// SuperTagEditorDoc.cpp : CSuperTagEditorDoc NX̓̒`s܂B
//

#include "stdafx.h"
#include "Shlwapi.h"
#include "FileMP3.h"
#include "SuperTagEditor.h"
#include "DlgCommonProg.h"
#include "DlgEnvSheet.h"
#include "SHBrowseForFolder.h"
#include "SuperTagEditorView.h"
#include "SuperTagEditorDoc.h"
#include "DlgPluginSetup.h"

#include "INI/Profile.h"

//#include "NewAPIs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//////////////////////////////////////////////////////////////////////////////
//GetLongPathName
//Zt@C𒷂t@Cɕϊ
//////////////////////////////////////////////////////////////////////////////
/*
F
    LPSTR lpszLongFileName  t@C󂯎obt@ւ̃|C^
    LPSTR lpszShortPathName Zt@C܂ރpXւ̃|C^
    DWORD dwSize            obt@TCY
߂l:
    DWORD obt@ɃRs[̒
        ÔƂُI
*/
DWORD GetLongPathName(LPSTR lpszLongFileName, LPSTR lpszShortPathName, DWORD dwSize)
{
	WIN32_FIND_DATA fd;
	HANDLE	hFind;

	//Zt@CŃt@C
	if((hFind = FindFirstFile(lpszShortPathName,&fd)) != INVALID_HANDLE_VALUE) {
		FindClose(hFind);
		if((DWORD)lstrlen(fd.cFileName) <= dwSize) {
			//t@Cobt@ɃRs[
			lstrcpy(lpszLongFileName,fd.cFileName);
			//obt@ɃRs[Ԃ
			return lstrlen(lpszLongFileName);
		}
	}
	lstrcpy(lpszLongFileName, "");
	//obt@̃TCY𒴂t@CȂƂُ͈I
	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CSuperTagEditorDoc

IMPLEMENT_DYNCREATE(CSuperTagEditorDoc, CDocument)

BEGIN_MESSAGE_MAP(CSuperTagEditorDoc, CDocument)
	//{{AFX_MSG_MAP(CSuperTagEditorDoc)
	ON_UPDATE_COMMAND_UI(ID_OPEN_FOLDER, OnUpdateOpenFolder)
	ON_COMMAND(ID_OPEN_FOLDER, OnOpenFolder)
	ON_UPDATE_COMMAND_UI(ID_SAVE_ALL_TAG, OnUpdateSaveAllTag)
	ON_COMMAND(ID_SAVE_ALL_TAG, OnSaveAllTag)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	ON_UPDATE_COMMAND_UI(ID_EDIT_FIELD_SI, OnUpdateEditFieldSi)
	ON_COMMAND(ID_EDIT_FIELD_SI, OnEditFieldSi)
	ON_UPDATE_COMMAND_UI(ID_EDIT_TD3_TAG, OnUpdateEditTd3Tag)
	ON_COMMAND(ID_EDIT_TD3_TAG, OnEditTd3Tag)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CHANGE_FIELD, OnUpdateEditChangeField)
	ON_COMMAND(ID_EDIT_CHANGE_FIELD, OnEditChangeField)
	ON_UPDATE_COMMAND_UI(ID_EXEC_CLASSIFICATION, OnUpdateExecClassification)
	ON_COMMAND(ID_EXEC_CLASSIFICATION, OnExecClassification)
	ON_COMMAND(ID_DLG_SETUP_PLUGIN, OnDlgSetupPlugin)
	ON_UPDATE_COMMAND_UI(ID_DLG_SETUP_PLUGIN, OnUpdateDlgSetupPlugin)
	ON_COMMAND(ID_DLG_ENVIRONMENT, OnDlgEnvironment)
	ON_UPDATE_COMMAND_UI(ID_DLG_ENVIRONMENT, OnUpdateDlgEnvironment)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSuperTagEditorDoc NX̍\z/

CSuperTagEditorDoc::CSuperTagEditorDoc()
{
	// TODO: ̈ʒuɂPxĂ΂\zp̃R[hǉĂB
	m_dlgLoadProgress = new CDlgCommonProgress;
	m_nArrayFileCount = 0;
	m_nArrayRequestFileCount = 0;

	m_StartLoadFileCount = 0;//ǉ by Kobarin
	m_TagUpdatingCount = 0;//ǉ by Kobarin

	m_bInitialized = false; /* StartInaction2 055 */
}

CSuperTagEditorDoc::~CSuperTagEditorDoc()
{
	delete	m_dlgLoadProgress;
	m_dlgLoadProgress = NULL;
}

BOOL CSuperTagEditorDoc::OnNewDocument()
{
	// ۑmF
	if (m_nArrayFileCount && CanCloseFrame((CFrameWnd *)AfxGetMainWnd()) == FALSE) {
		return FALSE;
	}

	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B)

	InitFileList();			// t@CXg̏
	ClearRequestFiles();	// ǉNGXgt@CXg̏


	if (!m_bInitialized) {
		InitPlugin();			// vOC̃[h

		// 
		GetView()->m_List.InitializeGrid();
		// tHg̐ݒ
		GetView()->UpdateFontListView();
	}
	InitGridList();			// Obh

	m_bInitialized = true;

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CSuperTagEditorDoc VAC[[V

void CSuperTagEditorDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring()) {
	} else {
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSuperTagEditorDoc NX̐ff

#ifdef _DEBUG
void CSuperTagEditorDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSuperTagEditorDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSuperTagEditorDoc R}h
//****************************************************************************
//                              t@C֘A
//****************************************************************************
// =============================================
// CSuperTagEditorDoc::GetFileTime
// Tv  : t@C̃^CX^v擾
//   : sFileName	= t@C
// ߂l: CTime		= ^CX^v(CTime(0):G[)
// =============================================
CTime CSuperTagEditorDoc::GetFileTime(const char *sFileName)
{
	CFileStatus	status;
	if (sFileName == NULL
	||  CFile::GetStatus(sFileName, status) == FALSE) {
		return(CTime(0));
	}
	if (status.m_mtime == -1) return(CTime(0));
	if (status.m_mtime.GetTime() == -1) return(CTime(0));
	return(status.m_mtime);
}

// =============================================
// CSuperTagEditorDoc::AddRequestFile
// Tv  : t@CǉNGXgXgɃt@Cǉ
//   : sFillPath		= tpX
//       : pParent			= eACe(NULL)
// ߂l: int				= CfbNX(ǉȂꍇ-1Ԃ)
// =============================================
int CSuperTagEditorDoc::AddRequestFile(const char *sFillPath, CSuperGridCtrl::CTreeItem *pParent)
{
	//ǉ by Kobarin
	if(IsTagUpdating())//^OXV͒ǉȂ
		return -1;
	if(m_dlgLoadProgress->IsCanceled()){
		//LZ{^Ă
		return -1;
	}

	FILE_STATE	stat;
	stat.strFullPathName = sFillPath;
	stat.pParent = pParent;
	// zɒǉ
	if (m_nArrayRequestFileCount > m_arrayRequestFiles.GetUpperBound()) {
		// z񂪑Ȃꍇ́AmۃTCY𑝉
		m_arrayRequestFiles.SetSize(m_arrayRequestFiles.GetUpperBound() + ADD_ARRAY_SIZE);
	}

	m_arrayRequestFiles[m_nArrayRequestFileCount] = stat;
	m_nArrayRequestFileCount++;
	return(m_nArrayRequestFileCount);
}

void CSuperTagEditorDoc::StartLoadFile(const char *sTitle)
{
	if (m_dlgLoadProgress->GetSafeHwnd() == NULL) {
		// vOXo[𐶐
//		m_dlgLoadProgress = new CDlgCommonProgress;
		m_dlgLoadProgress->Create(AfxGetMainWnd());
		m_dlgLoadProgress->SetWindowText(sTitle);
		UpdateAllViews(NULL);
	}
	m_dlgLoadProgress->SetDlgItemText(IDC_ST_MESSAGE, "t@C...");
    m_StartLoadFileCount++;//ǉ by Kobarin
}

void CSuperTagEditorDoc::EndLoadFile(void)
{
	if(--m_StartLoadFileCount != 0)return;//ǉ by Kobarin
	if (m_dlgLoadProgress->GetSafeHwnd() != NULL) {
		m_dlgLoadProgress->DestroyWindow();
		m_dlgLoadProgress->SetCanceled(FALSE);//ǉ by Kobarin
//		delete	m_dlgLoadProgress;
//		m_dlgLoadProgress = NULL;
	}
}

// =============================================
// CSuperTagEditorDoc::ExecRequestFiles
// Tv  : ǉNGXgXg̃t@C
//   : bListClear		= ǉIɒǉNGXg̃XgNA邩H
//       : bCheck			= `FbN}[Nt邩ǂ
// ߂l: none
// =============================================
void CSuperTagEditorDoc::ExecRequestFiles(bool bListClear, bool bCheck)
{
	m_dlgLoadProgress->SetDlgItemText(IDC_ST_MESSAGE, "^O̓ǂݍݒ...");

//	CMySuperGrid	&listCtrl = GetListCtrl();
//	listCtrl.SetRedraw(FALSE);

	//int		nFileCount = m_nArrayFileCount; /* STEP 015 */
	for (int no = 0; no < m_nArrayRequestFileCount; no++) {
		int		nFileCount = m_nArrayFileCount; /* STEP 015 */
		// vOXo[XV
		if (m_nArrayRequestFileCount > 1) {
			m_dlgLoadProgress->SetPos(no * 100 / (m_nArrayRequestFileCount-1));
		}
		// ǉ by Kobarin
		if(m_dlgLoadProgress->IsCanceled()){
			//LZ{^Ă
			break;
		}

		// do^`FbN
		if (nFileCount > 0) {
			bool	bFound = false;
			CString	*strFileName = &m_arrayRequestFiles[no].strFullPathName;
			int i; for (i = 0; i < nFileCount; i++) {
				if (GetListMP3(i)->strFullPathName == *strFileName) {
					bFound = true;
					break;
				}
			}
			if (bFound == false) {
				// loRt@C̎擾
				FoundFile(*strFileName, m_arrayRequestFiles[no].pParent, bCheck);
			}
		} else {
			// loRt@C̎擾
			FoundFile(m_arrayRequestFiles[no].strFullPathName, m_arrayRequestFiles[no].pParent, bCheck);
		}

	}

//	listCtrl.SetRedraw(TRUE);

	if (bListClear) {
		ClearRequestFiles();
	}

	if (g_bOptShowTotalParent) {
		CMySuperGrid	&listCtrl = GetListCtrl();
		listCtrl.CalcSum(0);
	}

	// J̎
	if (g_bOptLoadFileAdjustColumn) {
		CMySuperGrid	&listCtrl = GetListCtrl();
		listCtrl.AutoSizeColumns(-1);
	}
}

// =============================================
// CSuperTagEditorDoc::ClearRequestFiles
// Tv  : ǉNGXgt@CXg̏
//   : none
// ߂l: none
// =============================================
void CSuperTagEditorDoc::ClearRequestFiles(void)
{
	m_arrayRequestFiles.RemoveAll();
	m_arrayRequestFiles.SetSize(INIT_ARRAY_SIZE);
	m_nArrayRequestFileCount = 0;
}

// =============================================
// CSuperTagEditorDoc::LoadPlayList
// Tv  : vCXgǂ݂݂܂
//   : sPlayList	= vCXgt@C(΃pXŎw)
// ߂l: bool			= true:I / false:G[
// =============================================
bool CSuperTagEditorDoc::LoadPlayList(const char *sPlayList)
{
	TRY {
		CFile	file;

		// vCXgt@C̃JgfBNg擾
		TCHAR	drive[_MAX_DRIVE], dir[_MAX_DIR];
		_tsplitpath(sPlayList, drive, dir, NULL, NULL);

		if (file.Open(sPlayList, CFile::modeRead)) {
			CString		strLine;
			CArchive	ar(&file, CArchive::load);
			while(ar.ReadString(strLine)) {
				if (strLine.GetLength() >= 3) {
					if (strLine[0] != '#') {
						// Xgɒǉ
						if ((strLine[0] == '\\' && strLine[1] == '\\')
						||  strLine[1] == ':') {
							// ΃pX
							AddRequestFile(strLine, NULL);
						} else {
							// ΃pX
							CString	strName;
							if (strLine[0] == '\\') {
								// hCũ[gw
								strName.Format("%s%s", drive, strLine);
							} else {
								// [gȊO
								strName.Format("%s%s%s", drive, dir, strLine);
							}
							AddRequestFile(strName, NULL);
						}
					}
				}
			}
		}
	}
	CATCH( CFileException, e) {
		CString	str;
		str.Format("%s ̓ǂݍ݂Ɏs܂", sPlayList);
		MessageBox(NULL, str, "t@CG[", MB_ICONSTOP|MB_OK|MB_TOPMOST);
	}
	END_CATCH

	return(true);
}

// =============================================
// CSuperTagEditorDoc::FoundFile
// Tv  : t@CFt@C𔭌
//   : sFileName	= t@C
//       : pItemParent	= eACe(NULL=[g)
//       : bCheck		= `FbN}[Nt邩ǂ
// ߂l: bool			= true:I / false:ُI
// =============================================
bool CSuperTagEditorDoc::FoundFile(const char *sFileName, CSuperGridCtrl::CTreeItem *pItemParent, bool bCheck)
{
	// loRt@C̎擾
	CFileMP3	fileMP3;
	if (fileMP3.Attach(sFileName)) {
		int		nIndex = m_nArrayFileCount;

		// zɒǉ
		if (m_nArrayFileCount > m_arrayFiles.GetUpperBound()) {
			// z񂪑Ȃꍇ́AmۃTCY𑝉
			m_arrayFiles.SetSize(m_arrayFiles.GetUpperBound() + ADD_ARRAY_SIZE);
		}
		m_arrayFiles[m_nArrayFileCount] = fileMP3.m_fileMP3;
		m_nArrayFileCount++;

		// XgRg[擾
		CMySuperGrid	&listCtrl = GetListCtrl();
		if (g_classInfo.nType == 0) {
			// tH_ŕ
			listCtrl.AddFile(GetListMP3(nIndex), pItemParent, (LPARAM)nIndex, bCheck);
		} else {
			// ^Oŕ
			listCtrl.AddFile2(GetListMP3(nIndex), pItemParent, (LPARAM)nIndex, bCheck);
		}

		return(true);
	} else {
		CString	strMessage;
		strMessage.Format("%s ̓ǂݍ݂Ɏs܂", sFileName);
		//MessageBox(NULL, strMessage, "t@Cǂݍ݃G[", MB_ICONSTOP|MB_OK|MB_TOPMOST);
		((CMainFrame *)AfxGetMainWnd())->SetStatusBarText(strMessage);	// Xe[^Xo[ɃG[\
	}

	return(false);
}

// =============================================
// CSuperTagEditorDoc::SearchFileReent
// Tv  : t@CF
//   : sDir		= fBNg
//       : pItemDir	= fBNgACe(NULL=[g)
// ߂l: bool		= true:I / false:ُI
// =============================================
bool CSuperTagEditorDoc::SearchFileReent(const char *sDir, CSuperGridCtrl::CTreeItem *pItemDir)
{
	//ǉ by Kobarin
	if(m_dlgLoadProgress->IsCanceled()){
		return true;
	}

	HANDLE	hFindFile;
	WIN32_FIND_DATA	data;
	char	*sCurFile = new char [MAX_PATH + 1];

	if (sCurFile == NULL) return(false);	// 蓖Ďs

	// JnfBNg̏ꍇ̏
	if (pItemDir == NULL) {
		// [gɃfBNgACeǉ
		if (g_classInfo.nType == 0) {
			// tH_ŕ
			CMySuperGrid	&listCtrl = GetListCtrl();
//			pItemDir = listCtrl.AddDirectory(sDir, listCtrl.m_itemClassOK, 0);
			pItemDir = listCtrl.m_pItemRoot;
		}
	}

	// fBNg̑SẴt@C
	// TufBNǧ͍sȂ
	//static	char	*sFindPattern[] = {
	//	"*.rmp", "*.mp3", "*.ape", "*.wma", "*.wmv", "*.asf", "*.ogg"/* Conspiracy 196 */, "*.wav"/* Conspiracy 197 */, "*.avi"/* Conspiracy 197 */, NULL,
	//};
	extern void GetFileExtList(CStringArray& arExt);
	CStringArray arExt;
	GetFileExtList(arExt);
	for (int nType = 0; nType < arExt.GetSize() ; nType++) {
		// t@C̃p^[ݒ
		sprintf(sCurFile, "%s%s", sDir, "*." + arExt[nType]);

		// t@C
		if ((hFindFile = FindFirstFile(sCurFile, &data)) != INVALID_HANDLE_VALUE) {
			do {
				m_dlgLoadProgress->SetPos(0);//ǉ by Kobarin
				if(m_dlgLoadProgress->IsCanceled()){
					break;
				}
				if ((data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0) {
					// fBNgtt@C쐬
					strcpy(sCurFile, sDir);
					strcat(sCurFile, data.cFileName);
					m_sTargetFile = sCurFile;
					// t@C
					AddRequestFile(m_sTargetFile, pItemDir);
				}
			} while(FindNextFile(hFindFile, &data) == TRUE);
		}
		if (hFindFile != INVALID_HANDLE_VALUE) FindClose(hFindFile);
	}

	if (g_bEnableSearchSubDir) {	// TufBNǧ
		sprintf(sCurFile, "%s*.*", sDir);
		if ((hFindFile = FindFirstFile(sCurFile, &data)) != INVALID_HANDLE_VALUE) {
			do {
				m_dlgLoadProgress->SetPos(0);//ǉ by Kobarin
				if(m_dlgLoadProgress->IsCanceled()){
					break;
				}
				if ((data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0) {
					if (strcmp(data.cFileName, "." ) != 0		// JgfBNgȊO
					&&  strcmp(data.cFileName, "..") != 0		// efBNgȊO
					&& (data.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN) == 0/* STEP 032 */) { // BtH_ȊO
						// fBNgtt@C쐬
						strcpy(sCurFile, sDir);
						strcat(sCurFile, data.cFileName);
						m_sTargetFile = sCurFile;
						// c[ɃfBNgACeǉ
						CSuperGridCtrl::CTreeItem	*pItemSubDir = NULL;
						if (g_classInfo.nType == 0) {
							// tH_ŕ
							CMySuperGrid	&listCtrl = GetListCtrl();
							pItemSubDir = listCtrl.AddDirectory(data.cFileName, pItemDir);
						}
						// TufBNg˓
						strcat(sCurFile, "\\");
						if (!SearchFileReent(sCurFile, pItemSubDir)) {
							break;				// TufBNgG[
						}
						sCurFile[strlen(sCurFile)-1] = NULL;
						m_sTargetFile = sCurFile;	// TufBNg̏̂ōĐݒ
					}
				}
			} while(FindNextFile(hFindFile, &data) == TRUE);
		}
		if (hFindFile != INVALID_HANDLE_VALUE) FindClose(hFindFile); /* 2004.02.18 Ɉړ */
	}

	delete[] sCurFile;

	return(true);
}

// =============================================
// CSenkyokuMeijinDoc::SelectDirectory
// Tv  : tH_Qƃ_CAO
//   : sLocal			= pX(o)
// ߂l: bool
// =============================================
BOOL CSuperTagEditorDoc::SelectDirectory(char *sLocal)
{
	bool	bResult;
	CSHBrowseForFolder	browse(true, g_bEnableSearchSubDir);
	bResult = browse.Exec(sLocal);
	g_bEnableSearchSubDir = browse.GetSearchSubDirState();
	return(bResult);
}

void CSuperTagEditorDoc::OpenFolder(const char *sOpenDir)
{
	//ǉ by Kobarin
	if(IsTagUpdating())//^OXV͒ǉȂ
		return;
	if(m_dlgLoadProgress->IsCanceled()){
		//LZ{^Ă
		return ;
	}

	((CSuperTagEditorApp *)AfxGetApp())->AddToRecentFileList (sOpenDir); /* StartInaction 053 */

	// fBNg̃t@Cǂݍ
	char	sFolderName[_MAX_PATH] = {'\0'};

	strcpy(sFolderName, sOpenDir);

	int		nLen;
	nLen = strlen(sFolderName);
	if (nLen > 0) {
		if (IsFolderName(sFolderName) == false) {
			// Ō '\\' ł鎖
			strcat(sFolderName, "\\");
		}

		// vOXo[
		BOOL	bIsOpen = (m_dlgLoadProgress->GetSafeHwnd() == NULL) ? TRUE : FALSE;
		if (bIsOpen) StartLoadFile("loRt@Cǂݍݒ...");

		// tH_ǂݍ
		if (g_classInfo.nType == 0) {
			// tH_ŕ
			CMySuperGrid	&listCtrl = GetListCtrl();
			TCHAR	drive[_MAX_DRIVE], dir[_MAX_DIR];
			_tsplitpath(sFolderName, drive, dir, NULL, NULL);
			CString	str;
			str.Format("%s%s", drive, dir);
			SearchFileReent(sFolderName, listCtrl.AddDirectory(str, listCtrl.m_pItemRoot, 2));
		} else {
			// ^Oŕ
			SearchFileReent(sFolderName);
		}

		// ǉNGXĝt@C̃^Oǂݍ
#ifdef FLICKERFREE
		//CMySuperGrid	&listCtrl = GetListCtrl();
		//listCtrl.SetRedraw(FALSE);
		//GetView()->SetRedraw(FALSE);
#endif
		ExecRequestFiles(true, g_bOptLoadFileChecked);
#ifdef FLICKERFREE
		//listCtrl.SetRedraw(TRUE);
		//GetView()->SetRedraw(TRUE);
#endif

		// vOXo[I
		if (bIsOpen) EndLoadFile();

		UpdateAllViews(NULL);
	}
}

void CSuperTagEditorDoc::OnUpdateOpenFolder(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(TRUE);
}
void CSuperTagEditorDoc::OnOpenFolder()
{
	char	sFolderName[_MAX_PATH] = {'\0'};

	// tH_I_CAOJ
	strcpy(sFolderName, g_strCurrentDirectory);
	if (SelectDirectory(sFolderName) == TRUE) {
		g_strCurrentDirectory = sFolderName;

		OpenFolder(g_strCurrentDirectory);
	}
}

BOOL CSuperTagEditorDoc::CanCloseFrame(CFrameWnd* pFrame)
{
	if (CheckFileModified()) {
		int		nResult;
		nResult = MessageBox(AfxGetMainWnd()->GetSafeHwnd(), "^O񂪕ύXĂ܂B\n"
								   "ύXĂt@CXVĂ낵łH",
								   "ۑmF", MB_YESNOCANCEL);
		switch(nResult) {
		case IDYES:
			//OnSaveAllTag();
			SaveAllTag(TRUE);
			if (m_bSaveAllTagResult == false) {
				return(FALSE);
			}
			break;
		case IDNO:
			break;
		case IDCANCEL:
			return(FALSE);
		}
	}
	InitFileList(); /* Conspiracy 196 */
	return CDocument::CanCloseFrame(pFrame);
}

void CSuperTagEditorDoc::OnUpdateSaveAllTag(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(TRUE);
}

void CSuperTagEditorDoc::OnSaveAllTag()
{
	SaveAllTag(FALSE);
}

void CSuperTagEditorDoc::OnUpdateFileOpen(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(FALSE);
}

// [IvVݒ]-[S]
void CSuperTagEditorDoc::OnUpdateDlgEnvironment(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(TRUE);
}
void CSuperTagEditorDoc::OnDlgEnvironment()
{
	CDlgEnvSheet	dialog("IvVݒ");
	bool	bKeepTimeStamp = g_bOptKeepTimeStamp;
	bool	bHideMP3ListFile = g_bOptHideMP3ListFile;
	bool	bFileNameMaxCellColor = g_bFileNameMaxCellColor; /* SeaKnows 036 */

	dialog.m_pDoc = this;
	dialog.DoModal(CDlgEnvSheet::ENV_ALL);

	CMySuperGrid	&listCtrl = GetListCtrl();

	// ^CX^vێ̐ݒ荀ڂύXꂽ
	// MP3 List ̃t@C\̗LύXꂽ
	if (bKeepTimeStamp != g_bOptKeepTimeStamp
	||  bHideMP3ListFile != g_bOptHideMP3ListFile) {
		// \XV
		listCtrl.UpdateAllFiles();
		// J̎
		if (g_bOptLoadFileAdjustColumn) listCtrl.AutoSizeColumns(-1);
	}
	if (bFileNameMaxCellColor != g_bFileNameMaxCellColor) { /* SeaKnows 036 */
		// \XV
		listCtrl.UpdateAllFiles();
	}

	// ލς݃tH_̖̂XV
	listCtrl.UpdateSyncFolderItemName();

	// WXgXV
	listCtrl.MakeStrListGenre();
}

BOOL CSuperTagEditorDoc::OnOpenDocument(LPCTSTR lpszPathName)
{
//	if (!CDocument::OnOpenDocument(lpszPathName))
//		return FALSE;

	char	sFileName[FILENAME_MAX];
	strcpy(sFileName, lpszPathName);

	// 
	if (m_bInitialized == false) { /* StartInaction2 055 */
		InitFileList();			// t@CXg̏
		ClearRequestFiles();	// ǉNGXgt@CXg̏
		m_bInitialized = true;
		InitPlugin();			// vOC̃[h
		// 
		GetView()->m_List.InitializeGrid();
		// tHg̐ݒ
		GetView()->UpdateFontListView();
		InitGridList();			// Obh
	}

	// vCXgH
	CString	strFileName = sFileName;
	strFileName.MakeLower();
	if (strFileName.Find(".m3u") != -1) {
		// vCXgǉ
		GetView()->LoadPlayList(sFileName);
		return(TRUE);
	}

	// vOXo[
	StartLoadFile("loRt@Cǂݍݒ...");

	CFileStatus	status;
	if (CFile::GetStatus(sFileName, status) == TRUE && status.m_mtime != -1) {
		if (status.m_attribute & CFile::directory) {
			// fBNg̏ꍇ
			// Ō '\\' ͕Kv
			if (IsFolderName(sFileName) == false) {
				strcat(sFileName, "\\");
			}
			bool bEnableSearchSubDir = g_bEnableSearchSubDir; /* TyphoonSwell 026 */
			if (g_bOptDropSearchSubFolder) {
				g_bEnableSearchSubDir = true;
			}

			/* WildCherry2 078 */
			//SearchFileReent(sFileName);
			OpenFolder(sFileName);
			g_bEnableSearchSubDir = bEnableSearchSubDir;
		} else {
			// t@C̏ꍇ(Ot@CɕϊĂ珈)
			if (GetLongPathName(sFileName, status.m_szFullName, FILENAME_MAX) != 0) {
				CString	strLongFileName;
				TCHAR	drive[_MAX_DRIVE], dir[_MAX_DIR];
				_tsplitpath(status.m_szFullName, drive, dir, NULL, NULL);
				strLongFileName.Format("%s%s%s", drive, dir, sFileName);
				AddRequestFile(strLongFileName, NULL);
			}
		}
	} else if (strlen(sFileName) == 3 && sFileName[1] == ':' && sFileName[2] == '\\') { /* STEP 027 */
			// hCȕꍇ
			// ʊKw
			bool bEnableSearchSubDir = g_bEnableSearchSubDir;
			if (g_bOptDropSearchSubFolder) {
				g_bEnableSearchSubDir = true;
			}
			OpenFolder(sFileName);
			g_bEnableSearchSubDir = bEnableSearchSubDir;
	}

	// ǉNGXĝt@C̃^Oǂݍ
#ifdef FLICKERFREE
		//GetView()->SetRedraw(FALSE);
#endif
	ExecRequestFiles(true, g_bOptLoadFileChecked);
#ifdef FLICKERFREE
		//GetView()->SetRedraw(TRUE);
#endif

	// vOXo[I
	EndLoadFile();

	UpdateAllViews(NULL);

	return(TRUE);
}

// SI tB[h\^ҏW
void CSuperTagEditorDoc::OnUpdateEditFieldSi(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(TRUE);
	pCmdUI->SetCheck(g_bOptEditFieldSIF ? TRUE : FALSE);
}
void CSuperTagEditorDoc::OnEditFieldSi()
{
	if (g_bOptEditFieldSIF != true) {
		g_bOptEditFieldSIF = true;

		// XV
		UpdateAllFiles(true);
	}
}

// ID3 tag \^ҏW
void CSuperTagEditorDoc::OnUpdateEditTd3Tag(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(TRUE);
	pCmdUI->SetCheck(g_bOptEditFieldSIF ? FALSE : TRUE);
}
void CSuperTagEditorDoc::OnEditTd3Tag()
{
	if (g_bOptEditFieldSIF != false) {
		g_bOptEditFieldSIF = false;

		// XV
		UpdateAllFiles(true);
	}
}

// [ID3 tag] <=> [SItB[h]ؑ
void CSuperTagEditorDoc::OnUpdateEditChangeField(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(TRUE);
}
void CSuperTagEditorDoc::OnEditChangeField()
{
	g_bOptEditFieldSIF = g_bOptEditFieldSIF ? false : true;

	// XV
	UpdateAllFiles(true);
}

// ޕ\̍XV
void CSuperTagEditorDoc::OnUpdateExecClassification(CCmdUI* pCmdUI)
{
	pCmdUI->Enable((m_nArrayFileCount > 0 && g_classInfo.nType) ? TRUE : FALSE);
}
void CSuperTagEditorDoc::OnExecClassification()
{
	// vCXgǂ݂
	StartLoadFile("ޕ\XV...");
	m_dlgLoadProgress->SetDlgItemText(IDC_ST_MESSAGE, "...");
	m_dlgLoadProgress->EnableCancelButton(FALSE);

	// Obhɍēo^
	CMySuperGrid	&listCtrl = GetListCtrl();
	listCtrl.DeleteAllEx();			// Obh
	for (int no = 0; no < m_nArrayFileCount; no++) {
		// vOXo[XV
		if (m_nArrayFileCount > 1) {
			m_dlgLoadProgress->SetPos(no * 100 / (m_nArrayFileCount-1));
		}
		// tH_ŕ
		if (GetListMP3(no)->nFormat != FILE_FORMAT_UNKNOWN) {
			listCtrl.AddFile2(GetListMP3(no), NULL, (LPARAM)no, g_bOptLoadFileChecked);
		}
	}

	// t@C̃^Oǂݍ
	EndLoadFile();

	UpdateAllViews(NULL);
}

#include "DlgFileOverWrite.h"
bool CSuperTagEditorDoc::CheckFileAttribute(FILE_MP3 *fileMP3)
{
	extern	int		g_nWriteTagProcFlag;
	if (g_nWriteTagProcFlag == 3) {
		return(false);						// ȍ~~
	}

	// t@C擾
	CFileStatus	fileStatus;
	if (CFile::GetStatus(fileMP3->strFullPathName, fileStatus) == FALSE) {
		return(false);
	}
	// ǂݏopt@ĆA㏑mFs
	if (fileStatus.m_attribute & CFile::readOnly) {
		if (g_nWriteTagProcFlag != 1) {
			// ㏑mF_CAOJ
			CDlgFileOverWrite	dialog;
			dialog.m_strFileName = fileMP3->strFullPathName;
			dialog.m_strSize.Format("%ld byte", fileStatus.m_size);
			if (fileStatus.m_mtime.GetTime() < 0) {
				dialog.m_strTimeStamp.Format("----/--/-- --:--:--");
			} else {
				dialog.m_strTimeStamp.Format("%04d/%02d/%02d %02d:%02d:%02d",
											 fileStatus.m_mtime.GetYear(),
											 fileStatus.m_mtime.GetMonth(),
											 fileStatus.m_mtime.GetDay(),
											 fileStatus.m_mtime.GetHour(),
											 fileStatus.m_mtime.GetMinute(),
											 fileStatus.m_mtime.GetSecond());
			}
			dialog.DoModal();
			g_nWriteTagProcFlag = dialog.m_nResult;
			switch(dialog.m_nResult) {
			case 0:				// ̃t@C㏑
			case 1:				// ȍ~Sď㏑
				break;
			case 2:				// XLbv
			case 3:				// ~
			default:
				return(false);
			}
		}

		// ǂݍݐp
		SetFileAttributes(fileMP3->strFullPathName, CFile::normal);
	}
	return(true);
}

void CSuperTagEditorDoc::OnDlgSetupPlugin()
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CDlgPluginSetup	dialog;

	if (dialog.DoModal() == IDOK) {
		((CSuperTagEditorApp *)AfxGetApp())->UpdateAccelerator(); /* STEP 030 */
	}
}

void CSuperTagEditorDoc::OnUpdateDlgSetupPlugin(CCmdUI* pCmdUI)
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	pCmdUI->Enable(TRUE);
}

void CSuperTagEditorDoc::SaveAllTag(BOOL bSaveOnly)
{
	m_bSaveAllTagResult = true;
	extern	int		g_nWriteTagProcFlag;

	// vOXo[\
	StartLoadFile("^OXV...");
	m_dlgLoadProgress->SetDlgItemText(IDC_ST_MESSAGE, "...");

	// XVt@C̃^OXV
	g_nWriteTagProcFlag = 0;
	for (int no = 0; no < m_nArrayFileCount; no++) {
		FILE_MP3	*fileMP3 = GetListMP3(no);
		if (m_nArrayFileCount != 1) {
			// vOXo[XV
			m_dlgLoadProgress->SetPos(no * 100 / (m_nArrayFileCount-1));
			// ǉ by Kobarin
			if(m_dlgLoadProgress->IsCanceled()){
				m_bSaveAllTagResult = false;
				break;
			}
		}
		if (fileMP3->nFormat != FILE_FORMAT_UNKNOWN && fileMP3->bModifyFlag) {
			if (CFileMP3::WriteTag(fileMP3, g_bOptKeepTimeStamp)) {
				fileMP3->bModifyFlag = FALSE;
			} else {
				MessageBox(NULL, "^Ot@CXVł܂ł", fileMP3->strFullPathName, MB_ICONSTOP|MB_OK|MB_TOPMOST);
				m_bSaveAllTagResult = false;
			}
		}
	}

	// vOXo[I
	EndLoadFile();

	if (bSaveOnly)	return;

	// XV
	CMySuperGrid	&listCtrl = GetListCtrl();
#ifdef FLICKERFREE
	//listCtrl.SetRedraw(FALSE);
#endif
	listCtrl.UpdateAllFiles();
	UpdateAllFiles(true);
	if (g_bOptLoadFileAdjustColumn) listCtrl.AutoSizeColumns(-1); /* 2003.06.26 */
#ifdef FLICKERFREE
	//listCtrl.SetRedraw(TRUE);
#endif
}
