// MySuperGrid.cpp : implementation file
//

#include "stdafx.h"
#include "regexp.h"
#include "SuperTagEditor.h"
#include "SuperTagEditorDoc.h"
#include "SuperTagEditorView.h"
#include "DlgCommonProg.h"
#include "SuperGridCtrl.h"
#include "MySuperGrid.h"
#include "ComboInListView.h"
#include "DlgFixedString.h"
#include "DoubleZeroString.h"
#include "DlgFileNameChange.h"
#include "DlgFileOverWrite.h"
#include "DlgFileOverWrite2.h"
#include "STEP_api.h"

#include "Registry.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/* ̂PoCgڂǂ̌ */
#ifndef iskanji
#define iskanji(c)		((c) >= 0x81 && (c) <= 0x9f || (c) >= 0xe0 && (c) <= 0xfc)
#endif

#define COLUMN_MIN			1

#define MINCOLWIDTH			24  /* or whatever */

const char	*g_sNameListDefault[] = {
	_T("w"),
	_T("Audio List"),
	_T("t@C"),
	_T("gbN"),
	_T("A[eBXg"),
	_T("Ao"),
	_T("TrackNo"),
	_T("DiskNo"),
	_T("N"),
	_T("W"),
	_T("Rg"),
	_T("쌠"),
	_T(""),
	_T("\[X"),
	_T("\tgEFA"),
	_T("L[[h"),
	_T("Zp"),
	_T("̎"),
	_T("R~bV"),
	_T("쎌"),
	_T("Ȏ"), /* Baja 154 */
	_T("Albm.A[eBXg"), /* Baja 154 */
	_T("Orig.A[eBXg"), /* Baja 154 */
	_T("URL"), /* Baja 154 */
	_T("GR[hl"), /* Baja 154 */
	_T("TCY"),
	_T("XV"),
	_T("pX"),
	_T("t"),
	_T("̎t@C"),
	_T("t@C̎"),
	_T("tH[}bg"), 	//_T("BitRate"), /* Conspiracy 198 */
	_T("̑"), /* Conspiracy 196 */
	_T("쐬"), /* 2003.06.19 add */
	NULL,
};

struct COLUMN_STATUS	g_columnStatus[COLUMN_MAX] = {
	{"TreeItem"  , TRUE ,  0, 128,   0, LVCFMT_LEFT },	// c[ACe(tpX)
	{"FileName"  , TRUE ,  1, 150,   0, LVCFMT_LEFT },	// t@C
	{"TrackName" , TRUE ,  2, 128,   0, LVCFMT_LEFT },	// Ȗ
	{"ArtistName", TRUE ,  3, 128,   0, LVCFMT_LEFT },	// A[eBXg
	{"AlbumName" , TRUE ,  4, 128,   0, LVCFMT_LEFT },	// Ao^i
	{"TrackNo"   , TRUE ,  5,  48,  48, LVCFMT_RIGHT},	// gbNԍ(ID3 tag v1.1̂)
	{"DiskNo"    , FALSE,  6,  48,  48, LVCFMT_RIGHT},	// fBXNԍ(ID3 tag v1.1̂)
	{"Year"      , TRUE ,  7,  48,  48, LVCFMT_LEFT },	// [XN
	{"Genre"     , TRUE ,  8, 128,   0, LVCFMT_LEFT },	// W
	{"Comment"   , TRUE ,  9, 128,   0, LVCFMT_LEFT },	// Rg
	{"Copyright" , FALSE, 10, 128,   0, LVCFMT_LEFT },	// 쌠
	{"Engineer"  , FALSE, 11, 128,   0, LVCFMT_LEFT },	// GWjA()
	{"Source"    , FALSE, 12, 128,   0, LVCFMT_LEFT },	// \[X
	{"Software"  , FALSE, 13, 128,   0, LVCFMT_LEFT },	// \tgEFA
	{"Keyword"   , FALSE, 14, 128,   0, LVCFMT_LEFT },	// L[[h
	{"Technician", FALSE, 15, 128,   0, LVCFMT_LEFT },	// Zp
	{"Lyric"     , FALSE, 16, 128,   0, LVCFMT_LEFT },	// ̎
	{"Commission", FALSE, 17, 128,   0, LVCFMT_LEFT },	// R~bV
	{"Writer"    , FALSE, 18, 128,   0, LVCFMT_LEFT },	// 쎌
	{"Composer"  , FALSE, 19, 128,   0, LVCFMT_LEFT },	//  /* Baja 154 */
	{"AlbmArtist", FALSE, 20, 128,   0, LVCFMT_LEFT },	// Albm.A[eBXg /* Baja 154 */
	{"OrigArtist", FALSE, 21, 128,   0, LVCFMT_LEFT },	// Orig.A[eBXg /* Baja 154 */
	{"URL"       , FALSE, 22, 128,   0, LVCFMT_LEFT },	// URL /* Baja 154 */
	{"Encodest"  , FALSE, 23, 128,   0, LVCFMT_LEFT },	// GR[hl/* Baja 154 */
	{"FileSize"  , TRUE , 24,  56,  56, LVCFMT_RIGHT},	// t@CTCY
	{"FileTime"  , FALSE, 25, 128, 128, LVCFMT_LEFT },	// t@CXV
	{"FilePath"  , TRUE , 26, 128, 128, LVCFMT_LEFT },	// t@CpX
	{"PlayTime"  , FALSE, 27, 128, 128, LVCFMT_LEFT },	// t
	{"LyricFile" , FALSE, 28, 128, 128, LVCFMT_LEFT },	// ̎t@C
	{"FileType"  , TRUE , 29, 128, 128, LVCFMT_LEFT },	// t@C̎
// 	{"BitRate"   , FALSE, 30, 128, 0, LVCFMT_LEFT },	// rbg[g /* Conspiracy 198 */
	{"Format"    , FALSE, 30, 128, 0, LVCFMT_LEFT },	// tH[}bg /* Conspiracy 198 */
	{"Other"     , FALSE, 31, 128, 128, LVCFMT_LEFT },	// ̑ /* Conspiracy 196 */
	{"FileCTime" , FALSE, 32, 128, 128, LVCFMT_LEFT },	// t@C쐬 /* 2003.06.19 add */
};

// J^Cv(^O) => Jԍ ւ̕ϊe[u(InitializeGrid() ō쐬)
int		g_nColumnNumberList[COLUMN_MAX];
// Jԍ => J^Cv(^O) ւ̕ϊe[uInitializeGrid() ō쐬
int		g_nColumnTypeList[COLUMN_MAX];

/*
c[ACe, t@C, Ȗ, A[eBXg, Ao, gbNԍ, [XN, W, Rg
쌠, GWjA(), \[X, \tgEFA, L[[h, Zp, ̎, R~bV
, Orig.A[eBXg, URL, GR[hl, t@CTCY, t@CXV, t@CpX, t
̎t@C, t@C̎, tH[}bg, ̑
*/
static	CONTROLTYPE	**g_nControlTypeTableSIF;
static	CONTROLTYPE	**g_nControlTypeTable = NULL;

// Ɓ̓vOCCӂ̃^C~OōXVł悤ɂ

// eڂ̍ő啶
static int **g_nColMaxSIF;
static int **g_nColMax;
const char ***g_sNameList;
static UINT nCurrentFormatOfHeader = FILE_TYPE_UNKNOWN;
static bool bCurrentFormatOfHeaderIsDefault = true;

// strcnv.cpp ̐錾
enum	{CONV_SUJI=1, CONV_ALPHA=2, CONV_KATA=4, CONV_KIGOU=8, CONV_ALL=15};
extern "C" {
extern	int conv_han2zens(unsigned char *, const unsigned char *, int);
extern	int conv_zen2hans(unsigned char *, const unsigned char *, int);
extern	void conv_kata2hira(unsigned char *);
extern	void conv_kata_erase_dakuon(unsigned char *);
extern	void conv_hira2kata(unsigned char *);
extern	void conv_upper(unsigned char *);
extern	void conv_lower(unsigned char *);
extern	void conv_first_upper(unsigned char *, const char *, const char *, bool);

//extern	DWORD conv_kan2hira(HWND, unsigned char *, DWORD);
//extern	void conv_romaji(HWND hwnd, unsigned char *str, unsigned char *sRomaji);
}

extern	void conv_fixed_upper_lower(unsigned char *, CStringArray&); /* STEP 040 */

UINT STEClipbordFormat; /* Misirlou 146 */

/////////////////////////////////////////////////////////////////////////////
// CMySuperGrid
static char *GetToken(char *buffer, char *sToken)
{
	static char *pBuffer = NULL;

	if (buffer != NULL) pBuffer = buffer;
	if (pBuffer == NULL) return(NULL);
	if (*pBuffer == '\0') return(NULL);

	// 
	char *pNow = pBuffer;
	pBuffer = strstr(pBuffer, sToken);
	if (pBuffer != NULL) {
		*pBuffer = '\0';
		pBuffer++;
	}
	return(pNow);
}

static char *GetTokenQuote(char *buffer, char *sToken)
{
	static char *pBuffer = NULL;

	if (buffer != NULL) pBuffer = buffer;
	if (pBuffer == NULL) return(NULL);
	if (*pBuffer == '\0') return(NULL);

	// 
	char *pNow = pBuffer;
	if (*pNow == '"') {
		int nPos = 1;
		while (1) {
			// ̍sZ̃f[^Ȃ̂ŁAI " T
			while(pBuffer[nPos] != '\t' && pBuffer[nPos] != '\r' && pBuffer[nPos] != '\0') {
				nPos++;
			}
			if (pBuffer[nPos-1] == '"') {
				break;
			}
			nPos++;
		}
		nPos--;
		pBuffer += nPos;
		*pBuffer = '\0';
		pBuffer++;
	} else {
		pBuffer = strstr(pBuffer, sToken);
		if (pBuffer != NULL) {
			*pBuffer = '\0';
			pBuffer++;
		}
	}
	return(pNow);
}

static CString StrReplace(CString &strOrg, const char *sKey, const char *sRep)
{
	CString	strWork;
	int		nPos;

	strWork = strOrg;
	while((nPos = strWork.Find(sKey)) != -1) {
		int		nLenOrg = strWork.GetLength();
		int		nLenKey = strlen(sKey);
		strWork.Format("%s%s%s", strWork.Left(nPos), sRep, strWork.Right(nLenOrg-(nPos+nLenKey)));
	}
	// R[hXy[XɒuȂ /* SeaKnows2 040 */
	return(strWork);
}
static CString StrReplaceEx(CString &strOrg, const char *sKey, const char *sRep, bool bIsHtml)
{
	if (bIsHtml && strlen(sRep) == 0) sRep = "@";
	/* BeachMonster 119 *///if (bIsHtml)  return(StrReplace(StrReplace(strOrg, sKey, sRep), "\r\n", "<BR>")); /* BeachMonster 089 */
	return(StrReplace(strOrg, sKey, sRep));
}

static	CString	ConvFileName(CString strFullPath, CString strBaseDir)
{
	CString	strBuffer;
	if (strnicmp(strFullPath, strBaseDir, strBaseDir.GetLength()) == 0) {
		// ΃pXɕϊ\(pXv)
		strBuffer.Format("%s", strFullPath.Right(strFullPath.GetLength()-strBaseDir.GetLength()));
	} else if (strFullPath[1] == ':' && strnicmp(strFullPath, strBaseDir, 1) == 0) {
		// ΃pXɕϊ\(hCuꏏ)
		strBuffer.Format("%s", strFullPath.Right(strFullPath.GetLength()-2));
	} else {
		// ΃pXɕϊs\
		strBuffer.Format("%s", strFullPath);
	}
	return(strBuffer);
}


// =============================================
//  CharComp
//  Tv  : Pr֐
//    : sSrc		= r
//        : sDest		= r敶
//        : bDiffFlag	= 啶^ʃtO
//  ߂l: BOOL		= TRUE:I / FALSE:G[
// =============================================
static	BOOL CharComp(LPCSTR sSrc, LPCSTR sDest, BOOL bDiffFlag)
{
	BOOL	bIsKanjiSrc = iskanji(*sSrc) ? TRUE : FALSE;
	BOOL	bIsKanjiDest = iskanji(*sDest) ? TRUE : FALSE;
	if (bIsKanjiSrc == bIsKanjiDest) {
		if (bIsKanjiSrc) {			// 
			if (sSrc[0] == sDest[0]
			&&  sSrc[1] == sDest[1]) {
				return(TRUE);
			}
		} else {					// ASCII
			if (bDiffFlag) {
				// 啶^
				if (*sSrc == *sDest) return(TRUE);
			} else {
				// 啶^𓯈ꎋ
				if (toupper(*sSrc) == toupper(*sDest)) return(TRUE);
			}
		}
	}
	return(FALSE);
}

// =============================================
//  StringComp
//  Tv  : r֐(QoCgΉ)
//    : sSrc		= r
//        : sDest		= r敶
//        : nDestLen	= 
//        : bDiffFlag	= 啶^ʃtO
//  ߂l: BOOL		= TRUE:I / FALSE:G[
// =============================================
static	BOOL StringComp(LPCSTR sSrc, LPCSTR sDest, int nDestLen, BOOL bDiffFlag)
{
	int		nSrcLen = strlen(sSrc);
	if (nSrcLen >= nDestLen) {
		while(*sDest != '\0') {
			if (CharComp(sSrc, sDest, bDiffFlag) == FALSE) break;
			if (iskanji(*sDest)) {
				sSrc += 2;
				sDest += 2;
			} else {
				sSrc++;
				sDest++;
			}
		}
		if (*sDest == '\0') return(TRUE);
	}
	return(FALSE);
}

// =============================================
//  ConvNumber
//  Tv  : R̃J}؂ɕϊ
//    : strNum		= ()
//  ߂l: 			= ϊ̕
// =============================================
CString	ConvNumber(CString strNum)
{
	int		nCount = 1;
	while(strNum.GetLength() >= nCount * 4) {
		strNum = strNum.Left(strNum.GetLength() - (nCount * 4 - 1))
		       + CString(',')
		       + strNum.Right(nCount * 4 - 1);
		nCount++;
	}
	return(strNum);
}

// =============================================
//  GetFileType
//  Tv  : t@C^Cv擾
//    : fileMP3		= t@C
//  ߂l: CString		= t@C^Cv
// =============================================
static CString GetFileType(const FILE_MP3 *fileMP3)
{
	if ( fileMP3->strFileTypeName.IsEmpty()) {
		return("Unknown");
	}
	return fileMP3->strFileTypeName;
}

// =============================================
//  CMySuperGrid::CMySuperGrid
//  Tv  : RXgN^
//    : Ȃ
//  ߂l: Ȃ
// =============================================
CMySuperGrid::CMySuperGrid()
{
	m_bDrag = TRUE;
	m_pDoc = NULL;

	// WXg̍쐬
	MakeStrListGenre();

	m_bSortAscending = TRUE;
	m_nSortedCol = -1;

	m_rootItemFont = NULL;

	STEClipbordFormat = RegisterClipboardFormat(PROG_NAME/* ""*/); /* Misirlou 146 */
}

// =============================================
//  CMySuperGrid::~CMySuperGrid
//  Tv  : fXgN^
//    : Ȃ
//  ߂l: Ȃ
// =============================================
CMySuperGrid::~CMySuperGrid()
{
	if (m_rootItemFont != NULL) {
		m_rootItemFont->Detach();
		delete m_rootItemFont;
		m_rootItemFont = NULL;
	}
	{
		extern UINT GetFileTypeCount();
		int nFileTypeCount = GetFileTypeCount() + 1;
		int i; for (int i=0;i<nFileTypeCount;i++) {
			delete g_nControlTypeTable[i];
			delete g_nControlTypeTableSIF[i];
			delete g_nColMax[i];
			delete g_nColMaxSIF[i];
			if (i > 0 && g_sNameList[i] != NULL) {
				delete g_sNameList[i];
			}
		}
		delete [] g_nControlTypeTable;
		delete [] g_nControlTypeTableSIF;
		delete [] g_nColMax;
		delete [] g_nColMaxSIF;
		delete [] g_sNameList;
	}
}

#define CListCtrl		CSuperGridCtrl
BEGIN_MESSAGE_MAP(CMySuperGrid, CListCtrl)
	ON_WM_CONTEXTMENU()
	//{{AFX_MSG_MAP(CMySuperGrid)
	ON_WM_CREATE()
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
	ON_NOTIFY_REFLECT(LVN_ITEMCHANGED, OnItemChanged)
	ON_WM_KILLFOCUS()
	ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_SETFONT, OnSetFont)
	ON_WM_MEASUREITEM_REFLECT( )
    ON_NOTIFY_EX(TTN_NEEDTEXT, 0, OnToolTipNotify)
END_MESSAGE_MAP()
#undef CListCtrl

/////////////////////////////////////////////////////////////////////////////
// CMySuperGrid message handlers
CImageList g_imageCheckMark;//Must provide an imagelist

int CMySuperGrid::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CSuperGridCtrl::OnCreate(lpCreateStruct) == -1)
		return -1;
	/////////////////////
	//remember this
	///////////////////

	//associate imagelist with listviewctrl,
	//this imagelist is only for the first column re: the tree column
	if(!m_image.Create(IDB_BITMAP_TREE,16,1,RGB(255, 0, 255)))
		return -1;

	SetImageList(&m_image, LVSIL_SMALL);
	CImageList *pImageList = GetImageList(LVSIL_SMALL);
	if(pImageList)
		ImageList_GetIconSize(pImageList->m_hImageList, &m_cxImage, &m_cyImage);
	else
		return -1;
	extern CImageList* STEP_ImageList;
	STEP_ImageList = &m_image;


	// `FbN}[NpC[WXg
	// if(!m_imageCheck.Create(IDB_BITMAP_CHECK,16,1,RGB(255, 0, 255)))
	// 	return -1;
	// SetImageList(&m_imageCheck, LVSIL_STATE);
	g_imageCheckMark.Create(IDB_BITMAP_CHECK,16,1,RGB(255, 0, 255));

	//If you want to assiciate images to subitems, create an imagelist
	//and call SetSubItemImageList
	//now the next time you want to map an image from this imagelist to a
	//particular subitem call SetSubItemText(col,text,image-index);
//	CImageList imageSubItem;
//	if(!imageSubItem.Create(IDB_SUBITEMS,16,1,RGB(0, 255, 255)))
//		return -1;
//
//	if(!SetSubItemImageList(&imageSubItem))
//		return -1;

	return 0;
}



//helper function to copy CItemInfo used when drag/drop you must override this this function to suit your own CItemInfo class
CItemInfo* CMySuperGrid::CopyData(CItemInfo* lpSrc)
{
	ASSERT(lpSrc!=NULL);
	CItemInfo* lpDest = new CItemInfo;
	//well okay I put all the copy thing in one function, located in CItemInfo class,
	//so you should check out this function, remember to modify this function each time you add new data to CItemInfo class.
	lpDest->CopyObjects(lpSrc);
	return lpDest;
}


BOOL CMySuperGrid::OnItemLButtonDown(LVHITTESTINFO& ht)
{
	return 1;
}

//override called when OnLButtondown
bool CMySuperGrid::OnControlLButtonDown(UINT nFlags, CPoint point, LVHITTESTINFO& ht)
{
	//now I am sure I added a combobox some where, so check for this control
	CTreeItem*pSelItem = GetTreeItem(ht.iItem);
	if(pSelItem != NULL) {
		CItemInfo* pInfo = GetData(pSelItem);
		CONTROLTYPE ctrlType;
		if(pInfo->GetControlType(ht.iSubItem-1, ctrlType)) {
			if(ctrlType == combobox) {
				// []̕NbNꂽꍇ́AXgJ
				CRect rect;
				GetSubItemRect(ht.iItem, ht.iSubItem, LVIR_BOUNDS, rect);
				rect.left = rect.right - GetSystemMetrics(SM_CYVSCROLL);
				if (point.x >= rect.left && point.x <= rect.right) {
					CStringList *list = NULL;
					pInfo->GetListData(ht.iSubItem-1, list);
					CComboBox *pList = ShowList(ht.iItem, ht.iSubItem, list);
					return(true);
				}
			}
		}
	}
	return(false);
}


#define IDC_COMBOBOXINLISTVIEW 0x1235
CComboBox* CMySuperGrid::ShowList(int nItem, int nCol, CStringList *lstItems)
{
	CString strFind = GetItemText(nItem, nCol);

	//basic code start
	CRect rect;
	int offset = 0;
	// Make sure that the item is visible
	if( !EnsureVisible(nItem, TRUE)) return NULL;
	GetSubItemRect(nItem, nCol, LVIR_BOUNDS, rect);
	// Now scroll if we need to expose the column
	CRect rcClient;
	GetClientRect(rcClient);
	if( offset + rect.left < 0 || offset + rect.left > rcClient.right )
	{
		CSize size;
		size.cx = offset + rect.left;
		size.cy = 0;
		Scroll(size);
		rect.left -= size.cx;
	}

	rect.left += offset;
	rect.right = rect.left + GetColumnWidth(nCol);
	if(rect.right > rcClient.right)
	   rect.right = rcClient.right;
	//basic code end

	rect.bottom += 10 * rect.Height();	//dropdown area

	DWORD dwStyle =  WS_CHILD | WS_VISIBLE | WS_VSCROLL | /*WS_HSCROLL |*/ CBS_DROPDOWNLIST | CBS_DISABLENOSCROLL | CBS_SORT;
	CComboBox *pList = new CComboInListView(nItem, nCol, lstItems);
	pList->Create(dwStyle, rect, this, IDC_COMBOBOXINLISTVIEW);
	pList->ModifyStyleEx(0,WS_EX_CLIENTEDGE);//can we tell at all
	pList->SetHorizontalExtent(CalcHorzExtent(pList, lstItems));
	pList->ShowDropDown();
	pList->SelectString(-1, strFind.GetBuffer(1));
	// The returned pointer should not be saved
	return pList;
}



int CMySuperGrid::CalcHorzExtent(CWnd* pWnd, CStringList *pList)
{
	int nExtent=0;
	if(pWnd!=NULL)
	{
		CDC* pDC = pWnd->GetDC();
		HFONT hFont = (HFONT)pWnd->SendMessage(WM_GETFONT); //why not pWnd->GetFont();..I like the send thing alot and
		CFont *pFont = CFont::FromHandle(hFont);			//this way I get to use this function..cool :)
		if(pFont!=NULL)										//ya what ever makes me happy,.right :}
		{
			CFont* pOldFont = pDC->SelectObject(pFont);
			CSize newExtent;
			POSITION pos = pList->GetHeadPosition();
			while(pos != NULL)
			{
				CString str(pList->GetNext(pos));
				newExtent = pDC->GetTextExtent(str);
				newExtent.cx += 6;
				if (newExtent.cx > nExtent)
				{
					nExtent = newExtent.cx;
				}
			}
			pDC->SelectObject(pOldFont);
		}
		pWnd->ReleaseDC(pDC);
	}
	return nExtent;
}


BOOL CMySuperGrid::OnItemExpanding(CTreeItem *pItem, int iItem)
{
	return 1;
}


BOOL CMySuperGrid::OnItemExpanded(CTreeItem* pItem, int iItem)
{
	return 1;
}


BOOL CMySuperGrid::OnCollapsing(CTreeItem *pItem)
{
	return 1;
}



BOOL CMySuperGrid::OnItemCollapsed(CTreeItem *pItem)
{
	return 1;
}


CImageList *CMySuperGrid::CreateDragImageEx(int nItem)
{
		if(m_bDrag)
			return CSuperGridCtrl::CreateDragImageEx(GetDragItem());
		else
			return NULL;
}


void CMySuperGrid::SetNewImage(int nItem)
{
	CTreeItem*pItem = GetTreeItem(nItem);
	CItemInfo *lp = GetData(pItem);
	if(lp!=NULL)
	{
//		lp->SetSubItemImage(3/*subitem*/,4/*image index*/);
//		lp->SetSubItemImage(2/*subitem*/,4/*image index*/);
		//update internal node
		UpdateData(pItem, lp, TRUE);
		InvalidateItemRect(nItem);
	}
}

int CMySuperGrid::GetColumnCount(void) const
{
	// get the header control
	CHeaderCtrl* pHeader = (CHeaderCtrl*)GetDlgItem(0);
	// return the number of items in it - ie. the number of columns
	return pHeader->GetItemCount();
}

#define MAX(n1, n2)		(((n1) < (n2)) ? (n2) : (n1))
void CMySuperGrid::AutoSizeColumns(int col /*=-1*/)
{
	// Call this after your list control is filled
	SetRedraw(false);
	int mincol = col < 0 ? 0 : col;
	int maxcol = col < 0 ? GetColumnCount()-1 : col;
	for (col = mincol; col <= maxcol; col++) {
		if ((g_nColumnNumberList[COLUMN_TRACK_NUMBER] == col)|
			(g_nColumnNumberList[COLUMN_DISK_NUMBER] == col)) {
			SetColumnWidth(col, LVSCW_AUTOSIZE);
			int		wc = GetColumnWidth(col);
			int		wmax = g_columnStatus[g_nColumnTypeList[col]].nWidthMax;
			if (wmax > 0 && wc > wmax) wc = wmax;
			if (wc < MINCOLWIDTH) SetColumnWidth(col, MINCOLWIDTH);
/* 2003.06.19 start */
		} else if (g_nColumnNumberList[COLUMN_TREE_ITEM] == col && g_bAudioListShow && g_bOptHideMP3ListFile) {
			// AudioList Ƀt@C\Ȃނ͂ݏoĕ\ꍇA
			// ނlȂ(ACRE`FbN{bNX̃TCYjŃZTCY肷
			int indentmax = 0;
			int nItems = GetItemCount();
			for(int nItem=0; nItem < nItems; nItem++) {
				CTreeItem* pItem = GetTreeItem(nItem);
				int indent = GetIndent(pItem);
				if (indentmax < indent)	indentmax = indent;
				//if (!IsItemFile(pItem)) {
				//	InvalidateItemRectPtr(pItem); // ނĕ`
				//}
			}
			//extern	CImageList	g_imageCheckMark;
			//CImageList *pImageList = &g_imageCheckMark;
			int		cxIcon,cyIcon=0;
			ImageList_GetIconSize(g_imageCheckMark.m_hImageList, &cxIcon, &cyIcon);
			SetColumnWidth(col, indentmax * m_cxImage + m_cxImage + 2 + cxIcon);
			int		wc = GetColumnWidth(col);
			int		wmax = g_columnStatus[g_nColumnTypeList[col]].nWidthMax;
			if (wmax > 0 && wc > wmax) SetColumnWidth(col, wmax);
/* 2003.06.19 end */
		} else {
			SetColumnWidth(col, LVSCW_AUTOSIZE_USEHEADER);
			int		wc = GetColumnWidth(col);
			int		wmax = g_columnStatus[g_nColumnTypeList[col]].nWidthMax;
			if (wmax > 0 && wc > wmax) SetColumnWidth(col, wmax);
		}
	 }
	 // RecalcHeaderTips(); *** uncomment this if you use my header tips method
	 SetRedraw(true);
	 // Invalidate(); *** uncomment this if you don't use my SetRedraw function
}


void CMySuperGrid::DeleteAllEx(void)
{
	DeleteAll();

	m_bMultiSelect = false;

	// RootItem
	m_pItemRoot = AddDirectory("Root", NULL, 2);

	// RootItemtH_̖̂XV
	UpdateSyncFolderItemName();
	if (m_toolTip.GetSafeHwnd() == NULL) {
		m_toolTip.Create(GetParent());
		m_toolTip.AddTool(this, LPSTR_TEXTCALLBACK);
	}
}

void CMySuperGrid::UpdateCellInfo()
{
	int		i, j;
	extern UINT GetFileTypeCount();
	static int nFileTypeCount = 0;

	if (g_nControlTypeTable != NULL) {
		int i; for (int i=0;i<nFileTypeCount;i++) {
			delete g_nControlTypeTable[i];
			delete g_nControlTypeTableSIF[i];
			delete g_nColMax[i];
			delete g_nColMaxSIF[i];
			if (i > 0 && g_sNameList[i] != NULL) {
				delete g_sNameList[i];
			}
		}
		delete [] g_nControlTypeTable;
		delete [] g_nControlTypeTableSIF;
		delete [] g_nColMax;
		delete [] g_nColMaxSIF;
		delete [] g_sNameList;
	}
	nFileTypeCount = GetFileTypeCount() + 1;

	g_nControlTypeTable = new CONTROLTYPE*[nFileTypeCount];
	g_nControlTypeTableSIF = new CONTROLTYPE*[nFileTypeCount];
	g_nColMax = new int*[nFileTypeCount];
	g_nColMaxSIF = new int*[nFileTypeCount];
	g_sNameList = new const char**[nFileTypeCount];

	for (i=0;i<nFileTypeCount*2;i++) {
		CONTROLTYPE* controlTable = new CONTROLTYPE[COLUMN_MAX];
		int* colMax = new int[COLUMN_MAX];
		const char** nameList = new const char*[COLUMN_MAX];
		for (j=0;j<COLUMN_MAX;j++) {
			controlTable[j] = _NULL;
		}
		for (j=0;j<COLUMN_MAX;j++) {
			colMax[j] = 0;
		}
		for (j=0;j<COLUMN_MAX;j++) {
			nameList[j] = NULL;
		}
		controlTable[COLUMN_FILE_NAME] = _EDIT; // t@C͕ҏW
		colMax[COLUMN_FILE_NAME] = FILENAME_MAX;
		if (i == 0 || i == 1) {
			delete [] nameList;
			nameList = g_sNameListDefault;
		} else {
			extern UINT GetFormatType(UINT nIndex);
			extern CONTROLTYPE GetControlType(UINT nFormat, COLUMNTYPE nColumn, bool isEditSIF);
			extern int GetColumnMax(UINT nFormat, COLUMNTYPE nColumn, bool isEditSIF);
			extern LPCTSTR GetColumnName(UINT nFormat, COLUMNTYPE nColumn);
			UINT nFormat = GetFormatType(i/2-1);
			bool isEditSIF = i%2 == 0 ? true : false;
//			controlTable[COLUMN_FILE_NAME] = GetControlType(nFormat, COLUMN_FILE_NAME, isEditSIF);
			controlTable[COLUMN_TRACK_NAME] = GetControlType(nFormat, COLUMN_TRACK_NAME, isEditSIF);
			controlTable[COLUMN_ARTIST_NAME] = GetControlType(nFormat, COLUMN_ARTIST_NAME, isEditSIF);
			controlTable[COLUMN_ALBUM_NAME] = GetControlType(nFormat, COLUMN_ALBUM_NAME, isEditSIF);
			controlTable[COLUMN_TRACK_NUMBER] = GetControlType(nFormat, COLUMN_TRACK_NUMBER, isEditSIF);
			controlTable[COLUMN_DISK_NUMBER] = GetControlType(nFormat, COLUMN_DISK_NUMBER, isEditSIF);
			controlTable[COLUMN_YEAR]  = GetControlType(nFormat, COLUMN_YEAR, isEditSIF);
			controlTable[COLUMN_GENRE] = GetControlType(nFormat, COLUMN_GENRE, isEditSIF);
			controlTable[COLUMN_COMMENT] = GetControlType(nFormat, COLUMN_COMMENT, isEditSIF);
			controlTable[COLUMN_COPYRIGHT] = GetControlType(nFormat, COLUMN_COPYRIGHT, isEditSIF);
			controlTable[COLUMN_ENGINEER] = GetControlType(nFormat, COLUMN_ENGINEER, isEditSIF);
			controlTable[COLUMN_SOURCE] = GetControlType(nFormat, COLUMN_SOURCE, isEditSIF);
			controlTable[COLUMN_SOFTWARE] = GetControlType(nFormat, COLUMN_SOFTWARE, isEditSIF);
			controlTable[COLUMN_KEYWORD] = GetControlType(nFormat, COLUMN_KEYWORD, isEditSIF);
			controlTable[COLUMN_TECHNICIAN] = GetControlType(nFormat, COLUMN_TECHNICIAN, isEditSIF);
			controlTable[COLUMN_LYRIC] = GetControlType(nFormat, COLUMN_LYRIC, isEditSIF);
			controlTable[COLUMN_COMMISSION] = GetControlType(nFormat, COLUMN_COMMISSION, isEditSIF);
			controlTable[COLUMN_WRITER] = GetControlType(nFormat,COLUMN_WRITER,isEditSIF);
			controlTable[COLUMN_COMPOSER] = GetControlType(nFormat, COLUMN_COMPOSER, isEditSIF);
			controlTable[COLUMN_ALBM_ARTIST] = GetControlType(nFormat, COLUMN_ALBM_ARTIST, isEditSIF);
			controlTable[COLUMN_ORIG_ARTIST] = GetControlType(nFormat, COLUMN_ORIG_ARTIST, isEditSIF);
			controlTable[COLUMN_URL] = GetControlType(nFormat, COLUMN_URL, isEditSIF);
			controlTable[COLUMN_ENCODEST] = GetControlType(nFormat, COLUMN_ENCODEST, isEditSIF);
			controlTable[COLUMN_OTHER] = GetControlType(nFormat, COLUMN_OTHER, isEditSIF);
			/*
			controlTable[COLUMN_FILE_SIZE] = GetControlType(nFormat, COLUMN_FILE_SIZE, isEditSIF);
			controlTable[COLUMN_FILE_TIME] = GetControlType(nFormat, COLUMN_FILE_TIME, isEditSIF);
			controlTable[COLUMN_FILE_PATH] = GetControlType(nFormat, COLUMN_FILE_PATH, isEditSIF);
			controlTable[COLUMN_PLAY_TIME] = GetControlType(nFormat, COLUMN_PLAY_TIME, isEditSIF);
			controlTable[COLUMN_LYRIC_FILE] = GetControlType(nFormat, COLUMN_LYRIC_FILE, isEditSIF);
			controlTable[COLUMN_FILE_TYPE] = GetControlType(nFormat, COLUMN_FILE_TYPE, isEditSIF);
			controlTable[COLUMN_FORMAT] = GetControlType(nFormat, COLUMN_FORMAT, isEditSIF);
			*/

//			colMax[COLUMN_FILE_NAME] = GetColumnMax(nFormat, COLUMN_FILE_NAME, isEditSIF);
			colMax[COLUMN_TRACK_NAME] = GetColumnMax(nFormat, COLUMN_TRACK_NAME, isEditSIF);
			colMax[COLUMN_ARTIST_NAME] = GetColumnMax(nFormat, COLUMN_ARTIST_NAME, isEditSIF);
			colMax[COLUMN_ALBUM_NAME] = GetColumnMax(nFormat, COLUMN_ALBUM_NAME, isEditSIF);
			colMax[COLUMN_TRACK_NUMBER] = GetColumnMax(nFormat, COLUMN_TRACK_NUMBER, isEditSIF);
			colMax[COLUMN_DISK_NUMBER] = GetColumnMax(nFormat, COLUMN_DISK_NUMBER, isEditSIF);
			colMax[COLUMN_YEAR]  = GetColumnMax(nFormat, COLUMN_YEAR, isEditSIF);
			colMax[COLUMN_GENRE] = GetColumnMax(nFormat, COLUMN_GENRE, isEditSIF);
			colMax[COLUMN_COMMENT] = GetColumnMax(nFormat, COLUMN_COMMENT, isEditSIF);
			colMax[COLUMN_COPYRIGHT] = GetColumnMax(nFormat, COLUMN_COPYRIGHT, isEditSIF);
			colMax[COLUMN_ENGINEER] = GetColumnMax(nFormat, COLUMN_ENGINEER, isEditSIF);
			colMax[COLUMN_SOURCE] = GetColumnMax(nFormat, COLUMN_SOURCE, isEditSIF);
			colMax[COLUMN_SOFTWARE] = GetColumnMax(nFormat, COLUMN_SOFTWARE, isEditSIF);
			colMax[COLUMN_KEYWORD] = GetColumnMax(nFormat, COLUMN_KEYWORD, isEditSIF);
			colMax[COLUMN_TECHNICIAN] = GetColumnMax(nFormat, COLUMN_TECHNICIAN, isEditSIF);
			colMax[COLUMN_LYRIC] = GetColumnMax(nFormat, COLUMN_LYRIC, isEditSIF);
			colMax[COLUMN_COMMISSION] = GetColumnMax(nFormat, COLUMN_COMMISSION, isEditSIF);
			colMax[COLUMN_WRITER] = GetColumnMax(nFormat,COLUMN_WRITER,isEditSIF);
			colMax[COLUMN_COMPOSER] = GetColumnMax(nFormat, COLUMN_COMPOSER, isEditSIF);
			colMax[COLUMN_ALBM_ARTIST] = GetColumnMax(nFormat, COLUMN_ALBM_ARTIST, isEditSIF);
			colMax[COLUMN_ORIG_ARTIST] = GetColumnMax(nFormat, COLUMN_ORIG_ARTIST, isEditSIF);
			colMax[COLUMN_URL] = GetColumnMax(nFormat, COLUMN_URL, isEditSIF);
			colMax[COLUMN_ENCODEST] = GetColumnMax(nFormat, COLUMN_ENCODEST, isEditSIF);
			colMax[COLUMN_OTHER] = GetColumnMax(nFormat, COLUMN_OTHER, isEditSIF);
			/*
			colMax[COLUMN_FILE_SIZE] = GetColumnMax(nFormat, COLUMN_FILE_SIZE, isEditSIF);
			colMax[COLUMN_FILE_TIME] = GetColumnMax(nFormat, COLUMN_FILE_TIME, isEditSIF);
			colMax[COLUMN_FILE_PATH] = GetColumnMax(nFormat, COLUMN_FILE_PATH, isEditSIF);
			colMax[COLUMN_PLAY_TIME] = GetColumnMax(nFormat, COLUMN_PLAY_TIME, isEditSIF);
			colMax[COLUMN_LYRIC_FILE] = GetColumnMax(nFormat, COLUMN_LYRIC_FILE, isEditSIF);
			colMax[COLUMN_FILE_TYPE] = GetColumnMax(nFormat, COLUMN_FILE_TYPE, isEditSIF);
			colMax[COLUMN_FORMAT] = GetColumnMax(nFormat, COLUMN_FORMAT, isEditSIF);
			*/
			if (i%2 == 0) {
				extern bool HasOriginalColumnName(UINT nFormat);
				if (HasOriginalColumnName(nFormat) == true) {
					nameList[COLUMN_FILE_NAME] = GetColumnName(nFormat, COLUMN_FILE_NAME);
					nameList[COLUMN_TRACK_NAME] = GetColumnName(nFormat, COLUMN_TRACK_NAME);
					nameList[COLUMN_ARTIST_NAME] = GetColumnName(nFormat, COLUMN_ARTIST_NAME);
					nameList[COLUMN_ALBUM_NAME] = GetColumnName(nFormat, COLUMN_ALBUM_NAME);
					nameList[COLUMN_TRACK_NUMBER] = GetColumnName(nFormat, COLUMN_TRACK_NUMBER);
					nameList[COLUMN_DISK_NUMBER] = GetColumnName(nFormat, COLUMN_DISK_NUMBER);
					nameList[COLUMN_YEAR]  = GetColumnName(nFormat, COLUMN_YEAR);
					nameList[COLUMN_GENRE] = GetColumnName(nFormat, COLUMN_GENRE);
					nameList[COLUMN_COMMENT] = GetColumnName(nFormat, COLUMN_COMMENT);
					nameList[COLUMN_COPYRIGHT] = GetColumnName(nFormat, COLUMN_COPYRIGHT);
					nameList[COLUMN_ENGINEER] = GetColumnName(nFormat, COLUMN_ENGINEER);
					nameList[COLUMN_SOURCE] = GetColumnName(nFormat, COLUMN_SOURCE);
					nameList[COLUMN_SOFTWARE] = GetColumnName(nFormat, COLUMN_SOFTWARE);
					nameList[COLUMN_KEYWORD] = GetColumnName(nFormat, COLUMN_KEYWORD);
					nameList[COLUMN_TECHNICIAN] = GetColumnName(nFormat, COLUMN_TECHNICIAN);
					nameList[COLUMN_LYRIC] = GetColumnName(nFormat, COLUMN_LYRIC);
					nameList[COLUMN_COMMISSION] = GetColumnName(nFormat, COLUMN_COMMISSION);
					nameList[COLUMN_WRITER] = GetColumnName(nFormat,COLUMN_WRITER);
					nameList[COLUMN_COMPOSER] = GetColumnName(nFormat, COLUMN_COMPOSER);
					nameList[COLUMN_ALBM_ARTIST] = GetColumnName(nFormat, COLUMN_ALBM_ARTIST);
					nameList[COLUMN_ORIG_ARTIST] = GetColumnName(nFormat, COLUMN_ORIG_ARTIST);
					nameList[COLUMN_URL] = GetColumnName(nFormat, COLUMN_URL);
					nameList[COLUMN_ENCODEST] = GetColumnName(nFormat, COLUMN_ENCODEST);
					nameList[COLUMN_OTHER] = GetColumnName(nFormat, COLUMN_OTHER);
				} else {
					delete [] nameList;
					nameList = NULL;
				}
			} else {
				delete [] nameList;
				nameList = NULL;
			}
		}
		if (i%2 == 0) {
			g_nControlTypeTableSIF[i/2] = controlTable;
			g_nColMaxSIF[i/2] = colMax;
			g_sNameList[i/2] = nameList;
		} else {
			g_nControlTypeTable[i/2] = controlTable;
			g_nColMax[i/2] = colMax;
			//g_sNameList[i/2] = nameList;
		}
	}
}
// =============================================
// CMySuperGrid::InitializeGrid
// Tv  : Obh̏
//   : none
// ߂l: none
// =============================================
void CMySuperGrid::InitializeGrid()
{
	/*
	ExtendedStyle support:
	LVS_EX_TRACKSELECT
	LVS_EX_GRIDLINES
	LVS_EX_FLATSB
	LVS_EX_CHECKBOXES
	LVS_EX_FLATSB
	all other ExStyles are not supported...buhhh and you call your self a windows-developer :(
	*/
	SetExtendedStyle(LVS_EX_GRIDLINES | LVS_EX_CHECKBOXES);

	// ZWXgǂݏo
	CellStateControl(0);

	LV_COLUMN   lvColumn;
	//initialize the columns
	lvColumn.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;

	UpdateCellInfo();
	int		i, nColumn;


	// e[u -1 ŃNA
	for(nColumn = 0; nColumn < COLUMN_MAX; nColumn++) {
		g_nColumnNumberList[nColumn] = -1;
		g_nColumnTypeList[nColumn] = -1;
	}

	// Jԍ => J^Cv(^O) ւ̕ϊe[u쐬
	for (i = 0; i < COLUMN_MAX; i++) {
		struct COLUMN_STATUS	*Stat = &g_columnStatus[i];
		if (Stat->bShowFlag == TRUE) {
			g_nColumnTypeList[Stat->nNumber] = i;
		}
	}
	// \ݒŋ󂢂ĂƂl߂
	nColumn = 0;
	for (i = 0; i < COLUMN_MAX; i++) {
		if (g_nColumnTypeList[i] != -1) {
			if (i != nColumn) {
				int		nType = g_nColumnTypeList[i];
				g_nColumnTypeList[i] = -1;
				g_nColumnTypeList[nColumn] = nType;
			}
			nColumn++;
		}
	}

	// J^Cv(^O) => Jԍ ւ̕ϊe[u쐬
	for (nColumn = 0; nColumn < COLUMN_MAX; nColumn++) {
		int		nType = g_nColumnTypeList[nColumn];
		if (nType == -1) break;

		// CListCtrl ɃJǉ
		lvColumn.fmt		= g_columnStatus[nType].nFormat;
		lvColumn.pszText	= (LPTSTR)g_sNameList[0][nType+1];
		lvColumn.cx			= g_columnStatus[nType].nWidth;
		InsertColumn(nColumn, &lvColumn);

		g_nColumnNumberList[nType] = nColumn;
	}

	// ̎t@ČKvǂݒ
	g_bOptSearchLyricFile = g_columnStatus[COLUMN_LYRIC_FILE].bShowFlag ? true : false;

}

// =============================================
// CMySuperGrid::SetItemModifyFlag
// Tv  : ACe̕ύXtOݒ肷
//   : pItem		= ACe
//       : flag			= tO
// ߂l: none
// =============================================
void CMySuperGrid::SetItemModifyFlag(CTreeItem *pItem, bool flag)
{
	CItemInfo	*info = GetData(pItem);
	LPARAM		lParam = info->GetLParam();
	if (lParam >= 0) {
		FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)lParam);
		fileMP3->bModifyFlag = flag;
	}
}

// =============================================
// CMySuperGrid::GetItemModifyFlag
// Tv  : ACe̕ύXtO擾
//   : pItem		= ACe
// ߂l: bool			= tO
// =============================================
bool CMySuperGrid::GetItemModifyFlag(const CTreeItem *pItem)
{
	CItemInfo	*info = GetData(pItem);
	LPARAM		lParam = info->GetLParam();

	if (lParam < 0) return(false);

	FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)lParam);
	return(fileMP3->bModifyFlag);
}

// =============================================
// CMySuperGrid::GetItemFormat
// Tv  : ACẽt@C`擾
//   : pItem		= ACe
// ߂l: int			= `(FILE_FORMAT_xxxxxxx)
// =============================================
int CMySuperGrid::GetItemFormat(const CTreeItem *pItem)
{
	CItemInfo	*info = GetData(pItem);
	LPARAM		lParam = info->GetLParam();

	if (lParam < 0) return(FILE_FORMAT_UNKNOWN);

	FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)lParam);
	return(fileMP3->nFormat);
}

// =============================================
// CMySuperGrid::GetCellRGB
// Tv  : J[\ʒũZ̐F擾
//   : none
// ߂l: COLORREF		= F
// =============================================
COLORREF CMySuperGrid::GetCellRGB()
{
	COLORREF col = RGB(192, 0, 0);
//	int iItem = GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	int	iItem = GetSelectedItem();
	if (GetCurSubItem() != -1 && iItem != -1) {
		CTreeItem*pSelItem = GetTreeItem(iItem);
		if(pSelItem != NULL) {
			CHeaderCtrl* pHeader = (CHeaderCtrl*)GetDlgItem(0);
			int iSubItem = Header_OrderToIndex(pHeader->m_hWnd, GetCurSubItem());
			if (iSubItem == 0) {
				// [̃Z̏ꍇ
				col = RGB(192, 192, 192);
			} else {
				// ȊÕZ̏ꍇ
				CItemInfo* pInfo = GetData(pSelItem);
				CONTROLTYPE ctrlType;
				if (pInfo->GetControlType(iSubItem-1, ctrlType)) {
					if (ctrlType == invalid) {
						col = RGB(192, 192, 192);
					}
				}
			}
		}
	}
	return(col);
}

// =============================================
// CMySuperGrid::GetIcon
// Tv  : ACẽC[WACRԍ̎擾
//   : pItem		= ACe
// ߂l: int			= C[Wԍ
// =============================================
int CMySuperGrid::GetIcon(const CTreeItem* pItem)
{
	if (pItem != NULL) {
		int		n = GetData(pItem)->GetImage();
		if (n != -1) {
			CItemInfo	*pInfo = GetData(pItem);
			if (ItemHasChildren(pItem) || (int)pInfo->GetLParam() < 0) {
				// fBNg̏ꍇ
				return(IsCollapsed(pItem) ? n : n+1);
			}

			// t@C̏ꍇ
			extern int GetFileImageIndex(UINT nFormat, bool bModify);
			int nIndex = GetFileImageIndex(GetItemFormat(pItem), GetItemModifyFlag(pItem));
			if (nIndex == -1) {
				return(GetItemModifyFlag(pItem) ? 7 : 6);
			} else {
				return nIndex;
			}
		}
	}
	return 0;
}

// =============================================
// CMySuperGrid::OnUpdateListViewItem
// Tv  : ACef[^ύXꂽꍇ̏
//   : lpItem
//       : plvItem
// ߂l: none
// =============================================
void CMySuperGrid::OnUpdateListViewItem(CTreeItem* lpItem, LV_ITEM *plvItem)
{
	CItemInfo *lp = GetData(lpItem);
	CString str = (CString)plvItem->pszText;
	if (lp != NULL) {
		if(plvItem->iSubItem == 0) {
			lp->SetItemText(str);
			UpdateData(lpItem, lp);
			SetItemText(plvItem->iItem, plvItem->iSubItem, plvItem->pszText);
		} else {
			ChangeSubItemText(plvItem->iItem, plvItem->iSubItem, str);
		}
	}
}

// =============================================
// CMySuperGrid::ChangeSubItemText
// Tv  : Z̓eXV
//   : iItem		= ACe
//       : iSubItem		= TuACe
//       : sText		= ݒ肷镶
// ߂l: none
// =============================================
void CMySuperGrid::ChangeSubItemText(int iItem, int iSubItem, const char *sText)
{
	ChangeSubItemText(iItem, iSubItem, sText, 0);
}

// =============================================
// CMySuperGrid::ChangeSubItemText
// Tv  : Z̓eXV
//   : iItem		= ACe
//       : iSubItem		= TuACe
//       : sText		= ݒ肷镶
//       : nPos			= Zɒǉ 1:O 2: 0:u
// ߂l: none
// =============================================
void CMySuperGrid::ChangeSubItemText(int iItem, int iSubItem, const char *sUpdateText, int nPos)
{
	ChangeSubItemText(iItem, iSubItem, sUpdateText, nPos, false, "", "");
}


// =============================================
// CMySuperGrid::OnVkReturn
// Tv  : [Enter]ꂽꍇ̏(ҏWJn)
//   : none
// ߂l: BOOL
// =============================================
BOOL CMySuperGrid::OnVkReturn()
{
	BOOL bResult=FALSE;
	int iItem = GetNextItem( -1, LVNI_ALL | LVNI_SELECTED);
	if( GetCurSubItem() != -1 && iItem != -1)
	{
		CTreeItem *pSelItem = GetTreeItem(iItem);
		if(pSelItem!=NULL) {
			if (ItemHasChildren(pSelItem)) {
				// tH_̏ꍇ́A[Enter]тɃm[hJ^
				// JԂ
				SendMessage(WM_KEYDOWN, IsCollapsed(pSelItem) ? VK_ADD : VK_SUBTRACT, 0);
				return(TRUE);
			}

			CHeaderCtrl* pHeader = (CHeaderCtrl*)GetDlgItem(0);
			int iSubItem = Header_OrderToIndex(pHeader->m_hWnd, GetCurSubItem());
			if (iSubItem == 0) {
				// [̃Z̏ꍇ
				return(TRUE);
			} else {
				// ȊÕZ̏ꍇ
				CItemInfo* pInfo = GetData(pSelItem);
				CONTROLTYPE ctrlType;
				if (pInfo->GetControlType(iSubItem-1, ctrlType)) {
					switch(ctrlType) {
					/*put in your own control here*/
					case invalid:
						return(TRUE);
						break;
					case combobox:
						{
							CStringList *list = NULL;
							pInfo->GetListData(iSubItem-1, list);
							CComboBox * pList = ShowList(iItem, iSubItem, list);
							bResult = TRUE; //I'll handle it from here
						}
						break;
					default:
						break;
					}
				}
			}
		}
	}
	return bResult;
}

// =============================================
// CMySuperGrid::OnDeleteItem
// Tv  : [DELETE]ꂽꍇ̏
//   : pItem
//       : nIndex
// ߂l: BOOL
// =============================================
BOOL CMySuperGrid::OnDeleteItem(CTreeItem* pItem, int nIndex)
{
	// 폜֎~
	return(FALSE);
}

// =============================================
// CMySuperGrid::OnChangeSelect
// Tv  : IJ[\ʒuύXꂽ
//   : none
// ߂l: BOOL
// =============================================
BOOL CMySuperGrid::OnChangeSelect(void)
{
	// J[\ʒuXV
	UpdateStatusLocation();

	// Xe[^Xo[̃t@CXV
	CString	strText;
	int		iItem;
	if ((iItem = GetSelectedItem()) != -1) {
		CTreeItem	*pItem = GetTreeItem(iItem);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			CItemInfo	*pItemInfo = GetData(pItem);
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pItemInfo->GetLParam());
			strText = fileMP3->strFullPathName;
			// t@C^Cṽwb_[ɕύX
			extern bool HasOriginalColumnName(UINT nFormat);
			extern UINT GetFormatTypeIndex(UINT nFormat);
			if (nCurrentFormatOfHeader != (UINT)fileMP3->nFormat) {
				bool bOriginal = HasOriginalColumnName(fileMP3->nFormat);
				int nIndex = GetFormatTypeIndex(fileMP3->nFormat) + 1;
				if (g_sNameList[nIndex] == NULL)	bOriginal = false;
				if (bOriginal == false && bCurrentFormatOfHeaderIsDefault) {
				} else {
					for (int nColumn = 0; nColumn < COLUMN_MAX; nColumn++) {
						int		nType = g_nColumnTypeList[nColumn];
						if (nType == -1)	break;
						LVCOLUMN lvColumn;
						lvColumn.mask = LVCF_TEXT;
						if (bOriginal && g_sNameList[nIndex][nType] != NULL) {
							lvColumn.pszText = (LPTSTR)g_sNameList[nIndex][nType];
						} else {
							lvColumn.pszText = (LPTSTR)g_sNameList[0][nType+1]; /* ftHg̃J */
						}
						SetColumn(nColumn, &lvColumn);
						bCurrentFormatOfHeaderIsDefault = !bOriginal;
					}
				}
				nCurrentFormatOfHeader = fileMP3->nFormat;
			}
		} else if (pItem != NULL && IsItemFile(pItem) != TRUE && ItemHasChildren(pItem)) { /* LastTrain 062 */
			if (!IsRangeSelected()) {
				CArray <int, const int &> arrayList;
				int		nCount;
				nCount = MakeSelectFileArray(arrayList);
				if (GetSelectedItem() > 0) {
					strText.Format("%d̃t@CI", nCount);
				} else {
					strText.Format("S(%d)̃t@CI", nCount);
				}
			}
		}
	}
	((CMainFrame *)AfxGetMainWnd())->SetStatusBarText(strText);

	{ /* WildCherry 072 */
		int		nIndex = -1;
		double dSize = 0.0;
		unsigned long dPlayTime = 0; /* BeachMonster5 123 */
		int nCount=0;
		while((nIndex = GetNextItem(nIndex, LVNI_ALL | LVNI_SELECTED)) >=0) {
			if (IsItemFile(GetTreeItem(nIndex)) == TRUE) {
				// t@Ĉݏ
				int		nNumber = (int)GetLParamFromIndex(nIndex);
				if (nNumber >= 0) {
					FILE_MP3	*fileMP3 = m_pDoc->GetListMP3(nNumber);
					dSize += fileMP3->lFileSize;
					if (fileMP3->nPlayTime >= 0) { /* Conspiracy 195 */
						dPlayTime += fileMP3->nPlayTime; /* BeachMonster5 123 */
					}
					nCount++;
				}
			}
		}
		strText.Format("%dt@C/%.2fMB/%d:%02d", nCount, dSize / 1024 / 1024, dPlayTime / 60, dPlayTime % 60 /* BeachMonster5 123 */);
		AfxGetMainWnd()->SendMessage(WM_USER_SET_STATUS_SIZE, 0, (LPARAM)strText.GetBuffer(0));
	}
	return(CSuperGridCtrl::OnChangeSelect());
}

// =============================================
// CMySuperGrid::MakeStrListGenre
// Tv  : WXg̍쐬
//   : none
// ߂l: none
// =============================================
void CMySuperGrid::MakeStrListGenre(void)
{
	int		nGenre;
	m_strListGenre.RemoveAll();

	// Ή̃Ŵ߂̍
//	m_strListGenre.AddTail(_T("-NotSupported-"));

	// SCMPX݊Wԍ̓o^
	for (nGenre = 0; g_genreListSCMPX[nGenre].sName != NULL; nGenre++) {
		if (g_genreListSCMPX[nGenre].bAddList) {
			m_strListGenre.AddTail(g_genreListSCMPX[nGenre].sName);
		}
	}
	// [UW̓o^
	for (nGenre = 0; nGenre < USER_GENRE_LIST_MAX; nGenre++) {
		USER_GENRE_LIST	*pGenre = &g_genreListUSER[nGenre];
		if (g_genreListUSER[nGenre].bUse == false) {
			continue;
		}
		if (g_genreListUSER[nGenre].bAddList) {
			m_strListGenre.AddTail(g_genreListUSER[nGenre].sName);
		}
	}
}

// =============================================
// CMySuperGrid::AddDirectory
// Tv  : XgɃt@Cǉ
//   : sDirName		= fBNg
//       : pItemParent	= eACe
//       : nIcon		= ACR
//       : bSort		= \[gtO
// ߂l: CTreeItem *	= ACe(NULL:G[)
// =============================================
CSuperGridCtrl::CTreeItem *CMySuperGrid::AddDirectory(const char *sDirName, CTreeItem *pItemParent, int nIcon)
{
	CItemInfo* lp = new CItemInfo();

	lp->SetFlagExt(0x00000000);
	lp->SetLParam(-1);
	lp->SetImage(nIcon);

	// fBNgo^
	lp->SetItemText(sDirName);

	// SJҏW֎~ɂ
	for (int nCol = 0; nCol < COLUMN_MAX; nCol++) {
		lp->SetControlType(invalid, nCol);
	}

	// c[ɒǉ
	CTreeItem *pItem;
	if (pItemParent == NULL) pItem = InsertRootItem(lp);
	else                     pItem = InsertItem(pItemParent, lp, TRUE, INSERT_DIRECTORY);

	return(pItem);
}

// =============================================
// CMySuperGrid::AddFile
// Tv  : XgɃt@Cǉ
//   : fileMP3		= MP3t@C
//       : pItemParent	= eACe
//       : lParam		= ACeɐݒ肷LPARAM(Xg̃CfbNX)
//       : bCheck		= `FbN}[Nt邩ǂ
// ߂l: bool			= true:I / false:G[
// =============================================
bool CMySuperGrid::AddFile(const FILE_MP3 *fileMP3, CTreeItem *pItemParent, LPARAM lParam, bool bCheck)
{
	CString	strBuffer;
	CItemInfo* lp = new CItemInfo();

	lp->SetFlagExt(0x00000000);
	lp->SetLParam(lParam);
	lp->SetImage(6);

	// eڂ_~[œo^
	// t@C
	lp->AddSubItemText("");
	// tpX
	lp->AddSubItemText("");
	// gbN
	lp->AddSubItemText("");
	// A[eBXg
	lp->AddSubItemText("");
	// Ao
	lp->AddSubItemText("");
	// gbNԍ
	lp->AddSubItemText("");
	// fBXNԍ
	lp->AddSubItemText("");
	// N
	lp->AddSubItemText("");
	// W
	lp->AddSubItemText("");
	// Rg
	lp->AddSubItemText("");

	// === RIFF MP3 g ===
	// MP3 `
	lp->AddSubItemText("");
	// 쌠
	lp->AddSubItemText("");
	// GWjA()
	lp->AddSubItemText("");
	// \[X
	lp->AddSubItemText("");
	// \tgEFA
	lp->AddSubItemText("");
	// L[[h
	lp->AddSubItemText("");
	// Zp
	lp->AddSubItemText("");
	// ̎
	lp->AddSubItemText("");
	// R~bV
	lp->AddSubItemText("");

	// === ̑ ===
	// t@CTCY
	lp->AddSubItemText("");
	// t@CXV
	lp->AddSubItemText("");
	// t@CpX
	lp->AddSubItemText("");
	// t
	lp->AddSubItemText("");
	// ̎t@C
	lp->AddSubItemText("");

	// W̃R{{bNX̐ݒ
	int		nColNum = g_nColumnNumberList[COLUMN_GENRE];
	if (nColNum >= 0) {
		lp->SetControlType(combobox, nColNum-1);
		lp->SetListData(nColNum-1, &m_strListGenre);
	}

	// c[ɒǉ
	CTreeItem *pItem;
	if (pItemParent == NULL) pItemParent = m_pItemRoot;
	if (pItemParent == NULL) pItem = InsertRootItem(lp);
	else                     pItem = InsertItem(pItemParent, lp, TRUE, INSERT_FILE);

	if (pItem != NULL) {
		// eڂɐݒ
		UpdateFileStatus(pItem, fileMP3);

		// `FbNԂݒ
		SetCheckEx(pItem, bCheck);
	}

	return(pItem ? true : false);
}

// =============================================
// CSuperGridCtrl::SearchChildrenItem
// Tv  : qACe̒Aw肳ꂽÕACe
//   : strName		= O
//       : pItemParent	= eACe
// ߂l: CTreeItem *	= ACe(NULL:łȂ)
// =============================================
CSuperGridCtrl::CTreeItem *CMySuperGrid::SearchChildrenItem(const CString &strName, CTreeItem *pItemParent)
{
	POSITION pos = pItemParent ? GetHeadPosition(pItemParent) : GetRootHeadPosition();
	while(pos != NULL) {
		CTreeItem	*pParent = (CTreeItem*)(pItemParent ? GetNextChild(pItemParent, pos) : GetNextRoot(pos));
		CTreeItem	*pItem = pParent;
		CItemInfo	*lp = GetData(pParent);
		if ((int)lp->GetLParam() < 0) {
			// tH_̂ݏ
			CString		strData = lp->GetItemText();
			if (strData == strName) {
				// 
				return(pItem);
			}
		}
	}
	return((CTreeItem *)NULL);
}

// tB[heLXg擾
CString CMySuperGrid::GetFileColumnText(const FILE_MP3 *fileMP3, int nColumn)
{
	enum	{READ_ID3, READ_SIF, READ_SIF_ID3};
	int		nReadType = IsEditFieldSIF(fileMP3) ? READ_SIF : READ_ID3;
	int		nReadTypeTrackNumber = IsEditTrackNumberSIF(fileMP3) ? READ_SIF : READ_ID3;
	int		nReadTypeTrackGenre = IsEditGenreSIF(fileMP3) ? READ_SIF : READ_ID3;

	CString	strBuffer;
	switch(nColumn) {
	case COLUMN_FULL_PATH_NAME:		// tpX
		return(fileMP3->strFilePath);
	case COLUMN_FILE_NAME:		// t@C
		return(fileMP3->strFileName);
	case COLUMN_TRACK_NAME:		// gbN
		if (nReadType == READ_ID3) return(fileMP3->strTrackName);
		if (nReadType == READ_SIF) return(fileMP3->strTrackNameSI);
	case COLUMN_ARTIST_NAME:	// A[eBXg
		if (nReadType == READ_ID3) return(fileMP3->strArtistName);
		if (nReadType == READ_SIF) return(fileMP3->strArtistNameSI);
	case COLUMN_ALBUM_NAME:		// Ao
		if (nReadType == READ_ID3) return(fileMP3->strAlbumName);
		if (nReadType == READ_SIF) return(fileMP3->strAlbumNameSI);
	case COLUMN_DISK_NUMBER:	// fBXNԍ
		if (nReadType == READ_ID3) return(fileMP3->strDiskNumber);
		if (nReadType == READ_SIF) return(fileMP3->strDiskNumberSI);
	case COLUMN_TRACK_NUMBER:	// gbNԍ
		if (nReadTypeTrackNumber == READ_ID3) return(fileMP3->strTrackNumber);
		if (nReadTypeTrackNumber == READ_SIF) return(fileMP3->strTrackNumberSI);
		break;
	case COLUMN_YEAR:			// [XN
		if (nReadType == READ_ID3) return(fileMP3->strYear);
		if (nReadType == READ_SIF) return(fileMP3->strYearSI);
		return(fileMP3->strYearSI.IsEmpty() ? fileMP3->strYear : fileMP3->strYearSI);
	case COLUMN_GENRE:			// Wԍ
		if (nReadTypeTrackGenre == READ_ID3) return(fileMP3->strGenre);
		if (nReadTypeTrackGenre == READ_SIF) return(fileMP3->strGenreSI);
	case COLUMN_COMMENT:		// Rg
		if (nReadType == READ_ID3) return(fileMP3->strComment);
		if (nReadType == READ_SIF) return(fileMP3->strCommentSI);
		return(fileMP3->strCommentSI.IsEmpty() ? fileMP3->strComment : fileMP3->strCommentSI);
	case COLUMN_COPYRIGHT:		// 쌠
		return(fileMP3->strCopyrightSI);
	case COLUMN_ENGINEER:		// GWjA()
		return(fileMP3->strEngineerSI);
	case COLUMN_SOURCE:			// \[X
		return(fileMP3->strSourceSI);
	case COLUMN_SOFTWARE:		// \tgEFA
		return(fileMP3->strSoftwareSI);
	case COLUMN_KEYWORD:		// L[[h
		return(fileMP3->strKeywordSI);
	case COLUMN_TECHNICIAN:		// Zp
		return(fileMP3->strTechnicianSI);
	case COLUMN_LYRIC:			// ̎
		return(fileMP3->strLyricSI);
	case COLUMN_COMMISSION:		// R~bV
		return(fileMP3->strCommissionSI);

	case COLUMN_FILE_SIZE:		// t@CTCY
		strBuffer.Format("%.2fMB", (float)fileMP3->lFileSize / 1024 / 1024);
		break;
	case COLUMN_FILE_TIME:		// t@CXV
		strBuffer.Format("%04d/%02d/%02d %02d:%02d:%02d",
		                  fileMP3->time.GetYear(), fileMP3->time.GetMonth(), fileMP3->time.GetDay(),
		                  fileMP3->time.GetHour(), fileMP3->time.GetMinute(), fileMP3->time.GetSecond());
		break;
	case COLUMN_FILE_PATH:		// t@CpX
		return(fileMP3->strFilePath);
	case COLUMN_PLAY_TIME:		// t
		if (fileMP3->nPlayTime >= 0) { /* Conspiracy 195 */
			strBuffer.Format("%02d:%02d", fileMP3->nPlayTime/60, fileMP3->nPlayTime%60);
		}
		break;
	case COLUMN_LYRIC_FILE:		// ̎t@C
		strBuffer.Format("%s", fileMP3->bExistLyricFile ? "" : "Ȃ");
		break;
	case COLUMN_FILE_TYPE:		// t@C̎
		strBuffer = GetFileType(fileMP3);
		break;
	case COLUMN_FORMAT:			// tH[}bg /* Conspiracy 198 */
		if (fileMP3->strVisualFormat.IsEmpty()) {
			return(fileMP3->strAudioFormat);
		} else {
			return(fileMP3->strVisualFormat + "\n" + fileMP3->strAudioFormat);
		}
		break;
	case COLUMN_WRITER:			// 쎌 /* ADD MIMURA */
		return(fileMP3->strWriterSI);
		break;
	case COLUMN_COMPOSER:		//  /* Baja 154 */
		return(fileMP3->strComposerSI);
		break;
	case COLUMN_ALBM_ARTIST:	// Albm.A[eBXg /* Baja 154 */
		return(fileMP3->strAlbmArtistSI);
		break;
	case COLUMN_ORIG_ARTIST:	// Orig.A[eBXg /* Baja 154 */
		return(fileMP3->strOrigArtistSI);
		break;
	case COLUMN_URL:			// URL /* Baja 154 */
		return(fileMP3->strURLSI);
		break;
	case COLUMN_ENCODEST:		// GR[hl /* Baja 154 */
		return(fileMP3->strEncodest);
		break;
	case COLUMN_OTHER:			//  ̑ /* Conspiracy 196 */
		return(fileMP3->strOther);
		break;
/* 2003.06.19 start */
	case COLUMN_FILE_CTIME:		// t@C쐬
		strBuffer.Format("%04d/%02d/%02d %02d:%02d:%02d",
		                  fileMP3->timeCreate.GetYear(), fileMP3->timeCreate.GetMonth(), fileMP3->timeCreate.GetDay(),
		                  fileMP3->timeCreate.GetHour(), fileMP3->timeCreate.GetMinute(), fileMP3->timeCreate.GetSecond());
		break;
/* 2003.06.19 end */
	}
	return(strBuffer);
}

bool CMySuperGrid::AddFile2(const FILE_MP3 *fileMP3, CTreeItem *pItemParent, LPARAM lParam, bool bCheck)
{
	CTreeItem	*pParent = pItemParent ? pItemParent : m_pItemRoot;

	// KvȂtH_쐬
	for (int nClass = 0; nClass < CLASS_MAX; nClass++) {
		int		nColumn = g_classInfo.nColumn[nClass];
		if (nColumn >= 0 && nColumn < COLUMN_MAX) {
			CString	strBuffer;

			// t@C̎w̃Jԍ̏擾
			strBuffer = GetFileColumnText(fileMP3, nColumn);
			if (strBuffer.IsEmpty() == FALSE) {
				CTreeItem	*pItem;
				if ((pItem = SearchChildrenItem(strBuffer, pParent)) == NULL) {
					// VtH_쐬
					pItem = AddDirectory(strBuffer, pParent, 2);
				}
				pParent = pItem;
			}
		}
	}

	// t@Cǉ
	if (pParent == m_pItemRoot || pParent == NULL) {
		// ނłȂ
		return(AddFile(fileMP3, m_pItemRoot, lParam, bCheck));
	}
	return(AddFile(fileMP3, pParent, lParam, bCheck));
}

bool CMySuperGrid::UpdateFileStatus(CTreeItem *pItem, const FILE_MP3 *fileMP3)
{
	if (pItem == NULL) return(false);
	((FILE_MP3*)fileMP3)->pTreeItem = pItem; /* STEP 037 */

	CItemInfo	*pInfo = GetData(pItem);
	int		nIndex = NodeToIndex(pItem);
	CString	strBuffer;

	// t@Co^
	if (g_bOptHideMP3ListFile == false) {
		if (GetParentItem(pItem) == NULL) {
			strBuffer = fileMP3->strFullPathName;
		} else {
			TCHAR	fname[_MAX_FNAME], ext[_MAX_EXT];
			_tsplitpath(fileMP3->strFullPathName, NULL, NULL, fname, ext);
			strBuffer = fname;
			strBuffer += ext;
//			strBuffer = fileMP3->strFileName;
		}
	}

	pInfo->SetItemText(strBuffer);
	SetItemText(nIndex, 0, strBuffer);

	// Z̃eLXgݒ
	int		nColumn;
	for (nColumn = COLUMN_FILE_NAME; nColumn < COLUMN_MAX; nColumn++) {
		// eLXg擾
		strBuffer = GetFileColumnText(fileMP3, nColumn);

		int		nColNum = g_nColumnNumberList[nColumn];
		if (nColNum >= 0) {
			pInfo->SetSubItemText(nColNum-1, strBuffer);
			SetItemText(nIndex, nColNum, strBuffer);
		}
	}

	// t@C`ˑɂҏW\^s\ݒ菈
	int		nColNum;
	extern UINT GetFormatTypeIndex(UINT nFormat);
	if (g_bOptEditFieldSIF) {
		for (nColNum = COLUMN_TRACK_NAME; nColNum <= COLUMN_EDIT_MAX; nColNum++) {
			SetColumnControlType(pInfo, g_nControlTypeTableSIF[GetFormatTypeIndex(fileMP3->nFormat)+1][nColNum], nColNum);
		}
	} else {
		for (nColNum = COLUMN_TRACK_NAME; nColNum <= COLUMN_EDIT_MAX; nColNum++) {
			SetColumnControlType(pInfo, g_nControlTypeTable[GetFormatTypeIndex(fileMP3->nFormat)+1][nColNum], nColNum);
		}
	}

	// ̑
	// t@CTCYύXsɂ
	SetColumnControlType(pInfo, invalid, COLUMN_FILE_SIZE);
	// t@CXṼZ̃Rg[^CvXV
	if (g_bOptKeepTimeStamp) {
		SetColumnControlType(pInfo, edit, COLUMN_FILE_TIME);
	} else {
		SetColumnControlType(pInfo, invalid, COLUMN_FILE_TIME);
	}
	// t@CpXύXsɂ
	SetColumnControlType(pInfo, invalid, COLUMN_FILE_PATH);
	// tԂύXsɂ
	SetColumnControlType(pInfo, invalid, COLUMN_PLAY_TIME);
	// ̎t@CύXsɂ
	SetColumnControlType(pInfo, invalid, COLUMN_LYRIC_FILE);
	// t@C̎ނύXsɂ
	SetColumnControlType(pInfo, invalid, COLUMN_FILE_TYPE);
	// tH[}bgύXsɂ
	SetColumnControlType(pInfo, invalid, COLUMN_FORMAT/* Conspiracy 198 */);
	// ̑ύXsɂ
	//SetColumnControlType(pInfo, invalid, COLUMN_OTHER); /* Conspiracy 196 */
	// 쐬ύXsɂ
	SetColumnControlType(pInfo, invalid, COLUMN_FILE_CTIME); /* 2003.06.19 add */

	UpdateData(pItem, pInfo, FALSE);

	// `FbNԂXV
	SetCheckEx(pItem, fileMP3->bCheckFlag ? TRUE : FALSE);

	return(true);
}

bool CMySuperGrid::UpdateAllFiles(void)
{
	CWaitCursor	wait;

	int		nMax = GetItemCount();
	int		nIndex;
	for (nIndex = 0; nIndex < nMax; nIndex++) {
		CTreeItem	*pItem = GetTreeItem(nIndex);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			CItemInfo	*pInfo = GetData(pItem);
			UpdateFileStatus(pItem, m_pDoc->GetListMP3((int)pInfo->GetLParam()));
		}
	}

	return(true);
}

// J̍ő啶擾
int CMySuperGrid::OnGetColumLimitText(int nItem, int nCol)
{
	if (nItem >= 0) {
		CTreeItem	*pItem = GetTreeItem(nItem);
		if (pItem != NULL) {
			int		nType = g_nColumnTypeList[nCol];
			if (nType >= 0 && nType < COLUMN_MAX) {
				// t@CTCY^t@CpX^tԁ^̎t@C
				if (nType == COLUMN_FILE_SIZE || nType == COLUMN_FILE_PATH
				||  nType == COLUMN_PLAY_TIME || nType == COLUMN_LYRIC_FILE
				||	nType == COLUMN_FORMAT /* Conspiracy 198 */) {
					return(0);
				}
				// ^CX^v
				if (nType == COLUMN_FILE_TIME) {
					// 0000/00/00 00:00:00
					return(4+1+2+1+2+1+2+1+2+1+2);
				}

				int		nFileFormat = GetItemFormat(pItem);
				extern UINT GetFormatTypeIndex(UINT nFormat);
				if (g_bOptEditFieldSIF) {
					return g_nColMaxSIF[GetFormatTypeIndex(nFileFormat)+1][nType];
				} else {
					return g_nColMax[GetFormatTypeIndex(nFileFormat)+1][nType];
				}
			}
		}
	}
	return(0);
}

#define IS_RANGE(code, st, end)	((code) >= (st) && (code) <= (end))
BOOL CMySuperGrid::PreTranslateMessage(MSG* pMsg)
{
   	m_toolTip.RelayEvent(pMsg);
	if (pMsg->message == WM_KEYDOWN) {
		bool	bControl = (GetAsyncKeyState(VK_CONTROL) & 0x8000) ? true : false;
		if (GetFocus() == this) {
			int		iItem = GetSelectedItem();
			int		iSubItem = GetCurSubItem();
			if (iItem != -1 && iSubItem > 0) {
				CONTROLTYPE	ctrlType;
				CTreeItem	*pSelItem = GetTreeItem(iItem);
				CItemInfo	*pInfo = GetData(pSelItem);
				if (bControl == false) {
					_RPT1(_CRT_WARN,"GetAsyncKeyState(VK_CONVERT)&0x8000=%x\n", GetAsyncKeyState(VK_CONVERT)&0x8000);
					_RPT1(_CRT_WARN,"GetAsyncKeyState(VK_NONCONVERT)&0x8000=%x\n", GetAsyncKeyState(VK_NONCONVERT)&0x8000);
					_RPT1(_CRT_WARN,"GetAsyncKeyState(0xf2)&0x8000=%x\n", GetAsyncKeyState(0x0f2)&0x8000);
					_RPT1(_CRT_WARN,"GetAsyncKeyState(0xf3)&0x8000=%x\n", GetAsyncKeyState(0x0f3)&0x8000);
					_RPT1(_CRT_WARN,"GetAsyncKeyState(0xf4)&0x8000=%x\n", GetAsyncKeyState(0x0f4)&0x8000);
					_RPT1(_CRT_WARN,"pMsg->lParam&0x00FF0000)==0x00700000=%x\n", pMsg->lParam&0x00FF0000==0x00700000);
					_RPT1(_CRT_WARN,"pMsg->lParam&0x00FF0000)==0x00290000=%x\n", pMsg->lParam&0x00FF0000==0x00290000);
					WORD	wCode = pMsg->wParam;
					if (IS_RANGE(wCode, 'A', 'Z')		// 'A' - 'Z'
					||  IS_RANGE(wCode, '0', '9')		// '9' - '0'
					||  IS_RANGE(wCode, VK_NUMPAD0, VK_NUMPAD9)	// '9' - '0'(eL[)
					||  wCode == VK_SPACE				// Xy[X
					||  wCode == VK_SEPARATOR			// ?????
					||  wCode == VK_MULTIPLY			// '*'(eL[)
					||  wCode == VK_ADD					// '+'(eL[)
					||  wCode == VK_SUBTRACT			// '-'(eL[)
					||  wCode == VK_DECIMAL				// '.'(eL[)
					||  wCode == VK_DIVIDE				// '/'(eL[)
					||  wCode == 0x00bd					// '-'(L[{[hP)
					||  wCode == 0x00de					// '^'(L[{[hP)
					||  wCode == 0x00dc					// '\'(L[{[hP)
					||  wCode == 0x00c0					// '@'(L[{[hQ)
					||  wCode == 0x00db					// '['(L[{[hQ)
					||  wCode == 0x00bb					// ';'(L[{[hR)
					||  wCode == 0x00ba					// ':'(L[{[hR)
					||  wCode == 0x00dd					// ']'(L[{[hR)
					||  wCode == 0x00bc					// ','(L[{[hS)
					||  wCode == 0x00be					// '.'(L[{[hS)
					||  wCode == 0x00bf					// '/'(L[{[hS)
					||  wCode == 0x00e2					// '_'(L[{[hS)
					||  (wCode == VK_PROCESSKEY && !(GetAsyncKeyState(VK_CONVERT)&0x8000) && !(GetAsyncKeyState(VK_NONCONVERT)&0x8000) && /*!(GetAsyncKeyState(0xf2)&0x8000) && !(GetAsyncKeyState(0xf3)&0x8000) && !(GetAsyncKeyState(0xf4)&0x8000) &&*//* Baja 155 */ !((pMsg->lParam&0x00FF0000)==0x00700000/*Ђ炪*/ || (pMsg->lParam&0x00FF0000)==0x00290000/*p/Sp*/))/* Misirlou 151 */) {		// {(?)
						if (pInfo->GetControlType(iSubItem-1, ctrlType) == 0) {
							// GfBbgRg[̏ꍇ
							CEdit	*pEdit;
							pEdit = EditLabelEx(iItem, iSubItem);
							if (pEdit != NULL) {
								pEdit->SetSel(0, -1);		// ŜI
								pEdit->PostMessage(pMsg->message, pMsg->wParam, pMsg->lParam);
							}
							return(TRUE);
						} else if (ctrlType == combobox) {
							// R{{bNX̏ꍇ
							CStringList *list = NULL;
							pInfo->GetListData(iSubItem-1, list);
							CComboBox *pList = ShowList(iItem, iSubItem, list);
							if (pList != NULL) {
								pList->PostMessage(pMsg->message, pMsg->wParam, pMsg->lParam);
							}
							return(TRUE);
						}
					}
					if (wCode == VK_DELETE) {			// Z̓eNA
						CellClearSelected();
						return(TRUE);
					}

					// `FbN}[NL̏ꍇ
					if (GetExtendedStyle() & LVS_EX_CHECKBOXES) {
						if (wCode == VK_SPACE) {			// Xy[Xo[
							// `FbN}[N̕ύXȂ̂Ŗ
							return(TRUE);
						}
					}
				}
			}
		}
	}

	return(CSuperGridCtrl::PreTranslateMessage(pMsg));
}
#undef IS_RANGE


void ShowLastError(LPSTR title)
{
    LPVOID lpMsgBuf;
    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM,
        NULL,
        GetLastError(),
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0,
        NULL);
    MessageBox(NULL, (char*)lpMsgBuf, title, MB_OK);
    LocalFree(lpMsgBuf);
}


// =============================================
// CMySuperGrid::ClipboardCopy
// Tv  : Nbv{[hւ̃Rs[
//   : none
// ߂l: bool			= true:I / false:G[
// =============================================
bool CMySuperGrid::ClipboardCopy(void)
{
	CString		strBuffer;
	CString		strBufferText; /* RockDance 124 */

	if (IsRangeSelected() == false) {
		// ݂̃J[\ʒuI͈͂Ƃēo^
		if (GetSelectedItem() == -1) return(false);	// G[
		SelectRangeStart();
		m_bMultiSelect = m_bMultiSelectLine = false;
	}

	// I͈͂̃Z̓e𕶎ɕϊ
	int		sx, sy, ex, ey, nTemp;
	sx = m_posMultiSelect[0].x;
	sy = m_posMultiSelect[0].y;
	ex = m_posMultiSelect[1].x;
	ey = m_posMultiSelect[1].y;
	if (ex < sx) {nTemp = sx; sx = ex; ex = nTemp;}
	if (ey < sy) {nTemp = sy; sy = ey; ey = nTemp;}
	if (sx <= COLUMN_MIN) sx = COLUMN_MIN;
	for (int nItem = sy; nItem <= ey; nItem++) {
		CTreeItem	*pItem = GetTreeItem(nItem);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			CItemInfo	*pItemInfo = GetData(pItem);
			for (int nColumn = sx; nColumn <= ex; nColumn++) {
				CString	str = pItemInfo->GetSubItem(nColumn-1);
				if (g_nColumnNumberList[COLUMN_FILE_NAME] == nColumn) { /* Hurricane 214 */
					TCHAR	fname[_MAX_FNAME];
					_tsplitpath(str, NULL, NULL, fname, NULL);
					str = fname;
				}
				if (nColumn != sx) strBuffer += _T("\t");
				if (nColumn != sx) strBufferText += _T("\t"); /* RockDance 124 */
				strBuffer += quoteForComment(str)/* RockDance 124 */;
				strBufferText += str; /* RockDance 124 */
			}
			if (nItem < ey) strBuffer += _T("\r\n");
			if (nItem < ey) strBufferText += _T("\r\n"); /* RockDance 124 */
		}
	}

	// Nbv{[h]p̃obt@m
	LPSTR pBuffer;
	HGLOBAL hMem, hMem2/* RockDance 124 */;
	hMem = GlobalAlloc(GHND|GMEM_DDESHARE, strBuffer.GetLength()+1);
	pBuffer = (LPSTR)GlobalLock(hMem);
	strcpy(pBuffer, strBuffer);
	GlobalUnlock(hMem);
	/* RockDance 124 */
	hMem2 = GlobalAlloc(GHND|GMEM_DDESHARE, strBufferText.GetLength()+1);
	pBuffer = (LPSTR)GlobalLock(hMem2);
	strcpy(pBuffer, strBufferText);
	GlobalUnlock(hMem2);

	// Nbv{[hJăRs[
	OpenClipboard();
	::EmptyClipboard();
	::SetClipboardData(CF_TEXT, (HANDLE)hMem2);
	::SetClipboardData(STEClipbordFormat/*CF_DSPTEXT*//* Misirlou 146 */, (HANDLE)hMem); /* RockDance 124 */
	CloseClipboard();

	return(true);
}

// =============================================
// CMySuperGrid::ClipboardCut
// Tv  : Nbv{[hւ̃Jbg
//   : none
// ߂l: bool			= true:I / false:G[
// =============================================
bool CMySuperGrid::ClipboardCut(void)
{
	ClipboardCopy();
	CellClearSelected();

	return(true);
}

void CMySuperGrid::PasteString(char *sBuffer)
{
#ifdef FLICKERFREE
	//SetRedraw(FALSE);
#endif
	PasteString(sBuffer, 0, true/* RockDance 124 */);	/* FreeFall 052 */
#ifdef FLICKERFREE
	//SetRedraw(TRUE);
#endif
}

void CMySuperGrid::PasteString(char *sBuffer, int nPastePos, bool bText/* RockDance 124 */)	/* FreeFall 052 */
{
	PasteString(sBuffer, nPastePos, false, false, "", "");
}

// =============================================
// CMySuperGrid::ClipboardPaste
// Tv  : Nbv{[hւ̃y[Xg
//   : none
// ߂l: bool			= true:I / false:G[
// =============================================
bool CMySuperGrid::ClipboardPaste(void)
{
	return ClipboardPaste(0, false, "", ""); /* Baja 171 */
}

// Z̓eփRs[
bool CMySuperGrid::CellCopyDown(void)
{
	if (IsRangeSelected() == false) return(false);

	int		sx, sy, ex, ey, nTemp;
	sx = m_posMultiSelect[0].x;
	sy = m_posMultiSelect[0].y;
	ex = m_posMultiSelect[1].x;
	ey = m_posMultiSelect[1].y;
	if (ex < sx) {nTemp = sx; sx = ex; ex = nTemp;}
	if (ey < sy) {nTemp = sy; sy = ey; ey = nTemp;}
	if (sx <= COLUMN_MIN) sx = COLUMN_MIN;
	if (sy == ey) return(false);

	bool bSaveLoadFileAdjustColumn = g_bOptLoadFileAdjustColumn; /* RockDance 130 */
	g_bOptLoadFileAdjustColumn = false; /* RockDance 130 */

#ifdef FLICKERFREE
	//SetRedraw(FALSE);
#endif
	int nColumn;
	int nItem;
	for (nColumn = sx; nColumn <= ex; nColumn++) {
		CTreeItem	*pItemBase = GetTreeItem(sy);
		if (pItemBase != NULL && IsItemFile(pItemBase) == TRUE) {
			CItemInfo	*pItemInfo = GetData(pItemBase);
			CString		strBase = pItemInfo->GetSubItem(nColumn-1);

			for (nItem = sy+1; nItem <= ey; nItem++) {
				CTreeItem	*pItem = GetTreeItem(nItem);
				if (pItem != NULL && IsItemFile(pItem) == TRUE) {
					// Zɕݒ
#ifdef FLICKERFREE
					/*
					CItemInfo *pCurrentItemInfo = GetData(pItem);
					CString strCurrentText = pCurrentItemInfo->GetSubItem(nColumn-1);
					if (strCurrentText != strBase) {
						ChangeSubItemText(nItem, nColumn, strBase);
						InvalidateRangeItem(0, nItem, 0, nItem);
					} else*/
#endif
					ChangeSubItemText(nItem, nColumn, strBase);
#ifdef FLICKERFREE
					//InvalidateItemRect(nItem);
#endif
				}
			}
		}
	}
#ifdef FLICKERFREE
	InvalidateRangeItem(sx, sy, ex, ey);
	InvalidateRangeItem(0, sy, 0, ey);
#endif
	/* RockDance 130 */
	g_bOptLoadFileAdjustColumn = bSaveLoadFileAdjustColumn;
	for (nColumn = sx; nColumn <= ex; nColumn++) {
		if (g_bOptLoadFileAdjustColumn) AutoSizeColumns(nColumn);
	}
#ifdef FLICKERFREE
	//SetRedraw(TRUE);
#endif
	return(true);
}

bool CMySuperGrid::CellClear(int iItem, int iSubItem)
{
	if (iItem < 0) return(false);

	ChangeSubItemText(iItem, iSubItem, _T(""));
	InvalidateItemRect(iItem);
	return(true);
}

bool CMySuperGrid::CellClearSelected(void)
{
	int		sx, sy, ex, ey;
	// I͈͂擾
	if (GetSelectedRange(sx, sy, ex, ey) == false) {
		return(false);					// ͈͑I𖳂
	}
#ifdef FLICKERFREE
	//SetRedraw(FALSE);
#endif
	for (int nItem = sy; nItem <= ey; nItem++) {
		CTreeItem	*pItem = GetTreeItem(nItem);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			for (int nColumn = sx; nColumn <= ex; nColumn++) {
				ChangeSubItemText(nItem, nColumn, _T(""));
				InvalidateItemRect(nItem);
			}
		}
	}
#ifdef FLICKERFREE
	//SetRedraw(TRUE);
#endif

	return(true);
}

bool CMySuperGrid::SetFillNumber(int nStart, int nStep, bool bSpaceInitNumber/* Conspiracy 194 */)
{
	int		sx, sy, ex, ey;
	// I͈͂擾
	if (GetSelectedRange(sx, sy, ex, ey) == false) {
		return(false);					// ͈͑I𖳂
	}

#ifdef FLICKERFREE
	//SetRedraw(FALSE);
#endif
	int		nNumber = nStart;
	for (int nItem = sy; nItem <= ey; nItem++) {
		CTreeItem	*pItem = GetTreeItem(nItem);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			CString	strNumber;
			strNumber.Format("%d", nNumber);
			for (int nColumn = sx; nColumn <= ex; nColumn++) {
				ChangeSubItemText(nItem, nColumn, strNumber);
				InvalidateItemRect(nItem);
			}
			nNumber += nStep;
		} else { /* Conspiracy 194 */
			if (bSpaceInitNumber) {
				nNumber = nStart;
			}
		}
	}

#ifdef FLICKERFREE
	//SetRedraw(TRUE);
#endif
	return(true);
}

int CMySuperGrid::CompFunc(CString &str1, CString &str2, int nColum, bool bSortAscending)
{
	/* BeachMonster4 114 */
	int result;
	if (nColum == g_nColumnNumberList[COLUMN_TRACK_NUMBER] &&
		atoi(str1) > 0 && atoi(str2) > 0) { /* BeachMonster4 118 */
		result = atoi(str1) - atoi(str2);
	} else if (nColum == g_nColumnNumberList[COLUMN_DISK_NUMBER] &&
		atoi(str1) > 0 && atoi(str2) > 0) { /* BeachMonster4 118 */
		result = atoi(str1) - atoi(str2);
	} else if (nColum == g_nColumnNumberList[COLUMN_FILE_SIZE]) { /* RockDance 127 */
		result = (int)(atof(str1)*100 - atof(str2)*100);
	} else {
		char	*buffer1 = new char[str1.GetLength()*2+2];
		char	*buffer2 = new char[str2.GetLength()*2+2];
		CString strComp1 = str1; /* FunnyCorn 179 */
		CString strComp2 = str2; /* FunnyCorn 179 */
		if (g_bOptSortIgnoreKataHira) { /* FunnyCorn 179 */
			strcpy(buffer1, str1);
			strcpy(buffer2, str2);
			conv_hira2kata((unsigned char *)buffer1);
			conv_hira2kata((unsigned char *)buffer2);
			conv_kata_erase_dakuon((unsigned char *)buffer1);
			conv_kata_erase_dakuon((unsigned char *)buffer2);
			strComp1 = buffer1;
			strComp2 = buffer2;
		}
		if (g_bOptSortIgnoreZenHan) {
			conv_zen2hans((unsigned char *)buffer1, (unsigned char *)strComp1/* str1*//* FunnyCorn 179 */.GetBuffer(0), CONV_ALL);
			conv_zen2hans((unsigned char *)buffer2, (unsigned char *)strComp2/* str2*//* FunnyCorn 179 */.GetBuffer(0), CONV_ALL);
		} else {
			strcpy(buffer1, str1);
			strcpy(buffer2, str2);
		}
		if (FALSE && g_bOptSortIgnoreKataHira) { /* FunnyCorn 179 */
			strComp1 = buffer1;
			strComp2 = buffer2;
			conv_han2zens((unsigned char *)buffer1, (unsigned char *)strComp1/* str1*//* FunnyCorn 179 */.GetBuffer(0), CONV_ALL);
			conv_han2zens((unsigned char *)buffer2, (unsigned char *)strComp2/* str2*//* FunnyCorn 179 */.GetBuffer(0), CONV_ALL);
		}
		CString han1 = buffer1;
		if (g_bOptSortIgnoreCase) {
			result = han1.CompareNoCase(buffer2);
			//result = _mbsicmp((unsigned char *)buffer1, (unsigned char *)buffer2);
		} else {
			result = han1.Compare(buffer2);
			//result = _mbscmp((unsigned char *)buffer1, (unsigned char *)buffer2);
		}
		delete [] buffer1;
		delete [] buffer2;
	}
	if (!bSortAscending) {
		result *= -1;
	}
	return result;
}

int CMySuperGrid::CompFunc(SORT_STATE *sortState, int nKeys, int nItem1, int nItem2)
{
	int i; for (i = 0; i < nKeys; i++) {
		// w肳ꂽL[Ŕr
		int		nColumn = g_nColumnNumberList[sortState->nKeyColumn];
		if (nColumn >= 0 && nColumn < COLUMN_MAX) {
			int		nResult;
			nResult = CompFunc(GetItemText(nItem1, nColumn),
			                   GetItemText(nItem2, nColumn),
			                   nColumn,
			                   (sortState->nType == 0) ? true : false);
			if (nResult != 0) return(nResult);
		}

		// ̃L[
		sortState++;
	}
	return(0);
}

BOOL CMySuperGrid::SortTextItems(SORT_STATE *sortState, int nKeys, int low, int high)
{
	if (high == -1) high = GetItemCount() - 1;

	int		lo = low;
	int		hi = high;
	int		nMidItem;

	if (hi <= lo) return FALSE;

	nMidItem = (lo + hi) / 2;

	// loop through the list until indices cross
	while(lo <= hi) {
		while((lo < high) && (CompFunc(sortState, nKeys, lo, nMidItem) < 0))
			++lo;

		while((hi > low) && (CompFunc(sortState, nKeys, hi, nMidItem) > 0))
			--hi;

		if (lo <= hi) {
			// swap only if the items are not equal
			if (lo != hi && CompFunc(sortState, nKeys, lo, hi) != 0) {
				// swap the rows
				CItemInfo *pInfo1 = GetData(GetTreeItem(hi));
				CItemInfo *pInfo2 = GetData(GetTreeItem(lo));
				UpdateData(GetTreeItem(hi), pInfo2, TRUE);
				UpdateData(GetTreeItem(lo), pInfo1, TRUE);

				// `FbNԂւ
				BOOL	bCheck1 = pInfo1->GetCheck();
				BOOL	bCheck2 = pInfo2->GetCheck();
				SetCheck(hi, bCheck2);
				SetCheck(lo, bCheck1);

				// nMidItem ꂽꍇ́Aԍ𒲐
				if      (nMidItem == lo) nMidItem = hi;
				else if (nMidItem == hi) nMidItem = lo;
			}

			++lo;
			--hi;
		}
	}

	if (low < hi) SortTextItems(sortState, nKeys, low, hi);
	if (lo < high) SortTextItems(sortState, nKeys, lo, high);

	return TRUE;
}

void CMySuperGrid::MultiColumnSort(SORT_STATE *sortState, int nKeys)
{
	int		nMax = GetItemCount();
	int		nIndex;

	for (nIndex = 0; nIndex < nMax; nIndex++) {
		CTreeItem	*pItem = GetTreeItem(nIndex);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			CTreeItem	*pParent = GetParentItem(pItem);
			int nEnd; for (nEnd=nIndex+1; nEnd < nMax; nEnd++) {
				CTreeItem	*pItem = GetTreeItem(nEnd);
				if (pItem == NULL || IsItemFile(pItem) == FALSE || pParent != GetParentItem(pItem)) {
					break;
				}
			}
			if (nEnd-1 > nIndex) {
				SortTextItems(sortState, nKeys, nIndex, nEnd-1);
			}
			nIndex = nEnd - 1;
		}
	}

	// ĕ`
	InvalidateRect(NULL);
	UpdateWindow();
}

void CMySuperGrid::OnColumnClick(NMHDR* pNMHDR, LRESULT* pResult)
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	m_bSortAscending = (pNMListView->iSubItem == m_nSortedCol) ? !m_bSortAscending : TRUE;
	m_nSortedCol = pNMListView->iSubItem;

	// ҏW̏ꍇւ̑Ώ
	// (tH[JX߂ĕҏWĂ\[g)
	if (GetFocus() != this) SetFocus();

	CWaitCursor	wait;

	bool	bControl = (GetAsyncKeyState(VK_CONTROL) & 0x8000) ? true : false;
	if (bControl) {
		// NbNꂽJ̕𒲐
		// J̎
		AutoSizeColumns(m_nSortedCol);
	} else {
		// NbNꂽJŃ\[gs
		SORT_STATE	sortState;
		sortState.nKeyColumn = g_nColumnTypeList[m_nSortedCol];
		sortState.nType = m_bSortAscending ? 0 : 1;
		LockWindowUpdate();			// `֎~(h~)
		MultiColumnSort(&sortState, 1);
		UnlockWindowUpdate();		// `拖(h~)
	}

	*pResult = 0;
}

// =============================================
// CMySuperGrid::OnContextMenu
// Tv  : |bvAbvj[
//   : ...
// ߂l: none
// =============================================
void CMySuperGrid::OnContextMenu(CWnd*, CPoint point)
{
	if (GetSelectedItem() == -1) return;

	//L[Xg[Nɂ锭̏ꍇ́Aʒu𒲐
	if (point.x == -1 && point.y == -1) {
		// Jg̃ZʒuɃj[J
		CRect rect;
		GetSubItemRect(GetSelectedItem(), GetCurSubItem(), LVIR_BOUNDS, rect);
		// Z̍1/3Aォ1/2̈ʒuɒ
		point.x = rect.left + (rect.right - rect.left) / 3;
		point.y = (rect.top + rect.bottom) / 2;
		ClientToScreen(&point);
	}

	CMenu menu;
	bool	bUpdateMenuText = false;
	bool	bUpdateMenuText2= false; /* TyphoonSwell 027 */
	bool	bUpdateUserConvMenu = false; /* STEP 030 */

	extern void OnLoadMenu(CMenu* pMenu, UINT nType);
	if (IsRangeSelected() == true) {
		// Z̕I
		VERIFY(menu.LoadMenu(IDR_MENU_CELL_RANGE));
		OnLoadMenu(&menu, MENU_CELL_RANGE);
		bUpdateMenuText = true;
	} else if (GetSelectedCount() > 2) {
		// sI
		VERIFY(menu.LoadMenu(IDR_MENU_FILE_RANGE));
		OnLoadMenu(&menu, MENU_FILE_RANGE);
		bUpdateMenuText2= true;
		bUpdateUserConvMenu = true;
	} else {
		// PsI
		int		nIndex = GetSelectedItem();
		if (nIndex >= 0) {
			CTreeItem	*pItem = GetTreeItem(nIndex);
			if (pItem != NULL && IsItemFile(pItem) == TRUE) {
				// t@C
//				if (IsCurrentCellEditOK()) {
				if (GetCurSubItem() >= COLUMN_MIN) {
					// ҏW\ȃZ
					VERIFY(menu.LoadMenu(IDR_MENU_FILE_EDIT_OK));
					OnLoadMenu(&menu, MENU_FILE_EDIT_OK);
					bUpdateMenuText = true;
					bUpdateUserConvMenu = true; /* STEP 030 */
				} else {
					// ҏWs̃Z
					VERIFY(menu.LoadMenu(IDR_MENU_FILE_RANGE));
					OnLoadMenu(&menu, MENU_FILE_RANGE);
					bUpdateUserConvMenu = true; /* STEP 030 */
				}
			} else {
				// tH_
				VERIFY(menu.LoadMenu(IDR_MENU_SELECT_FOLDER));
				OnLoadMenu(&menu, MENU_SELECT_FOLDER);
				bUpdateUserConvMenu = true; /* STEP 030 */
			}
		}
		bUpdateMenuText2= true;
	}

	CMenu* pPopup = menu.GetSubMenu(0);
	ASSERT(pPopup != NULL);
	CWnd* pWndPopupOwner = this;
	CMenu convSubMenuT2F;
	CMenu convSubMenuF2T;
	if (bUpdateUserConvMenu && g_bUserConvAddMenu) { /* STEP 030 */
		CMenu* pUConvMenu = NULL;
		UINT nCount = pPopup->GetMenuItemCount();
		for (UINT j=0;j<nCount;j++) {
			CString strTitle;
			pPopup->GetMenuString(j, strTitle, MF_BYPOSITION);
			if (strTitle == "[U[wϊ(&U)") {
				pUConvMenu = pPopup->GetSubMenu(j);
				break;
			}
		}
		CString menuTitle;
		convSubMenuT2F.LoadMenu(IDR_MENU_CONV_FORMAT_USER_T2F);
		pUConvMenu->GetMenuString(ID_CONV_TAG2FILE_USER, menuTitle, MF_BYCOMMAND);
		pUConvMenu->ModifyMenu(ID_CONV_TAG2FILE_USER, MF_BYCOMMAND | MF_POPUP, (UINT)convSubMenuT2F.GetSubMenu(0)->GetSafeHmenu(), menuTitle);

		convSubMenuF2T.LoadMenu(IDR_MENU_CONV_FORMAT_USER_F2T);
		pUConvMenu->GetMenuString(ID_CONV_FILE2TAG_USER, menuTitle, MF_BYCOMMAND);
		pUConvMenu->ModifyMenu(ID_CONV_FILE2TAG_USER, MF_BYCOMMAND | MF_POPUP, (UINT)convSubMenuF2T.GetSubMenu(0)->GetSafeHmenu(), menuTitle);
	}

	// j[ږ̍XV
	if (bUpdateMenuText) {
		UINT	dwCmdID[] = {
			ID_CONV_FORMAT_EX_01,
			ID_CONV_FORMAT_EX_02,
			ID_CONV_FORMAT_EX_03,
			ID_CONV_FORMAT_EX_04,
			ID_CONV_FORMAT_EX_05,
			ID_CONV_FORMAT_EX_06,
			ID_CONV_FORMAT_EX_07,
			ID_CONV_FORMAT_EX_08,
			ID_CONV_FORMAT_EX_09,
			ID_CONV_FORMAT_EX_10,
		};
		int i; for (i = 0; i < 10; i++) {
			// j[ڂ̏
			CString	strName;
			// j[ږ擾
			switch(dwCmdID[i]) {
			case ID_CONV_FORMAT_EX_01:
				strName.Format("01F%s", g_userConvFormatEx[0].strName);
				break;
			case ID_CONV_FORMAT_EX_02:
				strName.Format("02F%s", g_userConvFormatEx[1].strName);
				break;
			case ID_CONV_FORMAT_EX_03:
				strName.Format("03F%s", g_userConvFormatEx[2].strName);
				break;
			case ID_CONV_FORMAT_EX_04:
				strName.Format("04F%s", g_userConvFormatEx[3].strName);
				break;
			case ID_CONV_FORMAT_EX_05:
				strName.Format("05F%s", g_userConvFormatEx[4].strName);
				break;
			case ID_CONV_FORMAT_EX_06:
				strName.Format("06F%s", g_userConvFormatEx[5].strName);
				break;
			case ID_CONV_FORMAT_EX_07:
				strName.Format("07F%s", g_userConvFormatEx[6].strName);
				break;
			case ID_CONV_FORMAT_EX_08:
				strName.Format("08F%s", g_userConvFormatEx[7].strName);
				break;
			case ID_CONV_FORMAT_EX_09:
				strName.Format("09F%s", g_userConvFormatEx[8].strName);
				break;
			case ID_CONV_FORMAT_EX_10:
				strName.Format("10F%s", g_userConvFormatEx[9].strName);
				break;
			default:
				pPopup->GetMenuString((UINT)dwCmdID[i], strName, MF_BYCOMMAND);
				break;
			}
			// j[XV
			pPopup->ModifyMenu((UINT)dwCmdID[i], MF_BYCOMMAND, dwCmdID[i], (LPCTSTR)strName);
		}
	}
	if (bUpdateMenuText2) {  /* TyphoonSwell 027 */
		UINT	dwCmdID[] = {
			ID_CONV_FORMAT_USER_01,
			ID_CONV_FORMAT_USER_02,
			ID_CONV_FORMAT_USER_03,
			ID_CONV_FORMAT_USER_04, /* LastTrain 057 */
			ID_CONV_FORMAT_USER_05, /* LastTrain 057 */
			/* STEP 030 */
			ID_CONV_FORMAT_USER_T2F_01,
			ID_CONV_FORMAT_USER_T2F_02,
			ID_CONV_FORMAT_USER_T2F_03,
			ID_CONV_FORMAT_USER_T2F_04,
			ID_CONV_FORMAT_USER_T2F_05,
			ID_CONV_FORMAT_USER_F2T_01,
			ID_CONV_FORMAT_USER_F2T_02,
			ID_CONV_FORMAT_USER_F2T_03,
			ID_CONV_FORMAT_USER_F2T_04,
			ID_CONV_FORMAT_USER_F2T_05,
		};
		int i; for (i = 0; i < /*3*//*5*//* WildCherry 066 */sizeof(dwCmdID)/sizeof(UINT)/* STEP 030 */; i++) {
			if (!(bUpdateUserConvMenu && g_bUserConvAddMenu) && i>=5)	break;
			// j[ڂ̏
			CString	strName;
			// j[ږ擾
			switch(dwCmdID[i]) {
			case ID_CONV_FORMAT_USER_01:
			case ID_CONV_FORMAT_USER_T2F_01: /* STEP 030 */
			case ID_CONV_FORMAT_USER_F2T_01: /* STEP 030 */
				strName.Format("01F%s", g_userConvFormat[0].strName);
				break;
			case ID_CONV_FORMAT_USER_02:
			case ID_CONV_FORMAT_USER_T2F_02: /* STEP 030 */
			case ID_CONV_FORMAT_USER_F2T_02: /* STEP 030 */
				strName.Format("02F%s", g_userConvFormat[1].strName);
				break;
			case ID_CONV_FORMAT_USER_03:
			case ID_CONV_FORMAT_USER_T2F_03: /* STEP 030 */
			case ID_CONV_FORMAT_USER_F2T_03: /* STEP 030 */
				strName.Format("03F%s", g_userConvFormat[2].strName);
				break;
			case ID_CONV_FORMAT_USER_04: /* LastTrain 057 */
			case ID_CONV_FORMAT_USER_T2F_04: /* STEP 030 */
			case ID_CONV_FORMAT_USER_F2T_04: /* STEP 030 */
				strName.Format("04F%s", g_userConvFormat[3].strName);
				break;
			case ID_CONV_FORMAT_USER_05: /* LastTrain 057 */
			case ID_CONV_FORMAT_USER_T2F_05: /* STEP 030 */
			case ID_CONV_FORMAT_USER_F2T_05: /* STEP 030 */
				strName.Format("05F%s", g_userConvFormat[4/* WildCherry 066 */].strName);
				break;
			default:
				pPopup->GetMenuString((UINT)dwCmdID[i], strName, MF_BYCOMMAND);
				break;
			}
			// j[XV
			pPopup->ModifyMenu((UINT)dwCmdID[i], MF_BYCOMMAND, dwCmdID[i], (LPCTSTR)strName);
		}
	}
	if (bUpdateMenuText) {
		UINT	dwCmdID[] = {
			ID_CONV_TAG_TO_TAG_01,
			ID_CONV_TAG_TO_TAG_02,
			ID_CONV_TAG_TO_TAG_03,
			ID_CONV_TAG_TO_TAG_04,
			ID_CONV_TAG_TO_TAG_05,
		};
		int i; for (i = 0; i < 5; i++) {
			// j[ڂ̏
			CString	strName;
			// j[ږ擾
			switch(dwCmdID[i]) {
			case ID_CONV_TAG_TO_TAG_01:
				strName.Format("01F%s", g_userConvFormatTag2Tag[0].strName);
				break;
			case ID_CONV_TAG_TO_TAG_02:
				strName.Format("02F%s", g_userConvFormatTag2Tag[1].strName);
				break;
			case ID_CONV_TAG_TO_TAG_03:
				strName.Format("03F%s", g_userConvFormatTag2Tag[2].strName);
				break;
			case ID_CONV_TAG_TO_TAG_04:
				strName.Format("04F%s", g_userConvFormatTag2Tag[3].strName);
				break;
			case ID_CONV_TAG_TO_TAG_05:
				strName.Format("05F%s", g_userConvFormatTag2Tag[4].strName);
				break;
			default:
				pPopup->GetMenuString((UINT)dwCmdID[i], strName, MF_BYCOMMAND);
				break;
			}
			// j[XV
			pPopup->ModifyMenu((UINT)dwCmdID[i], MF_BYCOMMAND, dwCmdID[i], (LPCTSTR)strName);
		}
	}
	if (bUpdateMenuText) { /* SeaKnows 030 */
		UINT	dwCmdID[] = {
			ID_TEIKEI_01,
			ID_TEIKEI_02,
			ID_TEIKEI_03,
			ID_TEIKEI_04,
			ID_TEIKEI_05,
			ID_TEIKEI_06,
			ID_TEIKEI_07,
			ID_TEIKEI_08,
			ID_TEIKEI_09,
			ID_TEIKEI_10,
			/* FreeFall 046 */
			ID_TEIKEI_2_01,
			ID_TEIKEI_2_02,
			ID_TEIKEI_2_03,
			ID_TEIKEI_2_04,
			ID_TEIKEI_2_05,
			ID_TEIKEI_2_06,
			ID_TEIKEI_2_07,
			ID_TEIKEI_2_08,
			ID_TEIKEI_2_09,
			ID_TEIKEI_2_10,
			ID_TEIKEI_3_01,
			ID_TEIKEI_3_02,
			ID_TEIKEI_3_03,
			ID_TEIKEI_3_04,
			ID_TEIKEI_3_05,
			ID_TEIKEI_3_06,
			ID_TEIKEI_3_07,
			ID_TEIKEI_3_08,
			ID_TEIKEI_3_09,
			ID_TEIKEI_3_10,
		};
		/* FreeFall 046 */ // ƃX}[gɂłȂ....
		CMenu* pTeikeiMenu = NULL;
		int nCount = pPopup->GetMenuItemCount();
		int j; for (int j=0;j<nCount;j++) {
			CString strTitle;
			pPopup->GetMenuString(j, strTitle, MF_BYPOSITION);
			if (strTitle == "^\t") {
				pTeikeiMenu = pPopup->GetSubMenu(j);
				break;
			}
		}
		for (int k = 0; k < 3 && pTeikeiMenu; k++) {
			CMenu* pSubMenu = pTeikeiMenu->GetSubMenu(0);
			pTeikeiMenu->RemoveMenu(0, MF_BYPOSITION);
			pTeikeiMenu->AppendMenu(MF_POPUP , (UINT)pSubMenu->GetSafeHmenu(), (LPCTSTR)g_strTeikeiGroupName[k]);
			int i; for (i = 0; i < 10; i++) {
				// j[ڂ̏
				CString	strName;
				// j[ږ擾
				strName.Format("%02dF%s", i+1, shortString(g_teikeiInfo[i+k*10].strTeikei/* STEP 035 */, TEIKEI_MENU_STRING_MAX) /* FreeFall 051 */);
				// j[XV
				pTeikeiMenu->ModifyMenu((UINT)dwCmdID[i+k*10], MF_BYCOMMAND, dwCmdID[i+k*10], (LPCTSTR)strName);
			}
		}
	}
	if (bUpdateMenuText || bUpdateMenuText2) {  /* LastTrain 065 */
		UINT	dwCmdID[] = {
			ID_MOVE_FOLDER_01,
			ID_MOVE_FOLDER_02,
			ID_MOVE_FOLDER_03,
			ID_MOVE_FOLDER_04,
			ID_MOVE_FOLDER_05,
		};
		int i; for (i = 0; i < 5; i++) {
			// j[ڂ̏
			CString	strName;
			// j[ږ擾
			switch(dwCmdID[i]) {
			case ID_MOVE_FOLDER_01: /* LastTrain 065 */
				strName.Format("01F%s", g_userMoveFolder[0].strName);
				break;
			case ID_MOVE_FOLDER_02: /* LastTrain 065 */
				strName.Format("02F%s", g_userMoveFolder[1].strName);
				break;
			case ID_MOVE_FOLDER_03: /* LastTrain 065 */
				strName.Format("03F%s", g_userMoveFolder[2].strName);
				break;
			case ID_MOVE_FOLDER_04: /* LastTrain 065 */
				strName.Format("04F%s", g_userMoveFolder[3].strName);
				break;
			case ID_MOVE_FOLDER_05: /* LastTrain 065 */
				strName.Format("05F%s", g_userMoveFolder[4].strName);
				break;
			default:
				pPopup->GetMenuString((UINT)dwCmdID[i], strName, MF_BYCOMMAND);
				break;
			}
			// j[XV
			pPopup->ModifyMenu((UINT)dwCmdID[i], MF_BYCOMMAND, dwCmdID[i], (LPCTSTR)strName);
		}
	}
	if (bUpdateMenuText || bUpdateMenuText2) {  /* FunnyCorn 175 */
		UINT	dwCmdID[] = {
			ID_EDIT_COPY_FORMAT_01,
			ID_EDIT_COPY_FORMAT_02,
			ID_EDIT_COPY_FORMAT_03,
			ID_EDIT_COPY_FORMAT_04,
			ID_EDIT_COPY_FORMAT_05,
		};
		int i; for (i = 0; i < 5; i++) {
			// j[ڂ̏
			CString	strName;
			// j[ږ擾
			switch(dwCmdID[i]) {
			case ID_EDIT_COPY_FORMAT_01:
				strName.Format("01F%s", g_userCopyFormat[0].strName);
				break;
			case ID_EDIT_COPY_FORMAT_02:
				strName.Format("02F%s", g_userCopyFormat[1].strName);
				break;
			case ID_EDIT_COPY_FORMAT_03:
				strName.Format("03F%s", g_userCopyFormat[2].strName);
				break;
			case ID_EDIT_COPY_FORMAT_04:
				strName.Format("04F%s", g_userCopyFormat[3].strName);
				break;
			case ID_EDIT_COPY_FORMAT_05:
				strName.Format("05F%s", g_userCopyFormat[4].strName);
				break;
			default:
				pPopup->GetMenuString((UINT)dwCmdID[i], strName, MF_BYCOMMAND);
				break;
			}
			// j[XV
			pPopup->ModifyMenu((UINT)dwCmdID[i], MF_BYCOMMAND, dwCmdID[i], (LPCTSTR)strName);
		}
	}

	while (pWndPopupOwner->GetStyle() & WS_CHILD)
		pWndPopupOwner = pWndPopupOwner->GetParent();

	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
		pWndPopupOwner);
}

// =============================================
// CMySuperGrid::CellStateControl
// Tv  : Z̐䏈
//   : nMode
// ߂l: none
// =============================================
void CMySuperGrid::CellStateControl(int nMode)
{
	CString strINI = AfxGetApp()->m_pszProfileName;
	InitProfile();
	//Profile_Initialize(strINI, TRUE);
	static	char	*sSectionColumnState	= "ColumnState";

	int		nColumn;
	CWinApp	*pApp = AfxGetApp();

	if (nMode == 0) {
		// JWXgǂݏo

		int ColNumFix = 0;		// o[W̃JEg␳

		CString	strVersion;		// ␳p
		double dVersion;
		strVersion = MyGetProfileString("Option","Version", "");
		dVersion = atof(strVersion);

		for (nColumn = 0; nColumn < COLUMN_MAX; nColumn++) {
			CString	strKey;
			struct COLUMN_STATUS	*Stat = &g_columnStatus[nColumn];

			// \tO
			strKey.Format("%sShow", Stat->sRegKey);
			Stat->bShowFlag = MyGetProfileInt(sSectionColumnState, strKey, Stat->bShowFlag);

			// Jʒu
			strKey.Format("%sColNum", Stat->sRegKey);
			Stat->nNumber = MyGetProfileInt(sSectionColumnState, strKey, Stat->nNumber) + ColNumFix;

			// J
			strKey.Format("%sWidth", Stat->sRegKey);
			Stat->nWidth = MyGetProfileInt(sSectionColumnState, strKey, Stat->nWidth);

			// őJ
			strKey.Format("%sWidthMax", Stat->sRegKey);
			Stat->nWidthMax = MyGetProfileInt(sSectionColumnState, strKey, Stat->nWidthMax);

			if(strcmp(Stat->sRegKey,"DiskNo") == 0) {
				if((dVersion == 1.04)|(dVersion == 1.041))
					ColNumFix++;
			}
		}
	} else if (nMode == 1) {
		// ݂̃JTCY擾
		CHeaderCtrl *pHeader = (CHeaderCtrl *)GetHeaderCtrl();
		int nColumnCount = pHeader->GetItemCount();
		for (nColumn = 0; nColumn < nColumnCount; nColumn++) {
			g_columnStatus[g_nColumnTypeList[nColumn]].nWidth = GetColumnWidth(nColumn);
		}
		// JWXgɏo
		for (nColumn = 0; nColumn < COLUMN_MAX; nColumn++) {
			CString	strKey;
			struct COLUMN_STATUS	*Stat = &g_columnStatus[nColumn];

			// \tO
			strKey.Format("%sShow", Stat->sRegKey);
			MyWriteProfileInt(sSectionColumnState, strKey, Stat->bShowFlag);

			// Jʒu
			strKey.Format("%sColNum", Stat->sRegKey);
			MyWriteProfileInt(sSectionColumnState, strKey, Stat->nNumber);

			// J
			strKey.Format("%sWidth", Stat->sRegKey);
			MyWriteProfileInt(sSectionColumnState, strKey, Stat->nWidth);

			// őJ
			strKey.Format("%sWidthMax", Stat->sRegKey);
			MyWriteProfileInt(sSectionColumnState, strKey, Stat->nWidthMax);
		}
	}
	//Profile_Flush(strINI);
	SaveProfile();
	FreeProfile();
	//Profile_Free();
}

LRESULT CMySuperGrid::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	if (message == WM_DESTROY) {
		// ZWXgɕۑ
		CellStateControl(1);
	}

	return CListCtrl::WindowProc(message, wParam, lParam);
}

bool CMySuperGrid::ConvTagInfo(int nIndex, int nType, const char *sFormat)
{
	return(ConvTagInfo(GetTreeItem(nIndex), nType, sFormat));
}

bool CMySuperGrid::ConvTagInfoSelected(int nType, const char *sFormat)
{
	// IĂt@CSď
	CArray <int, const int &> arrayList;
	int		nCount;
	nCount = MakeSelectFileArray(arrayList);
	int i; for (i = 0; i < nCount; i++) {
		int		nIndex = arrayList[i];
		ConvTagInfo(GetTreeItem(nIndex), nType, sFormat);
	}
	return(true);
}

bool CMySuperGrid::ConvTagInfo(CTreeItem *pItem, int nType, const char *sFormat, const char* sBaseTag)
{
	if (pItem == NULL || IsItemFile(pItem) == FALSE) return(false);

	int		nIndex = NodeToIndex(pItem);
	CItemInfo	*pItemInfo = GetData(pItem);
	FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pItemInfo->GetLParam());
	switch(nType) {
	default:
	case 1:		// t@C => gbN
		{
			CString	strFileName = GetFileColumnText(fileMP3, COLUMN_FILE_NAME);
			CString	strTrackName = GetFileColumnText(fileMP3, COLUMN_TRACK_NAME);
//			if (strTrackName.IsEmpty()) {
				TCHAR	fname[_MAX_FNAME];
				_tsplitpath(strFileName, NULL, NULL, fname, NULL);
				ChangeSubItemText(nIndex, g_nColumnNumberList[COLUMN_TRACK_NAME], fname);
				InvalidateItemRect(nIndex);
//			}
		}
		break;
	case 2:		// gbN => t@C
		{
			CString	strTrackName = GetFileColumnText(fileMP3, COLUMN_TRACK_NAME);
			if (strTrackName.IsEmpty() == false) {
				ChangeSubItemText(nIndex, g_nColumnNumberList[COLUMN_FILE_NAME], strTrackName);
				InvalidateItemRect(nIndex);
			}
		}
		break;
	case 3:		// [U[w[^O] => [t@C]ϊ
		{
			CString	strFileName = sFormat;
			CString	strTrackNumber,strTrackNumber2,strTrackNumber3,strDiskNumber,strDiskNumber2,strDiskNumber3;
			strTrackNumber.Format("%d", atoi(CFileMP3::GetIntTrackNo(GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER).SpanExcluding("\r"))));
			strTrackNumber2.Format("%02d", atoi(CFileMP3::GetIntTrackNo(GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER).SpanExcluding("\r"))));
			strTrackNumber3.Format("%03d", atoi(CFileMP3::GetIntTrackNo(GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER).SpanExcluding("\r"))));
			strDiskNumber.Format("%d", atoi(CFileMP3::GetIntDiskNo(GetFileColumnText(fileMP3, COLUMN_DISK_NUMBER).SpanExcluding("\r"))));
			strDiskNumber2.Format("%02d", atoi(CFileMP3::GetIntDiskNo(GetFileColumnText(fileMP3, COLUMN_DISK_NUMBER).SpanExcluding("\r"))));
			strDiskNumber3.Format("%03d", atoi(CFileMP3::GetIntDiskNo(GetFileColumnText(fileMP3, COLUMN_DISK_NUMBER).SpanExcluding("\r"))));
			strFileName = StrReplace(strFileName, "%TRACK_NAME%"   , GetFileColumnText(fileMP3, COLUMN_TRACK_NAME).SpanExcluding("\r"));
			strFileName = StrReplace(strFileName, "%ALBUM_NAME%"   , GetFileColumnText(fileMP3, COLUMN_ALBUM_NAME).SpanExcluding("\r"));
			strFileName = StrReplace(strFileName, "%ARTIST_NAME%"  , GetFileColumnText(fileMP3, COLUMN_ARTIST_NAME).SpanExcluding("\r"));
			strFileName = StrReplace(strFileName, "%TRACK_NUMBER%" , strTrackNumber);
			strFileName = StrReplace(strFileName, "%TRACK_NUMBER2%", strTrackNumber2);
			strFileName = StrReplace(strFileName, "%TRACK_NUMBER3%", strTrackNumber3);
			strFileName = StrReplace(strFileName, "%DISK_NUMBER%" , strDiskNumber);
			strFileName = StrReplace(strFileName, "%DISK_NUMBER2%", strDiskNumber2);
			strFileName = StrReplace(strFileName, "%DISK_NUMBER3%", strDiskNumber3);
			strFileName = StrReplace(strFileName, "%RELEASE_YEAR%" , GetFileColumnText(fileMP3, COLUMN_YEAR).SpanExcluding("\r"));
			strFileName = StrReplace(strFileName, "%COMMENT%"      , GetFileColumnText(fileMP3, COLUMN_COMMENT).SpanExcluding("\r")/* BeachMonster 089 */);
			strFileName = StrReplace(strFileName, "%GENRE%"        , GetFileColumnText(fileMP3, COLUMN_GENRE).SpanExcluding("\r"));
			// SIF ̍
			strFileName = StrReplace(strFileName, "%COPYRIGHT%" , fileMP3->strCopyrightSI.SpanExcluding("\r"));
			strFileName = StrReplace(strFileName, "%ENGINEER%"  , fileMP3->strEngineerSI.SpanExcluding("\r"));
			strFileName = StrReplace(strFileName, "%SOURCE%"    , fileMP3->strSourceSI.SpanExcluding("\r"));
			strFileName = StrReplace(strFileName, "%SOFTWARE%"  , fileMP3->strSoftwareSI.SpanExcluding("\r"));
			strFileName = StrReplace(strFileName, "%KEYWORD%"   , fileMP3->strKeywordSI.SpanExcluding("\r"));
			strFileName = StrReplace(strFileName, "%TECHNICIAN%", fileMP3->strTechnicianSI.SpanExcluding("\r"));
			strFileName = StrReplace(strFileName, "%LYRIC%"     , fileMP3->strLyricSI.SpanExcluding("\r"));
			strFileName = StrReplace(strFileName, "%COMMISSION%", fileMP3->strCommissionSI.SpanExcluding("\r"));
			strFileName = StrReplace(strFileName, "%WRITER%"	, fileMP3->strWriterSI.SpanExcluding("\r")); /* Baja 154 */
			strFileName = StrReplace(strFileName, "%COMPOSER%"	, fileMP3->strComposerSI.SpanExcluding("\r")); /* Baja 154 */
			strFileName = StrReplace(strFileName, "%ALBM_ARTIST%", fileMP3->strAlbmArtistSI.SpanExcluding("\r")); /* Baja 154 */
			strFileName = StrReplace(strFileName, "%ORIG_ARTIST%", fileMP3->strOrigArtistSI.SpanExcluding("\r")); /* Baja 154 */
			strFileName = StrReplace(strFileName, "%URL%"		, fileMP3->strURLSI.SpanExcluding("\r")); /* Baja 154 */
			strFileName = StrReplace(strFileName, "%ENCODEST%"	, fileMP3->strEncodest.SpanExcluding("\r")); /* Baja 154 */
			strFileName = StrReplace(strFileName, "%OTHER%"	    , fileMP3->strOther.SpanExcluding("\r")); /* Conspiracy 196 */
			ChangeSubItemText(nIndex, g_nColumnNumberList[COLUMN_FILE_NAME], strFileName);
			InvalidateItemRect(nIndex);
		}
		break;
	case 4:		// [U[w[t@C] => [^O]ϊ
	case 5:		// ^OUϊ /* STEP 034 */
		{
			// t@C擾
			CItemInfo	*pInfo = GetData(pItem);
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());
			char	*pFileName; /* STEP 034 */
			CString strFileName; /* STEP 034 */
			if (nType == 4) { /* STEP 034 */
				char	sFileName[_MAX_FNAME];
				char	sDirName[_MAX_DIR];	// 2003.06.18 add */
				_tsplitpath(fileMP3->strFullPathName, NULL, sDirName, sFileName, NULL); /* 2003.06.18 add */
	//			_tsplitpath(fileMP3->strFileName, NULL, NULL, sFileName, NULL); /* 2003.06.18 del */
	/* 2003.06.18 start */
				strFileName = sFileName;
				// ɃfBNg܂܂Ă邩`FbNĂ̊Kw̃fBNgϊɒǉ
				for (UINT nPos=0;nPos<strlen(sFormat);nPos++) {
					if (_ismbblead(sFormat[nPos])) {
						nPos++;
						continue;
					}
					if (sFormat[nPos] == '\\') {
						sDirName[strlen(sDirName)-1] = '\0';
						CString sPathName = sDirName;
						char	sExtName[_MAX_EXT];
						_tsplitpath(sPathName, NULL, sDirName, sFileName, sExtName); /* 2003.06.18 add */
						if (strlen(sFileName) == 0)	break;
						strFileName = CString(sFileName) + sExtName + "\\" + strFileName;
					}
				}
	//			char	*pFileName = &sFileName[0];
				/* STEP 034 *///char *pFileName = strFileName.GetBuffer(0);
			} else if (nType == 5) { /* STEP 034 */
				strFileName = sBaseTag;
			} else {
				ASSERT(0);
				return false;
			}
			pFileName = strFileName.GetBuffer(0);
/* 2003.06.18 end */
			while(*sFormat != '\0') {
				enum	{COLUMN_DUMMY = 99};
				int		nColumn = -1, nLen = 1;

				if (strnicmp(sFormat, "%TRACK_NAME%", 12) == 0) {
					nColumn = COLUMN_TRACK_NAME;
					nLen = 12;
				} else if (strnicmp(sFormat, "%ALBUM_NAME%", 12) == 0) {
					nColumn = COLUMN_ALBUM_NAME;
					nLen = 12;
				} else if (strnicmp(sFormat, "%ARTIST_NAME%", 13) == 0) {
					nColumn = COLUMN_ARTIST_NAME;
					nLen = 13;
				} else if (strnicmp(sFormat, "%DISK_NUMBER%", 13) == 0) {
					nColumn = COLUMN_TRACK_NUMBER;
					nLen = 14;
				} else if (strnicmp(sFormat, "%DISK_NUMBER2%", 14) == 0) {
					nColumn = COLUMN_TRACK_NUMBER;
					nLen = 15;
				} else if (strnicmp(sFormat, "%DISK_NUMBER3%", 14) == 0) {
					nColumn = COLUMN_TRACK_NUMBER;
					nLen = 15;
				} else if (strnicmp(sFormat, "%TRACK_NUMBER%", 14) == 0) {
					nColumn = COLUMN_TRACK_NUMBER;
					nLen = 14;
				} else if (strnicmp(sFormat, "%TRACK_NUMBER2%", 15) == 0) {
					nColumn = COLUMN_TRACK_NUMBER;
					nLen = 15;
				} else if (strnicmp(sFormat, "%TRACK_NUMBER3%", 15) == 0) {
					nColumn = COLUMN_TRACK_NUMBER;
					nLen = 15;
				} else if (strnicmp(sFormat, "%RELEASE_YEAR%", 14) == 0) {
					nColumn = COLUMN_YEAR;
					nLen = 14;
				} else if (strnicmp(sFormat, "%COMMENT%", 9) == 0) {
					nColumn = COLUMN_COMMENT;
					nLen = 9;
				} else if (strnicmp(sFormat, "%GENRE%", 7) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_GENRE;
					nLen = 7;
				} else if (strnicmp(sFormat, "%COPYRIGHT%", 11) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_COPYRIGHT;
					nLen = 11;
				} else if (strnicmp(sFormat, "%ENGINEER%", 10) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_ENGINEER;
					nLen = 10;
				} else if (strnicmp(sFormat, "%SOURCE%", 8) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_SOURCE;
					nLen = 8;
				} else if (strnicmp(sFormat, "%SOFTWARE%", 10) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_SOFTWARE;
					nLen = 10;
				} else if (strnicmp(sFormat, "%KEYWORD%", 9) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_KEYWORD;
					nLen = 9;
				} else if (strnicmp(sFormat, "%TECHNICIAN%", 12) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_TECHNICIAN;
					nLen = 12;
				} else if (strnicmp(sFormat, "%LYRIC%", 7) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_LYRIC;
					nLen = 7;
				} else if (strnicmp(sFormat, "%COMMISSION%", 12) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_COMMISSION;
					nLen = 12;
				} else if (strnicmp(sFormat, "%WRITER%", 10) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_WRITER;
					nLen = 10;
				} else if (strnicmp(sFormat, "%COMPOSER%", 10) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_COMPOSER;
					nLen = 10;
				} else if (strnicmp(sFormat, "%ALBM_ARTIST%", 13) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_ALBM_ARTIST;
					nLen = 13;
				} else if (strnicmp(sFormat, "%ORIG_ARTIST%", 13) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_ORIG_ARTIST;
					nLen = 13;
				} else if (strnicmp(sFormat, "%URL%", 5) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_URL;
					nLen = 5;
				} else if (strnicmp(sFormat, "%ENCODEST%", 10) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_ENCODEST;
					nLen = 10;
				} else if (strnicmp(sFormat, "%OTHER%", 7) == 0) { /* Conspiracy 200 */
					nColumn = COLUMN_OTHER;
					nLen = 7;
				} else if (strnicmp(sFormat, "%SKIP%", 6) == 0) {
					nColumn = COLUMN_DUMMY;
					nLen = 6;
				} else {
					if (*sFormat != *pFileName) break;	// tH[}bgsv
					pFileName++;
					sFormat++;
				}

				// JXV
				if (nColumn >= 0) {
					CString	strWord;
					if (sFormat[nLen] == '\0') {
						// Ō܂
						strWord = pFileName;
					} else {
						// ̋؂蕶܂
						CString		strWork = &sFormat[nLen];
						//  % ܂ł擾
						LPCSTR	sToken = strtok(strWork.GetBuffer(0), "%");
						if (sToken == NULL) {		// Ō܂
							strWord = pFileName;
						} else {					// ̃L[[h܂
							int		nLen = strlen(sToken);
							while(*pFileName != '\0' && strncmp(pFileName, sToken, nLen) != 0) {
								strWord += *pFileName;
								if (_ismbblead(*pFileName)) { /* 2003.06.19 add */
									pFileName++;
									strWord += *pFileName;
								}
								pFileName++;
							}
						}
					}
					if (nColumn != COLUMN_DUMMY) {
//						CString	strText = GetFileColumnText(fileMP3, nColumn);
//						if (strText.IsEmpty()) {
						if (CFileMP3::IsNumeric(strWord)) { /* STEP 021 */
							if(strnicmp(sFormat, "%TRACK_NUMBER%", 14) == 0) {
								strWord.Format("%d", atoi(strWord));
							}
							if(strnicmp(sFormat, "%TRACK_NUMBER2%", 15) == 0) {
								strWord.Format("%02d", atoi(strWord));
							}
							if(strnicmp(sFormat, "%TRACK_NUMBER3%", 15) == 0) {
								strWord.Format("%03d", atoi(strWord));
							}
							if(strnicmp(sFormat, "%DISK_NUMBER%", 13) == 0) {
								strWord.Format("%d", atoi(strWord));
							}
							if(strnicmp(sFormat, "%DISK_NUMBER2%", 14) == 0) {
								strWord.Format("%02d", atoi(strWord));
							}
							if(strnicmp(sFormat, "%DISK_NUMBER3%", 14) == 0) {
								strWord.Format("%03d", atoi(strWord));
							}
						}
							ChangeSubItemText(nIndex, g_nColumnNumberList[nColumn], strWord);
//						}
					}
					sFormat += nLen;
				}
			}
			strFileName.ReleaseBuffer(); // 2003.06.18 add */
			InvalidateItemRect(nIndex);
		}
		break;
	}
	return(true);
}

const char *CMySuperGrid::GetSelectFileName(void)
{
	int		nIndex = GetSelectedItem();
	if (nIndex >= 0) {
		CTreeItem	*pItem = GetTreeItem(nIndex);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			CItemInfo	*pInfo = GetData(pItem);
			return(m_pDoc->GetListMP3((int)pInfo->GetLParam())->strFullPathName);
		}
	}
	return(NULL);
}

bool CMySuperGrid::WritePlayList(CFile &file, CTreeItem *pItem, CString &strCurDir)
{
	ASSERT(pItem != NULL);
	if (pItem != NULL) {
		CItemInfo *pInfo = GetData(pItem);
		int		nIndex = NodeToIndex(pItem);
		if (IsItemFile(pItem) == TRUE) {
			// t@C̏ꍇ
			if (pInfo->GetCheck()) {
				CItemInfo	*pInfo = GetData(pItem);
				FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());

				// t@Co
				CString	strBuffer;
				// ΃pXΉ
				strBuffer = ConvFileName(fileMP3->strFullPathName, strCurDir);
				strBuffer += "\r\n";
				file.Write(strBuffer, strBuffer.GetLength());
			}
		} else {
			// tH_̏ꍇ
			// qACeSď
			if (ItemHasChildren(pItem) == TRUE) {
				CTreeItem *pSelItem = pItem;
				if (ItemHasChildren(pSelItem)) {
					POSITION pos = GetHeadPosition(pSelItem);
					while(pos != NULL) {
						WritePlayList(file, (CTreeItem *)GetNextChild(pSelItem, pos), strCurDir);
					}
				}
			}
		}
	}
	return(true);
}

bool CMySuperGrid::WritePlayList(const char *sFileName)
{
	return(WritePlayList(sFileName, GetRootHeadPosition()));
}

bool CMySuperGrid::WritePlayList(const char *sFileName, POSITION posRoot)
{
	TRY {
		// o̓t@CJ
		CFile	file(sFileName, CFile::modeCreate|CFile::modeWrite);

		// vCXgt@C̃JgfBNg擾
		CString	strCurDir;
		TCHAR	drive[_MAX_DRIVE], dir[_MAX_DIR];
		_tsplitpath(sFileName, drive, dir, NULL, NULL);
		strCurDir.Format("%s%s", drive, dir);

		// [g̃ACeSď
		POSITION pos = posRoot;
		while(pos != NULL) {
			CTreeItem	*pItem = (CTreeItem*)GetNextRoot(pos);
			WritePlayList(file, pItem, strCurDir);
		}
	}
	CATCH(CFileException, e) {
		CString	strMsg;
		strMsg.Format("t@CI[vł܂ł\nf܂\n\n%s", sFileName);
		MessageBox(strMsg, "t@C̃I[vs", MB_ICONSTOP|MB_OK|MB_TOPMOST);
		return(false);
	}
	END_CATCH

	return(true);
}

bool CMySuperGrid::WriteTreePlayList(const char *sFolder, CTreeItem *pItem, CString &strNameParent)
{
	ASSERT(pItem != NULL);
	if (pItem != NULL) {
		if (pItem != m_pItemRoot) {
			// vCXgo
			CString	strFileName;
			strFileName.Format("%s%s.m3u", sFolder, strNameParent);
			WritePlayList(strFileName, GetHeadPosition(pItem));
		}

		// TutH_̏
		CItemInfo *pInfo = GetData(pItem);
		int		nIndex = NodeToIndex(pItem);
		if (IsItemFile(pItem) == FALSE) {
			// tH_̏ꍇ
			if (ItemHasChildren(pItem) == TRUE) {
				CTreeItem *pSelItem = pItem;
				if (ItemHasChildren(pSelItem)) {
					POSITION pos = GetHeadPosition(pSelItem);
					while(pos != NULL) {
						CTreeItem	*pItem = (CTreeItem*)GetNextChild(pSelItem, pos);
						CItemInfo	*pInfo = pItem ? GetData(pItem) : NULL;
						if (pInfo && IsItemFile(pItem) == FALSE && ItemHasChildren(pItem)) {
							// tH_̂ݏ
							CString		strName;
							if (strNameParent.IsEmpty()) strName.Format("%s", pInfo->GetItemText());
							else                         strName.Format("%s - %s", strNameParent, pInfo->GetItemText());
							strName = ReplaceFileName(NULL, strName);
							WriteTreePlayList(sFolder, pItem, strName);
						}
					}
				}
			}
		}
	}
	return(true);
}

bool CMySuperGrid::WriteTreePlayList(const char *sFolder)
{
	// SẴt@Co
	CString	strFileName;
	strFileName.Format("%sAllFiles.m3u", sFolder);
	WritePlayList(strFileName);

	// [g
	CString		strEmpty;
	WriteTreePlayList(sFolder, m_pItemRoot, strEmpty);

	return(true);
}

// =============================================
// CMySuperGrid::MakeSelectFileArray
// Tv  : IĂt@C̔z쐬
//   : array	= z(o͗p)
// ߂l: int		= LȔz̗vf
// =============================================
int CMySuperGrid::MakeSelectFileArray(CArray <int, const int &> &array)
{
	const int	nInitSize = 256;
	int		nCount;

	// z̏
	nCount = 0;
	array.RemoveAll();
	array.SetSize(nInitSize);

	if (GetSelectedCount() > 0) {
		if (GetSelectedCount() == 1) {
			// PI
			nCount = AddSelectFileArray(GetSelectedItem(), array, nCount);
		} else {
			// I
			// Ȉꍇ́ASĂ̑IĂACe
			// AĂtH_̃t@C͖
			int		nIndex = -1;
			while((nIndex = GetNextItem(nIndex, LVNI_ALL | LVNI_SELECTED)) >=0) {
				if (IsItemFile(GetTreeItem(nIndex)) == TRUE) {
					// t@Ĉݏ
					nCount = AddSelectFileArray(nIndex, array, nCount);
				}
			}
		}
	}
	return(nCount);
}

int CMySuperGrid::MakeSelectFileArray(int nIndex, CArray <int, const int &> &array) /* STEP 008 */
{
	const int	nInitSize = 256;
	int		nCount;

	// z̏
	nCount = 0;
	array.RemoveAll();
	array.SetSize(nInitSize);

	if (nIndex > -1) {
		nCount = AddSelectFileArray(nIndex, array, nCount);
	}
	return(nCount);
}

// =============================================
// CMySuperGrid::AddSelectFileArray
// Tv  : IĂt@Czɒǉ
//   : nIndex		= ǉt@C̃CfbNX
//       : array		= z
//       : nCount		= z̗Lȗvf
// ߂l: int			= ǉ̔z̗Lȗvf
// =============================================
int CMySuperGrid::AddSelectFileArray(int nIndex, CArray <int, const int &> &array, int nCount)
{
	const int	nAddSize = 256;

	// ͈͊OG[
	if (nIndex < 0) return(nCount);

	CTreeItem	*pItem = GetTreeItem(nIndex);
	if (ItemHasChildren(pItem) == FALSE) {
		if (IsItemFile(pItem)) {
			// zg傷Kv邩H
			if (nCount > array.GetUpperBound()) {
				// z񂪑Ȃꍇ́AmۃTCY𑝉
				array.SetSize(array.GetUpperBound() + nAddSize);
			}

			// zɒǉ
			array[nCount] = nIndex;
			nCount++;
		}
	} else {
		POSITION pos = GetHeadPosition(pItem);
		// m[hĂꍇ͊J
		if(ItemHasChildren(pItem) && IsCollapsed(pItem)) {
			Expand(pItem, nIndex);
			InvalidateItemRect(nIndex);
		}
		// qACeSď
		while(pos != NULL) {
			CTreeItem *pChild = GetNextChild(pItem, pos);
			if (pChild != NULL) {
				nCount = AddSelectFileArray(NodeToIndex(pChild), array, nCount);
			}
		}
	}
	return(nCount);
}

void CMySuperGrid::OnItemChanged(NMHDR* pNMHDR, LRESULT* pResult)
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	*pResult = 0;
}

// ACe_uNbNꂽ
BOOL CMySuperGrid::OnItemDblClick(int nIndex)
{
	CSuperTagEditorView	*pView = (CSuperTagEditorView *)GetParent();

	if (pView != NULL) {
		CTreeItem	*pItem = GetTreeItem(nIndex);
		CItemInfo	*pInfo = pItem ? GetData(pItem) : NULL;
		if (pInfo != NULL) {
			pView->PlayFile((int)pInfo->GetLParam());
		}
	}
	return(TRUE);
}

// `FbNԂύXꂽ
void CMySuperGrid::OnChangeCheck(CTreeItem *pItem, BOOL bCheck)
{
	if (pItem != NULL && IsItemFile(pItem) == TRUE) {
		// t@Ĉݏ
		CItemInfo	*pInfo = GetData(pItem);
		if (pInfo != NULL) {
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());
			if (fileMP3) {
				// `FbNtOXV
				fileMP3->bCheckFlag = bCheck ? true : false;
			}
		}
	}
}

// =============================================
// CMySuperGrid::SetCheckAllFiles
// Tv  : SẴt@C̃`FbNԂݒ肷
//   : bCheck		= `FbN
// ߂l: none
// =============================================
void CMySuperGrid::SetCheckAllFiles(BOOL bCheck)
{
	// [g̃ACeSď
	POSITION pos = GetRootHeadPosition();
	while(pos != NULL) {
		CTreeItem	*pItem = (CTreeItem*)GetNextRoot(pos);
		SetCheckEx(NodeToIndex(pItem), bCheck);
	}
}

// =============================================
// CMySuperGrid::SetCheckFileSelect
// Tv  : `FbNĂt@CIԂɂ
//   : none
// ߂l: none
// =============================================
void CMySuperGrid::SetCheckFileSelect(void)
{
	// SẴACȇI
	SelectAllItems(FALSE);

	int		nIndex = -1;
	while((nIndex = GetNextItem(nIndex, LVNI_ALL)) >=0) {
		CTreeItem	*pItem = GetTreeItem(nIndex);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			// t@Ĉݏ
			CItemInfo *pInfo = GetData(pItem);
			if (pInfo && pInfo->GetCheck()) {
				// I
				//SetItemState(nIndex, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
				SetItemState(nIndex, LVIS_SELECTED, LVIS_SELECTED); // J[\ʒu͂̂܂
			}
		}
	}
	OnChangeSelect(); // http://bbs1.parks.jp/22/hasetaS/bbs.cgi?Action=Res&Mode=Tree&Base=94&Fx=1
}

// =============================================
// CMySuperGrid::SetSelectFileCheck
// Tv  : IĂt@C̃`FbNԂݒ肷
//   : bCheck		= `FbN
// ߂l: none
// =============================================
void CMySuperGrid::SetSelectFileCheck(BOOL bCheck)
{
	// IĂt@CSď
	CArray <int, const int &> arrayList;
	int		nCount;
	nCount = MakeSelectFileArray(arrayList);
	int i; for (i = 0; i < nCount; i++) {
		SetCheckEx(GetTreeItem(arrayList[i]), bCheck);
	}
}

// =============================================
// CMySuperGrid::ReverseCheckFiles
// Tv  : SẴt@C̃`FbNԂ𔽓]
//   : none
// ߂l: none
// =============================================
void CMySuperGrid::ReverseCheckFiles(void)
{
	int		nIndex = -1;
	while((nIndex = GetNextItem(nIndex, LVNI_ALL)) >=0) {
		CTreeItem	*pItem = GetTreeItem(nIndex);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			// t@Ĉݏ
			CItemInfo *pInfo = GetData(pItem);
			if (pInfo) {
				// `FbNԂ𔽓]
				SetCheckEx(pItem, pInfo->GetCheck() ? FALSE : TRUE);
			}
		}
	}
}

// =============================================
// CMySuperGrid::CheckFileAtColumnState
// Tv  : ^O̓eŃ`FbN
//   : chkWord		= 
// ߂l: none
// =============================================
void CMySuperGrid::CheckFileAtColumnState(CHECK_WORD_STATE *chkWord)
{
	// K\̃RpC
	if (chkWord->bRegExp) {
		if (chkWord->regexp.RegComp(chkWord->strSearchWord) == NULL) {
			// RpCG[
			MessageBox("K\Ɏw肳Ă镶ARpC\no܂ł\n\nK\̋LqmFĂ", "RpCG[", MB_ICONSTOP|MB_OK|MB_TOPMOST);
			return;
		}
	}

	// Jnʒu
	chkWord->nMatchPos = 0;
	chkWord->nMatchLength = 0;

	if (chkWord->bRangeSelected) {
		// IĂt@CSď
		CArray <int, const int &> arrayList;
		int		nCount;
		nCount = MakeSelectFileArray(arrayList);
		int i; for (i = 0; i < nCount; i++) {
			CheckFileAtColumnState(chkWord, GetTreeItem(arrayList[i]));
		}
	} else {
		// [g̃ACeSď
		POSITION pos = GetRootHeadPosition();
		while(pos != NULL) {
			CTreeItem	*pItem = (CTreeItem*)GetNextRoot(pos);
			CheckFileAtColumnState(chkWord, pItem);
		}
	}
}

// =============================================
// CMySuperGrid::CheckFileAtColumnState
// Tv  : ^O̓eŃ`FbN(ACePʂ̏)
//   : chkWord		= 
//         pItem		= ACe
// ߂l: none
// =============================================
void CMySuperGrid::CheckFileAtColumnState(CHECK_WORD_STATE *chkWord, CTreeItem *pItem)
{
	ASSERT(pItem != NULL);
	if (pItem != NULL) {
		if (IsItemFile(pItem) == TRUE) {
			// t@C̏ꍇ
			chkWord->nMatchPos = 0; /* STEP 002 */
			if (IsMatchItem(chkWord, pItem)) {
				int		nIndex;
				if ((nIndex = NodeToIndex(pItem)) != -1) {
					if (chkWord->bRangeSelected == FALSE
					&&  chkWord->bMatchSelected == TRUE) {
						// I
						SetItemState(nIndex, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
						OnChangeSelect();			// IύXꂽƂʒm
					} else {
						// `FbN
						SetCheckEx(nIndex, TRUE);
					}
				}
			}
		} else {
			// tH_̏ꍇ
			// qACeSď
			if (ItemHasChildren(pItem) == TRUE) {
				CTreeItem *pSelItem = pItem;
				if (ItemHasChildren(pSelItem)) {
					POSITION pos = GetHeadPosition(pSelItem);
					while(pos != NULL) {
						CheckFileAtColumnState(chkWord, (CTreeItem *)GetNextChild(pSelItem, pos));
					}
				}
			}
		}
	}
}

void CMySuperGrid::ReplaceMatchItem(CHECK_WORD_STATE *chkWord, bool bRepAll)
{
	// K\̃RpC
	if (chkWord->bRegExp) {
		if (chkWord->regexp.RegComp(chkWord->strSearchWord) == NULL) {
			// RpCG[
			MessageBox("K\Ɏw肳Ă镶ARpC\no܂ł\n\nK\̋LqmFĂ", "RpCG[", MB_ICONSTOP|MB_OK|MB_TOPMOST);
			return;
		}
	}

	if (bRepAll) {
		// Sā^I͈͂SĒu
		if (chkWord->bRangeSelected) {
			// IĂt@CSď
			CArray <int, const int &> arrayList;
			int		nCount;
			nCount = MakeSelectFileArray(arrayList);
			int i; for (i = 0; i < nCount; i++) {
				ReplaceMatchItem(chkWord, GetTreeItem(arrayList[i]));
			}
		} else {
			// [g̃ACeSď
			POSITION pos = GetRootHeadPosition();
			while(pos != NULL) {
				CTreeItem	*pItem = (CTreeItem*)GetNextRoot(pos);
				ReplaceMatchItem(chkWord, pItem);
			}
		}
	} else {
		// ݂̍ŝݒu
		int		nIndex = GetSelectedItem();
		if (nIndex != -1) {
			CTreeItem	*pItem = GetTreeItem(nIndex);
			if (pItem != NULL) {
				ReplaceMatchItem(chkWord, pItem);
			}
		}
	}
}

void CMySuperGrid::ReplaceMatchItem(CHECK_WORD_STATE *chkWord, CTreeItem *pItem)
{
	ASSERT(pItem != NULL);
	if (pItem != NULL) {
		if (IsItemFile(pItem) == TRUE) {
			// t@C̏ꍇ
			int		nRetryMax = 128;
			// Jnʒu
			chkWord->nMatchPos = 0;
			chkWord->nMatchLength = 0;
			while(IsMatchItem(chkWord, pItem) && --nRetryMax) {
				int		nIndex;
				if ((nIndex = NodeToIndex(pItem)) != -1) {
					CItemInfo *pInfo = GetData(pItem);
					FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());
					CString	strText;

					// Z̃eLXg擾
					strText = GetFileColumnText(fileMP3, chkWord->nMatchColumn);

					// Ώۂ[t@C]H
					if (chkWord->nMatchColumn == COLUMN_FILE_NAME) {
						// gq͒ȗΏۂɂȂ
						if (chkWord->nMatchPos >= strText.GetLength()-4) break;
					}

					CString	strNew;
					strNew = strText.Left(chkWord->nMatchPos)
					       + chkWord->strReplaceWord
					       + strText.Right(strText.GetLength() - (chkWord->nMatchPos+chkWord->nMatchLength));
					ChangeSubItemText(nIndex, g_nColumnNumberList[chkWord->nMatchColumn], strNew);
					if (strNew == strText) {
						// [vp
						break;
					}

					// u̒̕ȗΏۂɂȂ悤ɂ鏈
					chkWord->nMatchPos += chkWord->strReplaceWord.GetLength();
				}
			}
		} else {
			// tH_̏ꍇ
			// qACeSď
			if (ItemHasChildren(pItem) == TRUE) {
				CTreeItem *pSelItem = pItem;
				if (ItemHasChildren(pSelItem)) {
					POSITION pos = GetHeadPosition(pSelItem);
					while(pos != NULL) {
						ReplaceMatchItem(chkWord, (CTreeItem *)GetNextChild(pSelItem, pos));
					}
				}
			}
		}
	}
}

// =============================================
// CMySuperGrid::IsMatchItem
// Tv  : ACeɈv邩ǂ𒲂ׂ
//   : chkWord		= 
//         pItem		= `FbNACe
// ߂l: bool			= true:v / false:sv
// =============================================
bool CMySuperGrid::IsMatchItem(CHECK_WORD_STATE *chkWord, CTreeItem *pItem)
{
	bool	bMatch = false;

	ASSERT(pItem != NULL);
	ASSERT(IsItemFile(pItem) == TRUE);

	if (pItem != NULL && IsItemFile(pItem) == TRUE) {
		int		nTargetColumn;
		int		nStart, nEnd;
		if (chkWord->nTargetColumn == -1) {
			nStart = COLUMN_TRACK_NAME;
			nEnd = COLUMN_EDIT_MAX;/*COLUMN_COMMISSION;*//* Baja 154 */
		} else {
			nStart = nEnd = chkWord->nTargetColumn;
		}

		int		nIndex = NodeToIndex(pItem);
		CItemInfo *pInfo = GetData(pItem);
		FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());
		for (nTargetColumn = nStart; nTargetColumn <= nEnd; nTargetColumn++) {
			enum	{TYPE_NUMERIC, TYPE_STRING};
			int		nType = TYPE_STRING;
			CString	strText;
			UINT	dwData = 0;

			// Z̃eLXg擾
			switch(nTargetColumn) {
			case COLUMN_TRACK_NUMBER:	// gbNԍ
				strText = fileMP3->strTrackNumber;
				break;
			case COLUMN_DISK_NUMBER:	// fBXNԍ
				strText = fileMP3->strDiskNumber;
				break;
			case COLUMN_GENRE:			// Wԍ
				strText = fileMP3->strGenre;
				break;
			case COLUMN_FULL_PATH_NAME:
				strText = fileMP3->strFullPathName;
				break;
			default:					// ̑
				// Z̃eLXg擾
				strText = GetFileColumnText(fileMP3, nTargetColumn);
				break;
			}

			int		nMatchPos = 0, nMatchLen = 0;
			if (nType == TYPE_STRING) {
				if (chkWord->bRegExp == FALSE) {
					// ʏ팟
					int		nCount = strText.GetLength() - chkWord->strSearchWord.GetLength();
					if (nCount >= 0) {
						int		nPos;
						int		nLength = chkWord->strSearchWord.GetLength();
						if (chkWord->strSearchWord.GetLength() == 1) {
							TCHAR	chSearch = chkWord->strSearchWord.GetAt(0);
							for (nPos = chkWord->nMatchPos; nPos <= nCount; nPos++) {
								if (iskanji(strText.GetAt(nPos))) {
									// ̓XLbv
									nPos++;
								} else {
									// ASCII
									if (chkWord->bCheckDiffUL == TRUE) {
										// 啶^
										if (strText.GetAt(nPos) == chSearch) {
											// v
											nMatchPos = nPos;
											nMatchLen = nLength;
											break;
										}
									} else {
										// 啶^𓯈ꎋ
										if (toupper(strText.GetAt(nPos)) == toupper(chSearch)) {
											// v
											nMatchPos = nPos;
											nMatchLen = nLength;
											break;
										}
									}
								}
							}
						} else {
							for (nPos = chkWord->nMatchPos; nPos <= nCount; nPos++) {
								if (StringComp(((LPCSTR)strText)+nPos, (LPCSTR)chkWord->strSearchWord, nLength, chkWord->bCheckDiffUL)) {
									// v
									nMatchPos = nPos;
									nMatchLen = nLength;
									break;
								}
								if (iskanji(strText.GetAt(nPos))) { /* RockDance 132 */
									// ̓XLbv
									nPos++;
								}
							}
						}
					}
				} else {
					// K\
					if ((nMatchPos = chkWord->regexp.RegFind(strText.GetBuffer(0)+chkWord->nMatchPos)) >= 0) {
						nMatchPos += chkWord->nMatchPos;
						nMatchLen = chkWord->regexp.GetFindLen();
					}
				}
				if (chkWord->bMatchComplete) {
					// Sv
					bMatch = (nMatchPos == 0 && nMatchLen != 0 && nMatchLen == strText.GetLength()) ? true : false;
				} else {
					// v
					bMatch = nMatchLen ? true : false;
				}
			} else if (nType == TYPE_NUMERIC) {
				bMatch = ((BYTE)atoi(chkWord->strSearchWord) == (BYTE)dwData) ? true : false;
			}
			if (bMatch == true) {
				chkWord->nMatchColumn = nTargetColumn;
				chkWord->nMatchPos = nMatchPos;
				chkWord->nMatchLength = nMatchLen;
				break;
			}
		}
	}
	return(bMatch);
}

int CMySuperGrid::FindNextMatchItem(int nStart, CHECK_WORD_STATE *chkWord, bool bNext)
{
	// K\̃RpC
	if (chkWord->bRegExp) {
		if (chkWord->regexp.RegComp(chkWord->strSearchWord) == NULL) {
			// RpCG[
			MessageBox("K\Ɏw肳Ă镶ARpC\no܂ł\n\nK\̋LqmFĂ", "RpCG[", MB_ICONSTOP|MB_OK|MB_TOPMOST);
			return(-1);
		}
	}

	// Jnʒu
	chkWord->nMatchPos = 0;
	chkWord->nMatchLength = 0;

	int		nIndex = nStart;
	int		nFlag;
	nFlag = chkWord->bRangeSelected ? LVNI_SELECTED : 0;
	nFlag |= bNext ? LVNI_BELOW : LVNI_ABOVE;
	while((nIndex = GetNextItem(nIndex, nFlag)) >= 0) {
		if (nIndex != nStart) {
			CTreeItem	*pItem = GetTreeItem(nIndex);
			if (pItem != NULL && IsItemFile(pItem) == TRUE) {
				// t@Ĉݏ
				if (IsMatchItem(chkWord, pItem)) {
					// v
					return(nIndex);
				}
			}
		}
	}
	return(-1);
}

void CMySuperGrid::SelectAndVisibleColumn(int nIndex, int nColType)
{
	if (nIndex != -1) {
		// s̑IύX
		SetItemState(nIndex, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
		EnsureVisible(nIndex, FALSE);

		int		iSubItem = g_nColumnNumberList[nColType];
		if (iSubItem != -1) {
			// ̑IύX
			SetCurSubItem(iSubItem);
			MakeColumnVisible(iSubItem);
		}
		OnChangeSelect();			// IύXꂽƂʒm
	}
}

bool CMySuperGrid::ConvUserFormatEx(USER_CONV_FORMAT_EX *pForm)
{
	if (pForm->strFormat.IsEmpty()) {
		// ϊ
		return(false);					// G[
	}

	int		sx, sy, ex, ey;
	// I͈͂擾
	if (GetSelectedRange(sx, sy, ex, ey) == false) {
		return(false);					// ͈͑I𖳂
	}

	// Œ蕶͂
	if (pForm->strFormat.Find("%STRING%") != -1) {
		CDlgFixedString	dialog;
		dialog.m_strText = pForm->strFixString;
		if (dialog.DoModal() == IDCANCEL) {
			// LZ
			return(false);
		}
		pForm->strFixString = dialog.m_strText;
	}

	// Aԕϊ̐ݒ
	char	sNumFormat[20] = {0};
	sprintf_s(sNumFormat,20,"%s0%dd","%",pForm->nColumnCount);

	int		nNumber = pForm->nInitNumber;
	int		fileCount = 0;
	for (int nItem = sy; nItem <= ey; nItem++) {
		CTreeItem	*pItem = GetTreeItem(nItem);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			CItemInfo	*pInfo = GetData(pItem);
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());

			// t@Cgq擾
			CString	strFileName = GetFileColumnText(fileMP3, COLUMN_FILE_NAME);
			TCHAR	sFileName[_MAX_FNAME];
			_tsplitpath(strFileName, NULL, NULL, sFileName, NULL);

			CString	strText = pForm->strFormat;
			CString	strNumber, strTrackNumber, strTrackNumber2, strTrackNumber3, strDiskNumber, strDiskNumber2, strDiskNumber3;
			// A
			strNumber.Format(sNumFormat, nNumber);
			// P̃gbNԍ
			strTrackNumber.Format("%d", atoi(CFileMP3::GetIntTrackNo(GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER).SpanExcluding("\r"))));
			// Q̃gbNԍ
			strTrackNumber2.Format("%02d", atoi(CFileMP3::GetIntTrackNo(GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER).SpanExcluding("\r"))));
			// R̃gbNԍ
			strTrackNumber3.Format("%03d", atoi(CFileMP3::GetIntTrackNo(GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER).SpanExcluding("\r"))));

			// P̃fBXNԍ
			strDiskNumber.Format("%d", atoi(CFileMP3::GetIntDiskNo(GetFileColumnText(fileMP3, COLUMN_DISK_NUMBER).SpanExcluding("\r"))));
			// Q̃fBXNԍ
			strDiskNumber2.Format("%02d", atoi(CFileMP3::GetIntDiskNo(GetFileColumnText(fileMP3, COLUMN_DISK_NUMBER).SpanExcluding("\r"))));
			// R̃fBXNԍ
			strDiskNumber3.Format("%03d", atoi(CFileMP3::GetIntDiskNo(GetFileColumnText(fileMP3, COLUMN_DISK_NUMBER).SpanExcluding("\r"))));

			// gĕ쐬
			strText = StrReplace(strText, "%FILE_NAME%"    , sFileName);
			strText = StrReplace(strText, "%TRACK_NAME%"   , GetFileColumnText(fileMP3, COLUMN_TRACK_NAME).SpanExcluding("\r"));
			strText = StrReplace(strText, "%ALBUM_NAME%"   , GetFileColumnText(fileMP3, COLUMN_ALBUM_NAME).SpanExcluding("\r"));
			strText = StrReplace(strText, "%ARTIST_NAME%"  , GetFileColumnText(fileMP3, COLUMN_ARTIST_NAME).SpanExcluding("\r"));
			strText = StrReplace(strText, "%TRACK_NUMBER%" , strTrackNumber);
			strText = StrReplace(strText, "%TRACK_NUMBER2%", strTrackNumber2);
			strText = StrReplace(strText, "%TRACK_NUMBER3%", strTrackNumber3);
			strText = StrReplace(strText, "%DISK_NUMBER%" , strDiskNumber);
			strText = StrReplace(strText, "%DISK_NUMBER2%", strDiskNumber2);
			strText = StrReplace(strText, "%DISK_NUMBER3%", strDiskNumber3);
			strText = StrReplace(strText, "%RELEASE_YEAR%" , GetFileColumnText(fileMP3, COLUMN_YEAR).SpanExcluding("\r"));
			strText = StrReplace(strText, "%COMMENT%"      , GetFileColumnText(fileMP3, COLUMN_COMMENT).SpanExcluding("\r")/* BeachMonster 089 */);
			strText = StrReplace(strText, "%GENRE%"        , GetFileColumnText(fileMP3, COLUMN_GENRE).SpanExcluding("\r"));
			strText = StrReplace(strText, "%NUMBER%"       , strNumber);
			strText = StrReplace(strText, "%STRING%"       , pForm->strFixString);
			// SIF ̍
			strText = StrReplace(strText, "%COPYRIGHT%" , fileMP3->strCopyrightSI.SpanExcluding("\r"));
			strText = StrReplace(strText, "%ENGINEER%"  , fileMP3->strEngineerSI.SpanExcluding("\r"));
			strText = StrReplace(strText, "%SOURCE%"    , fileMP3->strSourceSI.SpanExcluding("\r"));
			strText = StrReplace(strText, "%SOFTWARE%"  , fileMP3->strSoftwareSI.SpanExcluding("\r"));
			strText = StrReplace(strText, "%KEYWORD%"   , fileMP3->strKeywordSI.SpanExcluding("\r"));
			strText = StrReplace(strText, "%TECHNICIAN%", fileMP3->strTechnicianSI.SpanExcluding("\r"));
			strText = StrReplace(strText, "%LYRIC%"     , fileMP3->strLyricSI.SpanExcluding("\r"));
			strText = StrReplace(strText, "%COMMISSION%", fileMP3->strCommissionSI.SpanExcluding("\r"));
			strText = StrReplace(strText, "%WRITER%"	, fileMP3->strWriterSI.SpanExcluding("\r")); /* Baja 154 */
			strText = StrReplace(strText, "%COMPOSER%"	, fileMP3->strComposerSI.SpanExcluding("\r")); /* Baja 154 */
			strText = StrReplace(strText, "%ALBM_ARTIST%", fileMP3->strAlbmArtistSI.SpanExcluding("\r")); /* Baja 154 */
			strText = StrReplace(strText, "%ORIG_ARTIST%", fileMP3->strOrigArtistSI.SpanExcluding("\r")); /* Baja 154 */
			strText = StrReplace(strText, "%URL%"		, fileMP3->strURLSI.SpanExcluding("\r")); /* Baja 154 */
			strText = StrReplace(strText, "%ENCODEST%"	, fileMP3->strEncodest.SpanExcluding("\r")); /* Baja 154 */
			strText = StrReplace(strText, "%OTHER%"  	, fileMP3->strOther.SpanExcluding("\r")); /* Conspiracy 196 */

			/* STEP 007 */
			if (fileCount == 0) {
				fileCount = GetFolderFileCount(NodeToIndex(GetParentItem(pItem)));
			}
			CString strFileCount;
			strFileCount.Format(sNumFormat, fileCount);
			strText = StrReplace(strText, "%FOLDER_FILE_COUNT%"	, strFileCount);

			// Zɍ쐬ݒ
			for (int nColumn = sx; nColumn <= ex; nColumn++) {
				ChangeSubItemText(nItem, nColumn, strText);
				InvalidateItemRect(nItem);
			}

			// AԂi߂
			nNumber += pForm->nAddNumber;
		} else {
			// ݂łZr؂ꂽAԂ
			if (pForm->bSpaceInitNumber) {
				nNumber = pForm->nInitNumber;
			}
			fileCount = GetFolderFileCount(NodeToIndex(pItem)); /* STEP 0007 */
		}
	}
	return(true);
}

bool CMySuperGrid::ConvString(int nType)
{
	int		sx, sy, ex, ey;
	// I͈͂擾
	if (GetSelectedRange(sx, sy, ex, ey) == false) {
		return(false);					// ͈͑I𖳂
	}

	for (int nItem = sy; nItem <= ey; nItem++) {
		CTreeItem	*pItem = GetTreeItem(nItem);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			CItemInfo	*pInfo = GetData(pItem);
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());
			for (int nColumn = sx; nColumn <= ex; nColumn++) {
				CString	strText;
				TCHAR	fname[_MAX_FNAME], ext[_MAX_EXT];
				bool	bKeepExt = false;

				// Z̃eLXg擾
				strText = GetFileColumnText(fileMP3, g_nColumnTypeList[nColumn]);

				// t@C̏ꍇAgqSpɕϊȂ悤ɂ
				if (g_nColumnTypeList[nColumn] == COLUMN_FILE_NAME) {
					switch(nType) {
					case CONV_STR_HIRA:			// SpȂɕϊ
					case CONV_STR_KATA:			// SpJiɕϊ
					case CONV_STR_HAN_ALL:		// Sp => p(S)ϊ
					case CONV_STR_HAN_KIGOU:	// Sp => p(L)ϊ
					case CONV_STR_HAN_SUJI:		// Sp => p()ϊ
					case CONV_STR_HAN_KATA:		// Sp => p(J^Ji)ϊ
					case CONV_STR_HAN_ALPHA:	// Sp => p(At@xbg)ϊ
					case CONV_STR_ZEN_ALL:		// p => Sp(S)ϊ
					case CONV_STR_ZEN_KIGOU:	// p => Sp(L)ϊ
					case CONV_STR_ZEN_SUJI:		// p => Sp()ϊ
					case CONV_STR_ZEN_KATA:		// p => Sp(J^Ji)ϊ
					case CONV_STR_ZEN_ALPHA:	// p => Sp(At@xbg)ϊ
					default:
						_tsplitpath(strText, NULL, NULL, fname, ext);
						extern bool CheckFileExt(const FILE_MP3* pFileMP3, const char* ext);
						if (/*strlen(ext) == 4 && */CheckFileExt(fileMP3, ext)) {
						/*
						&&	(strcmpi(ext, ".mp3") == 0 || strcmpi(ext, ".rmp") == 0 ||
							 strcmpi(ext, ".wma") == 0 || strcmpi(ext, ".wmv") == 0 ||
							 strcmpi(ext, ".asf") == 0 ||
							 strcmpi(ext, ".ape") == 0 ||
							 strcmpi(ext, ".wav") == 0 || strcmpi(ext, ".avi") == 0 || /* Conspiracy 197 *//*
							 strcmpi(ext, ".ogg") == 0)) {
						*/
							// gq菜
							strText = fname;
							bKeepExt = true;
						}
						break;
					}
				}

				if (strText.GetLength() > 0) {
					// ϊ
					char	*buffer = new char[strText.GetLength()*2+2];
					switch(nType) {
					case CONV_STR_UPPER:		// 啶ɕϊ
						conv_upper((unsigned char *)strText.GetBuffer(0));
						break;
					case CONV_STR_LOWER:		// ɕϊ
						conv_lower((unsigned char *)strText.GetBuffer(0));
						break;
					case CONV_STR_HANKAKU:		// pɕϊ
						conv_zen2hans((unsigned char *)buffer, (unsigned char *)strText.GetBuffer(0), CONV_ALL);
						strText = buffer;
						break;
					case CONV_STR_HIRA:			// SpȂɕϊ
						conv_han2zens((unsigned char *)buffer, (unsigned char *)strText.GetBuffer(0), CONV_ALL);
						conv_kata2hira((unsigned char *)buffer);
						strText = buffer;
						break;
					case CONV_STR_KATA:			// SpJiɕϊ
						conv_han2zens((unsigned char *)buffer, (unsigned char *)strText.GetBuffer(0), CONV_ALL);
						conv_hira2kata((unsigned char *)buffer);
						strText = buffer;
						break;


					case CONV_STR_HAN_ALL:		// Sp => p(S)ϊ
						conv_zen2hans((unsigned char *)buffer, (unsigned char *)strText.GetBuffer(0), CONV_ALL);
						strText = buffer;
						break;
					case CONV_STR_HAN_KIGOU:	// Sp => p(L)ϊ
						conv_zen2hans((unsigned char *)buffer, (unsigned char *)strText.GetBuffer(0), CONV_KIGOU);
						strText = buffer;
						break;
					case CONV_STR_HAN_SUJI:		// Sp => p()ϊ
						conv_zen2hans((unsigned char *)buffer, (unsigned char *)strText.GetBuffer(0), CONV_SUJI);
						strText = buffer;
						break;
					case CONV_STR_HAN_KATA:		// Sp => p(J^Ji)ϊ
						conv_zen2hans((unsigned char *)buffer, (unsigned char *)strText.GetBuffer(0), CONV_KATA);
						strText = buffer;
						break;
					case CONV_STR_HAN_ALPHA:	// Sp => p(At@xbg)ϊ
						conv_zen2hans((unsigned char *)buffer, (unsigned char *)strText.GetBuffer(0), CONV_ALPHA);
						strText = buffer;
						break;
					case CONV_STR_ZEN_ALL:		// p => Sp(S)ϊ
						conv_han2zens((unsigned char *)buffer, (unsigned char *)strText.GetBuffer(0), CONV_ALL);
						strText = buffer;
						break;
					case CONV_STR_ZEN_KIGOU:	// p => Sp(L)ϊ
						conv_han2zens((unsigned char *)buffer, (unsigned char *)strText.GetBuffer(0), CONV_KIGOU);
						strText = buffer;
						break;
					case CONV_STR_ZEN_SUJI:		// p => Sp()ϊ
						conv_han2zens((unsigned char *)buffer, (unsigned char *)strText.GetBuffer(0), CONV_SUJI);
						strText = buffer;
						break;
					case CONV_STR_ZEN_KATA:		// p => Sp(J^Ji)ϊ
						conv_han2zens((unsigned char *)buffer, (unsigned char *)strText.GetBuffer(0), CONV_KATA);
						strText = buffer;
						break;
					case CONV_STR_ZEN_ALPHA:	// p => Sp(At@xbg)ϊ
						conv_han2zens((unsigned char *)buffer, (unsigned char *)strText.GetBuffer(0), CONV_ALPHA);
						strText = buffer;
						break;
					case CONV_STR_TO_UPPER:		//  => 啶ϊ
						conv_upper((unsigned char *)strText.GetBuffer(0));
						break;
					case CONV_STR_TO_LOWER:		// 啶 => ϊ
						conv_lower((unsigned char *)strText.GetBuffer(0));
						break;
					case CONV_STR_FIRST_UPPER:	// P̂Pڂ̂ݑ啶
						conv_lower((unsigned char *)strText.GetBuffer(0));
						conv_first_upper((unsigned char *)strText.GetBuffer(0),/* STEP 026 */ g_strFirstUpperIgnoreWords, g_strFirstUpperSentenceSeparator, g_bFirstUpperIgnoreWord);
						break;
					case CONV_STR_FIXED_UP_LOW:	// 啶Œ /* STEP 040 */
						conv_fixed_upper_lower((unsigned char *)strText.GetBuffer(0), g_arFixedWords);
						break;
					case CONV_STR_HIRA2KATA:	// Ђ炪 => J^Jiϊ
						conv_hira2kata((unsigned char *)strText.GetBuffer(0));
						break;
					case CONV_STR_KATA2HIRA:	// J^Ji => Ђ炪ȕϊ
						conv_kata2hira((unsigned char *)strText.GetBuffer(0));
						break;
					}
					delete[]	buffer;

					// 菜ĂgqtȂ
					if (bKeepExt) {
						strText += ext;
					}

					ChangeSubItemText(nItem, nColumn, strText);
					InvalidateItemRect(nItem);
				}
			}
		}
	}
	return(true);
}


bool CMySuperGrid::GetSelectedRange(int &sx, int &sy, int &ex, int &ey)
{
	if (IsRangeSelected() == false) {
		if (GetSelectedItem() == -1) return(false);	// G[
		if (GetCurSubItem() < COLUMN_MIN) return(false);		// G[
		// ͈͑I𖳂
		sx = ex = GetCurSubItem();
		sy = ey = GetSelectedItem();
	} else {
		// ͈͑I
		int		nTemp;
		sx = m_posMultiSelect[0].x;
		sy = m_posMultiSelect[0].y;
		ex = m_posMultiSelect[1].x;
		ey = m_posMultiSelect[1].y;
		if (ex < sx) {nTemp = sx; sx = ex; ex = nTemp;}
		if (ey < sy) {nTemp = sy; sy = ey; ey = nTemp;}
		if (sx <= COLUMN_MIN) sx = COLUMN_MIN;
	}
	return(true);
}

void CMySuperGrid::ExecFolderTreeSync(const char *sRootFolder, bool bCheckOnly)
{
	CString	strFolder;
	int		nLen = strlen(sRootFolder);
	if (nLen == 0) return;

	// tH_̍ŌK '\\' ɂ
	strFolder = sRootFolder;
	if (IsFolderName(sRootFolder) == false) strFolder += '\\';

	// vOXo[
	m_pDoc->StartLoadFile("tH_...");
	m_pDoc->GetDlgLoadProgressBarPtr()->SetDlgItemText(IDC_ST_MESSAGE, "΂炭҂...");

	// ċN^̃tH_̓s
	m_nFolderSyncCounter = 0;
	ExecFolderTreeSync(strFolder, m_pItemRoot, bCheckOnly, true);

	// vOXo[I
	m_pDoc->EndLoadFile();
}

bool CMySuperGrid::CheckExist(const char *sTarget)
{
	bool	bReturn = false;
//	int		nLen = strlen(sTarget);

	if ((sTarget[0] == '\\' && sTarget[1] == '\\')
	&&  _mbschr((const unsigned char *)(sTarget+2), '\\') == NULL) {
		// "\\lbg[N" ݂̂̏ꍇ͏ɐ^
		bReturn = true;
	} else {
		DWORD	dwAttr;
		DWORD	dwLastError;
		dwAttr = GetFileAttributes(sTarget);
		dwLastError = GetLastError();
		if (dwAttr != 0xFFFFFFFF) {
			// t@C݂
			bReturn = true;
		} else {
			// G[e𒲂ׂ
			bReturn = false;
			switch(dwLastError) {
			case ERROR_SUCCESS:				// (L蓾ȂƎvǈꉞc)
			case ERROR_FILE_NOT_FOUND:		// t@C
			case ERROR_PATH_NOT_FOUND:		// pX
				// {Ƀt@C
				break;
			default:
				{	// lbg[NؒfȂǂ̒vIȃG[
					CString	strBuffer;
					LPVOID lpMsgBuf;
					FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
								  FORMAT_MESSAGE_FROM_SYSTEM |
								  FORMAT_MESSAGE_IGNORE_INSERTS,
								  NULL, dwLastError,
								  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // ftHg
								  (LPTSTR)&lpMsgBuf, 0, NULL);
					strBuffer.Format("t@C̑݃`FbNɎs܂B\nvIȃG[ł\̂ŁA\n𒆒f܂\n\nΏۃt@CF%s\n\n%s", sTarget, (const char *)lpMsgBuf);
					LocalFree(lpMsgBuf);
					MessageBox(strBuffer, "vIG[", MB_ICONSTOP|MB_OK|MB_TOPMOST);
				}
				break;
			}
		}
	}
	return(bReturn);
}

// =============================================
// CMySuperGrid::CheckFileName
// Tv  : Lȃt@Cǂ𒲂ׂ
//   : sTarget		= t@C
// ߂l: bool			= true:L / false:(sȃt@C)
// =============================================
bool CMySuperGrid::CheckFileName(const char *sTarget)
{
	if ((sTarget[0] == '\\' && sTarget[1] == '\\')
	&&  _mbschr((const unsigned char *)(sTarget+2), '\\') == NULL) {
		// "\\lbg[N" ݂̂̏ꍇ͏ɐ^
		return(true);
	}

	if (GetFileAttributes(sTarget) == 0xFFFFFFFF) {
		// G[e𒲂ׂ
		if (GetLastError() == ERROR_INVALID_NAME) {
			// sȃt@CAtH_A{[x
			CString	strBuffer;
			strBuffer.Format("t@C^tH_ɕsȕ܂܂Ă܂\nΏۃt@CF%s", sTarget);
			MessageBox(strBuffer, "vIG[", MB_ICONSTOP|MB_OK|MB_TOPMOST);
			return(false);
		}
	}
	return(true);
}

void CMySuperGrid::ChangeFileAttr(const char *sFileName, DWORD dwAttr)
{
	DWORD	dwAttrNow;
	if ((dwAttrNow = GetFileAttributes((LPTSTR)sFileName)) != (DWORD)-1L) {
		if (dwAttrNow != dwAttr) {
			SetFileAttributes((LPTSTR)sFileName, dwAttr);
		}
	}
}

bool CMySuperGrid::DirectoryMake(CString &strDir)
{
	char	*sTemp;
	int		i, nLen = strDir.GetLength();

	// KhCu܂ސ΃pXŎw肷邱
	if (nLen <= 3) return(false);	// pXZ!
//	if (sDir[1] != ':' || sDir[2] != '\\') return(false);

	sTemp = strDir.GetBuffer(strDir.GetLength());
	// i = 3 ŏĂ̂́Aŏ'\\'(ٰިڸ)΂
	for (i = 3; i <= nLen; i++) {
		unsigned char	c = sTemp[i];
		if (iskanji(c)) {
			i++;
			continue;
		}
		if (c == '\\' || i == nLen) {
			sTemp[i] = NULL;		// '\\'  '\0' ɒu
			if (!CheckExist((const char *)sTemp)) {
				// fBNg݂Ȃ
RETRY:
				if (CreateDirectory(sTemp, NULL) == FALSE) {
					CString	strBuffer;
					LPVOID lpMsgBuf;
					FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
								  FORMAT_MESSAGE_FROM_SYSTEM |
								  FORMAT_MESSAGE_IGNORE_INSERTS,
								  NULL, GetLastError(),
								  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // ftHg
								  (LPTSTR)&lpMsgBuf, 0, NULL);
					strBuffer.Format("%s\n\n%s", sTemp, (const char *)lpMsgBuf);
					LocalFree(lpMsgBuf);
					switch(MessageBox(strBuffer, "tH_̍쐬Ɏs", MB_OK/*MB_ABORTRETRYIGNORE*/|MB_TOPMOST)) {
					case IDRETRY:		// Ďs
						goto RETRY;
					case IDABORT:		// ~
						break;
					case IDIGNORE:		// 
						break;
					}
					return(false);	// G[
				}
			}
			if (i != nLen) sTemp[i] = '\\';	// '\0'  '\\' ɖ߂
		}
	}
	return(true);
}

bool CMySuperGrid::DirectoryRemove(CString &strDir)
{
	// 폜fBNg̑NA
	ChangeFileAttr(strDir, CFile::normal);

	char	*buffer;
	buffer = strDir.GetBuffer(strDir.GetLength());
	if (RemoveDirectory(buffer) == FALSE) {
//		CString	strBuffer;
//		LPVOID lpMsgBuf;
//		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
//					  FORMAT_MESSAGE_FROM_SYSTEM |
//					  FORMAT_MESSAGE_IGNORE_INSERTS,
//					  NULL, GetLastError(),
//					  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // ftHg
//					  (LPTSTR)&lpMsgBuf, 0, NULL);
//		strBuffer.Format("%s\n\n%s", buffer, (const char *)lpMsgBuf);
//		LocalFree(lpMsgBuf);
//		switch(MessageBox(strBuffer, "tH_̍폜Ɏs", MB_OK/*MB_ABORTRETRYIGNORE*/|MB_TOPMOST)) {
//		case IDRETRY:				// Ďs
//			goto RETRY;
//		case IDABORT:				// ~
//			break;
//		case IDIGNORE:				// 
//			break;
//		}
		return(false);	// G[
	}
	return(true);
}

void CMySuperGrid::ExecFolderTreeSync(const char *sFolder, CTreeItem *pItem, bool bCheckOnly, bool bIsRoot)
{
	ASSERT(pItem != NULL);

	// qACetH_ȊȌꍇ͉ɏI
	if (pItem == NULL) return;
	if (IsItemFile(pItem) == TRUE) return;
	if (ItemHasChildren(pItem) == FALSE) return;

	// tH_̏ꍇ
	CString	strFolder;
	bool	bMakeDir = true;

	// tH_쐬
	if (bIsRoot == false) {
		CItemInfo	*lp = GetData(pItem);
		CString		strText = lp->GetItemText();
		// t@CɎgpłȂu
		strText = ReplaceFileName(NULL, strText);
		// Ōオ '.' ɂȂĂꍇ́A'.' 폜
		// Windows ł͍Ōオ '.' ̃tH_͍쐬łȂ
		while(strText.GetLength() > 0) {
			if (strText[strText.GetLength()-1] != '.') break;
			strText = strText.Left(strText.GetLength()-1);
		}
		strFolder.Format("%s%s\\", sFolder, strText);
	} else {
		strFolder = sFolder;
	}

	// qACeSď
	int		nIndex = NodeToIndex(pItem);
	POSITION pos = GetHeadPosition(pItem);
	while(pos != NULL) {
		CTreeItem	*pChild = (CTreeItem *)GetNextChild(pItem, pos);
		if (pChild != NULL) {
			if (IsItemFile(pChild) == FALSE) {
				// tH_(ċAĂяo)
				ExecFolderTreeSync(strFolder, pChild, bCheckOnly);
			} else {
				// t@C
				// vOXo[XV
				if (m_pDoc->GetArrayFileCount() > 0) {
					m_nFolderSyncCounter++;
					m_pDoc->GetDlgLoadProgressBarPtr()->SetPos(m_nFolderSyncCounter * 100 / m_pDoc->GetArrayFileCount());
					CString	strMessage;
					strMessage.Format("...(%d/%d)", m_nFolderSyncCounter, m_pDoc->GetArrayFileCount());
					m_pDoc->GetDlgLoadProgressBarPtr()->SetDlgItemText(IDC_ST_MESSAGE, strMessage);
				}

				CItemInfo *pInfo = GetData(pChild);
				if (bCheckOnly == false || pInfo->GetCheck()) {
					FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());

					// fBNg쐬
					if (bMakeDir == true) {
						DirectoryMake(strFolder);
						bMakeDir = false;
					}

					// t@Cړ
					CString		strOldFolder = fileMP3->strFilePath;
					if (CFileMP3::CopyFile(fileMP3, strFolder, true)) {
						// ړɐꍇ́AtH_ɂȂĂtH_폜
						if (g_bSyncDeleteFolder) {
							while(DirectoryRemove(strOldFolder)) {
								// Ō '\\' 
								strOldFolder = strOldFolder.Left(strOldFolder.GetLength()-1);
								// P̃fBNg쐬
								int		nPos;
								nPos = strOldFolder.ReverseFind('\\');
								if (nPos <= 0) break;
								strOldFolder = strOldFolder.Left(nPos);
							}
						}
					}
				}
			}
		}
	}
}

bool CMySuperGrid::WriteFormatFileBody(CFile &file, CTreeItem *pItem, const CString &strBody, bool bIsHtml, LIST_WRITE_STATUS *pStatus, bool bWriteHtml /* BeachMonster5 120 */)
{
	ASSERT(pItem != NULL);
	if (pItem != NULL) {
		CItemInfo *pInfo = GetData(pItem);
		int		nIndex = NodeToIndex(pItem);
		if (IsItemFile(pItem) == TRUE) {
			// t@C̏ꍇ
			CItemInfo	*pInfo = GetData(pItem);
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());

			CString strText = MakeFormatFileBody(fileMP3, strBody, bIsHtml, pStatus, bWriteHtml); /* Rumble 190 */

			// Pt@Co
			file.Write(strText, strText.GetLength());
		} else {
			// tH_̏ꍇ
			// qACeSď
			if (ItemHasChildren(pItem) == TRUE) {
				CTreeItem *pSelItem = pItem;
				if (ItemHasChildren(pSelItem)) {
					POSITION pos = GetHeadPosition(pSelItem);
					while(pos != NULL) {
						WriteFormatFileBody(file, (CTreeItem *)GetNextChild(pSelItem, pos), strBody, bIsHtml, pStatus, bWriteHtml);
					}
				}
			}
		}
	}

	return(true);
}

bool CMySuperGrid::WriteFormatFileFoot(CFile &file, const CString &strFoot, bool bIsHtml, LIST_WRITE_STATUS *pStatus, bool bWriteHtml)
{
	CString strText = MakeFormatFileFoot(strFoot, bIsHtml, pStatus, bWriteHtml); /* Rumble 190 */

	// o
	file.Write(strText, strText.GetLength());

	return(true);
}

bool CMySuperGrid::WriteFormatFile(const char *sFileName, const CString &strHead, const CString &strBody, const CString &strFoot, bool bSelected, bool bIsHtml, bool bIsWriteAppend, bool bWriteHtml)
{
	TRY {
		// o̓t@CJ
		UINT	iOpenMode = bIsWriteAppend ? (CFile::modeWrite) : (CFile::modeCreate|CFile::modeWrite);
		CFile	file(sFileName, iOpenMode);

		// ǉ̏ꍇ̓t@C̍ŌɈړ
		if (bIsWriteAppend) file.Seek(0, CFile::end);

		// Xgo͏
		LIST_WRITE_STATUS	status;
		status.nFileNumber	= 0;			// ݂̃t@Cԍ
		status.nFileCount	= 0;			// t@C
		status.fTotalSize	= 0.0f;			// TCY
		status.nTotalTime	= 0;			// t

		// Xgt@C̃fBNg擾
		CString	strCurDir;
		TCHAR	drive[_MAX_DRIVE], dir[_MAX_DIR];
		_tsplitpath(sFileName, drive, dir, NULL, NULL);
		status.strDirectory.Format("%s%s", drive, dir);

		// wb_o
		CString strText = strHead; /* Rumble 190 */
		if (bSelected) { /* Rumble 190 */
			// IĂt@CSď
			CArray <int, const int &> arrayList;
			int		nCount;
			nCount = MakeSelectFileArray(arrayList);
			int i; for (i = 0; i < nCount; i++) {
				strText = WriteFormatFileHeader(file, GetTreeItem(arrayList[i]), strText, bIsHtml, &status, bWriteHtml);
			}
		} else {
			// [g̃ACeSď
			POSITION pos = GetRootHeadPosition();
			while(pos != NULL) {
				CTreeItem	*pItem = (CTreeItem*)GetNextRoot(pos);
				strText = WriteFormatFileHeader(file, pItem, strText, bIsHtml, &status, bWriteHtml);
			}
		}
		/* Rumble 190 *///file.Write(strHead, strHead.GetLength());
		strText = MakeFormatFileFoot(strText, bIsHtml, &status, bWriteHtml); /* Rumble 190 */
		file.Write(strText, strText.GetLength()); /* Rumble 190 */
		// Xe[^XZbg /* Rumble 190 */
		status.nFileNumber	= 0;			// ݂̃t@Cԍ
		status.nFileCount	= 0;			// t@C
		status.fTotalSize	= 0.0f;			// TCY
		status.nTotalTime	= 0;			// t

		// {fBo
		int		nFileNumber = 1;
		if (bSelected) {
			// IĂt@CSď
			CArray <int, const int &> arrayList;
			int		nCount;
			nCount = MakeSelectFileArray(arrayList);
			int i; for (i = 0; i < nCount; i++) {
				WriteFormatFileBody(file, GetTreeItem(arrayList[i]), strBody, bIsHtml, &status, bWriteHtml);
			}
		} else {
			// [g̃ACeSď
			POSITION pos = GetRootHeadPosition();
			while(pos != NULL) {
				CTreeItem	*pItem = (CTreeItem*)GetNextRoot(pos);
				WriteFormatFileBody(file, pItem, strBody, bIsHtml, &status, bWriteHtml);
			}
		}

		// tb^o
		// Xe[^XZbg /* Rumble 190 */
		status.nFileNumber	= 0;			// ݂̃t@Cԍ
		status.nFileCount	= 0;			// t@C
		status.fTotalSize	= 0.0f;			// TCY
		status.nTotalTime	= 0;			// t
		CString strTextFoot = strFoot; /* Rumble 190 */
		if (bSelected) { /* Rumble 190 */
			// IĂt@CSď
			CArray <int, const int &> arrayList;
			int		nCount;
			nCount = MakeSelectFileArray(arrayList);
			int i; for (i = 0; i < nCount; i++) {
				strTextFoot = WriteFormatFileHeader(file, GetTreeItem(arrayList[i]), strTextFoot, bIsHtml, &status, bWriteHtml);
			}
		} else {
			// [g̃ACeSď
			POSITION pos = GetRootHeadPosition();
			while(pos != NULL) {
				CTreeItem	*pItem = (CTreeItem*)GetNextRoot(pos);
				strTextFoot = WriteFormatFileHeader(file, pItem, strTextFoot, bIsHtml, &status, bWriteHtml);
			}
		}
		/* Rumble 190 *///file.Write(strHead, strHead.GetLength());
		strTextFoot = MakeFormatFileFoot(strTextFoot, bIsHtml, &status, bWriteHtml); /* Rumble 190 */
		/* Rumble 190 *///WriteFormatFileFoot(file, strFoot, bIsHtml, &status, bWriteHtml);
		WriteFormatFileFoot(file, strTextFoot, bIsHtml, &status, bWriteHtml);
	}
	CATCH(CFileException, e) {
		CString	strMsg;
		strMsg.Format("t@CI[vł܂ł\nf܂\n\n%s", sFileName);
		MessageBox(strMsg, "t@C̃I[vs", MB_ICONSTOP|MB_OK|MB_TOPMOST);
		return(false);
	}
	END_CATCH

	return(true);
}

// =============================================
//  CMySuperGrid::ReplaceFileName
//  Tv  : t@CɎgpłȂu
//    : strName		= t@C
//  ߂l: 			= ũt@C
// =============================================
CString	CMySuperGrid::ReplaceFileName(const FILE_MP3 *fileMP3, CString strName)
{
	TCHAR	fname[_MAX_FNAME], ext[_MAX_EXT];
	TCHAR	drive[_MAX_DRIVE], dir[_MAX_DIR];
	bool	bKeepExt = false;

	/* LastTrain 058 */
	_tsplitpath(strName, drive, dir, fname, ext); /* BeachMonster 100 */
	extern bool CheckFileExt(const FILE_MP3* pFileMP3, const char* ext);
	if (/*strlen(ext) == 4 &&*/ CheckFileExt(fileMP3, ext)) {
	/*
		&&	(strcmpi(ext, ".mp3") == 0 || strcmpi(ext, ".rmp") == 0 ||
			 strcmpi(ext, ".wma") == 0 || strcmpi(ext, ".wmv") == 0 ||
			 strcmpi(ext, ".asf") == 0 ||
			 strcmpi(ext, ".ape") == 0 ||
			 strcmpi(ext, ".wav") == 0 || strcmpi(ext, ".avi") == 0 || /* Conspiracy 197 *//*
			 strcmpi(ext, ".ogg") == 0)) {
	*/
		// gq菜
		strName = fname;
		strName = dir + strName; /* BeachMonster 100 */
		strName = drive + strName; /* BeachMonster 100 */
		bKeepExt = true;
	}
	{ /* LastTrain 058 */
		char	*buffer = new char[strName.GetLength()*2+2];

		switch (g_nFileUnifyHiraKata) { // Љ
		case 1:// Ђ炪
			conv_kata2hira((unsigned char *)strName.GetBuffer(0));
			break;
		case 2:// J^Ji
			conv_hira2kata((unsigned char *)strName.GetBuffer(0));
			break;
		}
		switch (g_nFileUnifyKigou /* BeachMonster 103 */) { // L
		case 1:// Sp
			conv_han2zens((unsigned char *)buffer, (unsigned char *)strName.GetBuffer(0), CONV_KIGOU);
			strName = buffer;
			break;
		case 2:// p
			conv_zen2hans((unsigned char *)buffer, (unsigned char *)strName.GetBuffer(0), CONV_KIGOU);
			strName = buffer;
			break;
		}
		switch (g_nFileUnifySuji) { // 
		case 1:// Sp
			conv_han2zens((unsigned char *)buffer, (unsigned char *)strName.GetBuffer(0), CONV_SUJI);
			strName = buffer;
			break;
		case 2:// p
			conv_zen2hans((unsigned char *)buffer, (unsigned char *)strName.GetBuffer(0), CONV_SUJI);
			strName = buffer;
			break;
		}
		switch (g_nFileUnifyKata) { // J^Ji
		case 1:// Sp
			conv_han2zens((unsigned char *)buffer, (unsigned char *)strName.GetBuffer(0), CONV_KATA);
			strName = buffer;
			break;
		case 2:// p
			conv_zen2hans((unsigned char *)buffer, (unsigned char *)strName.GetBuffer(0), CONV_KATA);
			strName = buffer;
			break;
		}
		switch (g_nFileUnifyAlpha) { // At@xbg
		case 1:// Sp
			conv_han2zens((unsigned char *)buffer, (unsigned char *)strName.GetBuffer(0), CONV_ALPHA);
			strName = buffer;
			break;
		case 2:// p
			conv_zen2hans((unsigned char *)buffer, (unsigned char *)strName.GetBuffer(0), CONV_ALPHA);
			strName = buffer;
			break;
		}
		switch (g_nFileUnifyUpLow) { // 啶
		case 1:// 啶
			conv_upper((unsigned char *)strName.GetBuffer(0));
			break;
		case 2:// 
			conv_lower((unsigned char *)strName.GetBuffer(0));
			break;
		case 3:// P̂Pڂ̂ݑ啶
			conv_lower((unsigned char *)strName.GetBuffer(0));
			conv_first_upper((unsigned char *)strName.GetBuffer(0), /* STEP 026 */ g_strFirstUpperIgnoreWords, g_strFirstUpperSentenceSeparator, g_bFirstUpperIgnoreWord);
			break;
		}
		/* STEP 006 */
		if (fileMP3 != NULL) {
			switch (g_nFileExtChange) {
			case 0:// ̂܂
				break;
			case 1://
				conv_lower((unsigned char*)ext);
				break;
			case 2://啶
				conv_upper((unsigned char *)ext);
				break;
			}
		}
		delete [] buffer;
	}
	{// u([Uw) /* FreeFall 050 */
		int i; for (i = 0; i < USER_FILENAME_REPLACE_MAX; i++) {
			FILENAME_REPLACE	*pRep = &g_userFileNameReplace[i];
			if (!pRep->strBefore.IsEmpty() && pRep->strBefore != pRep->strAfter && pRep->strAfter.Find(pRep->strBefore) == -1) {
				strName = StrReplace(strName, pRep->strBefore, pRep->strAfter);
			}
		}
	}
	if (bKeepExt) { /* LastTrain 058 */
		strName += ext;
	}
	// u
	int i; for (i = 0; i < FILENAME_REPLACE_MAX; i++) {
		FILENAME_REPLACE	*pRep = &g_fileNameReplace[i];
		if (pRep->strBefore != pRep->strAfter && pRep->strAfter.Find(pRep->strBefore) == -1) {
			strName = StrReplace(strName, pRep->strBefore, pRep->strAfter);
		}
	}
	return(strName);
}

LRESULT CMySuperGrid::OnSetFont(WPARAM wParam, LPARAM)
{
	LRESULT res =  Default();

	CRect rc;
	GetWindowRect( &rc );

	WINDOWPOS wp;
	wp.hwnd = m_hWnd;
	wp.cx = rc.Width();
	wp.cy = rc.Height();
	wp.flags = SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOOWNERZORDER | SWP_NOZORDER;
	SendMessage( WM_WINDOWPOSCHANGED, 0, (LPARAM)&wp );

	return res;
}

void CMySuperGrid::MeasureItem ( LPMEASUREITEMSTRUCT lpMeasureItemStruct )
{
	LOGFONT lf;
	GetFont()->GetLogFont( &lf );

	//CSuperGridCtrl::MeasureItem(lpMeasureItemStruct);
	/* 2003.06.19 ftHgtHgꍇ"_"Ȃ̂ +1 */
	/* 2006.02.02 CSuperGridCtrl::MeasureItem()ɂ킹 +4 ƂȂ悤ɂ +1 ̓ACR̍*/ 
	/**/
	if( lf.lfHeight < 0 )
		lpMeasureItemStruct->itemHeight = max(-lf.lfHeight + 2 + 1 + 1, m_cxImage);
	else
		lpMeasureItemStruct->itemHeight = max(lf.lfHeight + 2 + 1 + 1, m_cxImage);
	/**/
}

bool CMySuperGrid::DeleteChar(int nCount, int nPos)
{
	int		sx, sy, ex, ey;
	// I͈͂擾
	if (GetSelectedRange(sx, sy, ex, ey) == false) {
		return(false);					// ͈͑I𖳂
	}

	for (int nItem = sy; nItem <= ey; nItem++) {
		CTreeItem	*pItem = GetTreeItem(nItem);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			CItemInfo	*pInfo = GetData(pItem);
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());
			for (int nColumn = sx; nColumn <= ex; nColumn++) {
				CString	strText;
				TCHAR	fname[_MAX_FNAME], ext[_MAX_EXT];
				bool	bKeepExt = false;

				// Z̃eLXg擾
				strText = GetFileColumnText(fileMP3, g_nColumnTypeList[nColumn]);

				// t@C̏ꍇAgqSpɕϊȂ悤ɂ
				if (g_nColumnTypeList[nColumn] == COLUMN_FILE_NAME) {
					_tsplitpath(strText, NULL, NULL, fname, ext);
					extern bool CheckFileExt(const FILE_MP3* pFileMP3, const char* ext);
					if (/*strlen(ext) == 4 &&*/ CheckFileExt(fileMP3, ext)
					) {/*
					&&	(strcmpi(ext, ".mp3") == 0 || strcmpi(ext, ".rmp") == 0 ||
						 strcmpi(ext, ".wma") == 0 || strcmpi(ext, ".wmv") == 0 ||
						 strcmpi(ext, ".asf") == 0 ||
						 strcmpi(ext, ".ape") == 0 ||
						 strcmpi(ext, ".wav") == 0 || strcmpi(ext, ".avi") == 0 || /* Conspiracy 197 *//*
						 strcmpi(ext, ".ogg") == 0)) {
					*/
						// gq菜
						strText = fname;
						bKeepExt = true;
					}
				}

				if (strText.GetLength() > nCount) {
					// 폜
					if (nPos == 0) {
						strText.Delete(0, nCount);
					} else {
						strText = strText.Left(strText.GetLength()-nCount);
					}
					// 菜ĂgqtȂ
					if (bKeepExt) {
						strText += ext;
					}

					ChangeSubItemText(nItem, nColumn, strText);
					InvalidateItemRect(nItem);
				}
			}
		}
	}
	return(true);
}

bool CMySuperGrid::AddFillNumber(int nStart, int nStep, int nWidth, CString strBefore/* Conspiracy 194 */, CString strAfter/* Conspiracy 194 */, int nPos, bool bSpaceInitNumber/* Conspiracy 194 */)
{
	CString strSeparator = strBefore; /* Conspiracy 194 */
	int		sx, sy, ex, ey;
	// I͈͂擾
	if (GetSelectedRange(sx, sy, ex, ey) == false) {
		return(false);					// ͈͑I𖳂
	}

#ifdef FLICKERFREE
	//SetRedraw(FALSE);
#endif
	int		nNumber = nStart;
	for (int nItem = sy; nItem <= ey; nItem++) {
		CTreeItem	*pItem = GetTreeItem(nItem);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			CString	strNumber;
			CItemInfo	*pItemInfo = GetData(pItem);
			strNumber.Format("%0*d", nWidth, nNumber);
			for (int nColumn = sx; nColumn <= ex; nColumn++) {
				FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pItemInfo->GetLParam());
				CString strText;
				if (nPos == 0) {
					strText = strNumber + strSeparator + GetFileColumnText(fileMP3, g_nColumnTypeList[nColumn]);
				} else if (nPos == 2) {
					strText = strBefore + strNumber + strAfter;
				} else {
					if (g_nColumnTypeList[nColumn] == COLUMN_FILE_NAME) { /* Baja 157 */
						strText = GetFileColumnText(fileMP3, g_nColumnTypeList[nColumn]);
						TCHAR	extOrg[_MAX_EXT];
						TCHAR	fname[_MAX_FNAME], ext[_MAX_EXT];
						_tsplitpath(fileMP3->strFullPathName, NULL, NULL, NULL, extOrg);
						_tsplitpath(strText, NULL, NULL, fname, ext);
						strText = fname + strSeparator + strNumber;
						extern bool CheckFileExt(const FILE_MP3* pFileMP3, const char* ext);
						if (/*strlen(ext) != 4 || */!CheckFileExt(fileMP3, ext)
						)/*
						||  !(strcmpi(ext, ".mp3") == 0 || strcmpi(ext, ".rmp") == 0 ||
							  strcmpi(ext, ".wma") == 0 || strcmpi(ext, ".wmv") == 0 ||
							  strcmpi(ext, ".asf") == 0 ||
							  strcmpi(ext, ".ape") == 0 ||
							  strcmpi(ext, ".wav") == 0 || strcmpi(ext, ".avi") == 0 || /* Conspiracy 197 *//*
							  strcmpi(ext, ".ogg") == 0)) {//C by Kobarin
						*/
							strText += extOrg;
						/*}*/
					} else {
						strText = GetFileColumnText(fileMP3, g_nColumnTypeList[nColumn]) + strSeparator + strNumber;
						/* Baja 158 */
						/*
						CString strText2 = GetFileColumnText(fileMP3, g_nColumnTypeList[nColumn]);
						strText = strSeparator + strNumber;
						strText.Insert(0, strText2);
						*/
					}
				}
				ChangeSubItemText(nItem, nColumn, strText);
				InvalidateItemRect(nItem);
			}
			nNumber += nStep;
		} else { /* Conspiracy 194 */
			if (bSpaceInitNumber) {
				nNumber = nStart;
			}
		}
	}
#ifdef FLICKERFREE
	//SetRedraw(TRUE);
#endif

	return(true);
}

bool CMySuperGrid::MoveFolderFormat(USER_MOVE_FODLER_FORMAT *pForm, CString strFolder, bool isCopy)
{
	// ̂Ƃ͑ItH_Ɉړ /* WildCherry 067 */
//	if (pForm->strFormat.IsEmpty()) {
//		// ϊ
//		return(false);					// G[
//	}

	CArray <int, const int &> arrayList;
	int		nCount;
	nCount = MakeSelectFileArray(arrayList);
	/*
	int		sx, sy, ex, ey;
	// I͈͂擾
	if (GetSelectedRange(sx, sy, ex, ey) == false) {
		return(false);					// ͈͑I𖳂
	}
	*/

	// Œ蕶͂
	if (pForm->strFormat.Find("%STRING%") != -1) {
		CDlgFixedString	dialog;
		dialog.m_strText = pForm->strFixString;
		if (dialog.DoModal() == IDCANCEL) {
			// LZ
			return(false);
		}
		pForm->strFixString = dialog.m_strText;
	}

	CStringArray strMoveFile;
	// Aԕϊ̐ݒ
	//char	*sNumFormat = "%01d";
	//sNumFormat[2] = '0' + pForm->nColumnCount;

	//int		nNumber = pForm->nInitNumber;
	// vOXo[
	if (isCopy) {
		m_pDoc->StartLoadFile("t@CRs[...");
	} else {
		m_pDoc->StartLoadFile("t@Cړ...");
	}
	m_pDoc->GetDlgLoadProgressBarPtr()->SetDlgItemText(IDC_ST_MESSAGE, "΂炭҂...");
	CString strConvFileNameBefore;
	CString strConvFileNameAfter;

	int nOverWriteFlag = 0; /* STEP 041 */
	int i; for (int i=0;i<nCount;i++) {
		if (nOverWriteFlag == 3)	break;
		// vOXo[XV
		if (nCount > 1) {
			m_pDoc->GetDlgLoadProgressBarPtr()->SetPos(i * 100 / (nCount-1));
		}
		int		nIndex = arrayList[i];
		int		nNumber = (int)GetLParamFromIndex(nIndex);
		if (!(nNumber >= 0))	continue;
		FILE_MP3	*fileMP3 = m_pDoc->GetListMP3(nNumber);
		if (fileMP3->bModifyFlag == true) {
			MessageBox("ύXۑĂȂt@C܂܂Ă܂\n\n"
					   "ύXۑĂȂt@C͖܂",
					   "It@Cړ/Rs[", MB_ICONSTOP|MB_OK|MB_TOPMOST);
			continue;
		}

		// t@Cgq擾
		CString	strFileName = GetFileColumnText(fileMP3, COLUMN_FILE_NAME);
		TCHAR	sFileName[_MAX_FNAME];
		_tsplitpath(strFileName, NULL, NULL, sFileName, NULL);

		CString	strText = pForm->strFormat;
		CString	strTrackNumber, strTrackNumber2, strTrackNumber3, strDiskNumber, strDiskNumber2, strDiskNumber3;

		// P̃gbNԍ
		strTrackNumber.Format("%d", atoi(CFileMP3::GetIntTrackNo(GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER).SpanExcluding("\r"))));
		// Q̃gbNԍ
		strTrackNumber2.Format("%02d", atoi(CFileMP3::GetIntTrackNo(GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER).SpanExcluding("\r"))));
		// R̃gbNԍ
		strTrackNumber3.Format("%03d", atoi(CFileMP3::GetIntTrackNo(GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER).SpanExcluding("\r"))));

		// P̃fBXNԍ
		strDiskNumber.Format("%d", atoi(CFileMP3::GetIntDiskNo(GetFileColumnText(fileMP3, COLUMN_DISK_NUMBER).SpanExcluding("\r"))));
		// Q̃fBXNԍ
		strDiskNumber2.Format("%02d", atoi(CFileMP3::GetIntDiskNo(GetFileColumnText(fileMP3, COLUMN_DISK_NUMBER).SpanExcluding("\r"))));
		// R̃fBXNԍ
		strDiskNumber3.Format("%03d", atoi(CFileMP3::GetIntDiskNo(GetFileColumnText(fileMP3, COLUMN_DISK_NUMBER).SpanExcluding("\r"))));


		// gĕ쐬
		strText = StrReplace(strText, "%FILE_NAME%"    , sFileName);
		strText = StrReplace(strText, "%TRACK_NAME%"   , GetFileColumnText(fileMP3, COLUMN_TRACK_NAME).SpanExcluding("\r"));
		strText = StrReplace(strText, "%ALBUM_NAME%"   , GetFileColumnText(fileMP3, COLUMN_ALBUM_NAME).SpanExcluding("\r"));
		strText = StrReplace(strText, "%ARTIST_NAME%"  , GetFileColumnText(fileMP3, COLUMN_ARTIST_NAME).SpanExcluding("\r"));
		strText = StrReplace(strText, "%TRACK_NUMBER%" , strTrackNumber);
		strText = StrReplace(strText, "%TRACK_NUMBER2%", strTrackNumber2);
		strText = StrReplace(strText, "%TRACK_NUMBER3%", strTrackNumber3);
		strText = StrReplace(strText, "%DISK_NUMBER%" , strDiskNumber);
		strText = StrReplace(strText, "%DISK_NUMBER2%", strDiskNumber2);
		strText = StrReplace(strText, "%DISK_NUMBER3%", strDiskNumber3);
		strText = StrReplace(strText, "%RELEASE_YEAR%" , GetFileColumnText(fileMP3, COLUMN_YEAR).SpanExcluding("\r"));
		strText = StrReplace(strText, "%COMMENT%"      , GetFileColumnText(fileMP3, COLUMN_COMMENT).SpanExcluding("\r")/* BeachMonster 089 */);
		strText = StrReplace(strText, "%GENRE%"        , GetFileColumnText(fileMP3, COLUMN_GENRE).SpanExcluding("\r"));
		//strText = StrReplace(strText, "%NUMBER%"       , strNumber);
		strText = StrReplace(strText, "%STRING%"       , pForm->strFixString);

		// R[hiꕔjXy[Xɒu /* SeaKnows2 040 */
		strText = StrReplace(strText, "\n", " ");
		strText = StrReplace(strText, "\r", " ");
		strText = StrReplace(strText, "\t", " ");
		{
			int nStart = 0;
			CString strFolder;
			CString strNewPath;
			strText.TrimLeft('\\');
			strText.TrimRight('\\');
			strText += "\\";
			while (true) {
				nStart = strText.Find('\\'/* AstralCircle2 042 , nStart + 1*/);
				if (nStart == -1) {
					break;
				}
				CString strNewPath = ReplaceFileName(fileMP3, strText.Left(nStart));
				if (strNewPath.GetLength() > g_nConfFileNameMaxChar && g_bConfFileNameMaxCheck) {
					if (strConvFileNameBefore == strNewPath) {
						strNewPath = strConvFileNameAfter;
					} else {
						CDlgFileNameChange dialog;
						dialog.m_nMaxChar = g_nConfFileNameMaxChar;
						dialog.m_strFileName = strNewPath;
						dialog.m_strOrgFileName = strNewPath;
						//dialog.m_strMsg.Format("쐬tH_ %d ȓɕύXĂ", g_nConfFileNameMaxChar);
						dialog.m_strMsgFormat = "쐬tH_ %d(%d) ȓɕύXĂ";
						if (dialog.DoModal() == IDOK) {
							strConvFileNameBefore = strNewPath;
							strNewPath = dialog.m_strFileName;
							strConvFileNameAfter = strNewPath;
						}
					}
				}
				strFolder += strNewPath;
				strText.Delete(0, nStart + 1);
				strFolder += "\\";
			}
			strFolder.TrimRight('\\');
			strText = strFolder;
		}

		{// tH_쐬Ĉړ܂̓Rs[
			int nStart = 0;
			BOOL res = TRUE;
			CString strMakePath;
			strFolder.TrimRight('\\');
			CString strPathName = strFolder + "\\" + strText;
			//if (strPathName.Right(1) == "\\") {
			//	strPathName=strPathName.Left(strPathName.GetLength()-1);
			//}

			// fBNg1JԂ쐬
			CString strNewPath = strPathName;
			strPathName.TrimRight('\\');
			strPathName += _T("\\");
			while(strMakePath + _T("\\") != strPathName)
			{
				// 쐬fBNgݒ
				nStart = strPathName.Find('\\', nStart + 1);
				strMakePath = strPathName.Left(nStart);
				strNewPath = strMakePath;
				CFileStatus rStatus;
				// ̃sIh폜
				strNewPath.MakeReverse();
				int i; for (int i=0;i<strNewPath.GetLength();i++) {
					if (strNewPath[i] == '.') {
						strNewPath.Delete(0, 1);
						i--;
					} else break;
				}
				strNewPath.MakeReverse();
				if (strNewPath.GetLength() == 0)	res = false;
				// UNC
				if (strNewPath.GetLength() < 3 && strNewPath[0] == '\\' && strNewPath[1] == '\\')	continue;
				if (strNewPath.GetLength() == 2 && strNewPath[1] == ':')	continue;
				if (strFolder == strNewPath)	continue;
				// fBNg݂邩`FbN΍쐬
				DWORD dwAttr = GetFileAttributes(strNewPath);
				if (dwAttr == 0xFFFFFFFF || !(dwAttr & FILE_ATTRIBUTE_DIRECTORY)) {
				//if(!(CFile::GetStatus(strNewPath, rStatus) || (strNewPath.GetLength() == 2 && strNewPath.GetAt(1) == ':'))) {
					res = ::CreateDirectory(strNewPath, NULL);
					if (!res) break;
				}
			}
			if (!res) {
				MessageBox(strNewPath + " 쐬ł܂ł", "ړ/Rs[G[", MB_ICONSTOP|MB_OK|MB_TOPMOST);
				break;
			}
			strNewPath += _T("\\");
			SHFILEOPSTRUCT sfo;
			ZeroMemory(&sfo, sizeof(sfo));
			sfo.hwnd = GetSafeHwnd();
			sfo.wFunc = FO_MOVE;
			sfo.lpszProgressTitle = _T("ړĂ܂...");
			CDoubleZeroString strFile;
			strFile.Add(GetFileColumnText(fileMP3, COLUMN_FULL_PATH_NAME) + GetFileColumnText(fileMP3, COLUMN_FILE_NAME));
			{
				TCHAR	drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
				TCHAR	sLyricsFile[FILENAME_MAX+1];
				// MP3 t@CƓtH_ɂ̎t@C
				_tsplitpath(fileMP3->strFullPathName, drive, dir, fname, ext);
				// .lrc => .txt ̏Ō
				int i; for (i = 0; i < 2; i++) {
					LPSTR	sLyricsExt = (i == 0) ? ".lrc" : ".txt";
					_tmakepath(sLyricsFile, drive, dir, fname, sLyricsExt);
					if (GetFileAttributes(sLyricsFile) != 0xFFFFFFFF) {
						// t@C𔭌F̎t@C
						strFile.Add(sLyricsFile);
					}
				}
			}
			sfo.pFrom = strFile;
			sfo.pTo = strNewPath;
			sfo.fFlags = FOF_NOCONFIRMATION | FOF_SILENT /* BeachMonster4 116 */;
			if (nOverWriteFlag != 1) { /* STEP 041 */
				TCHAR	drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
				TCHAR	sDestFile[FILENAME_MAX+1];
				_tsplitpath(fileMP3->strFullPathName, drive, dir, fname, ext);
				_tmakepath(sDestFile, NULL, strNewPath, fname, ext);
				if (GetFileAttributes(sDestFile) != 0xFFFFFFFF) {
					CDlgFileOverWrite2	dialog;
					dialog.m_strFileName = sDestFile;
					CFileStatus	fileStatus;
					if (CFile::GetStatus(fileMP3->strFullPathName, fileStatus) == FALSE) {
						break;
					}
					dialog.m_strSize.Format("%ld byte", fileStatus.m_size);
					if (fileStatus.m_mtime.GetTime() < 0) {
						dialog.m_strTimeStamp.Format("----/--/-- --:--:--");
					} else {
						dialog.m_strTimeStamp.Format("%04d/%02d/%02d %02d:%02d:%02d",
													 fileStatus.m_mtime.GetYear(),
													 fileStatus.m_mtime.GetMonth(),
													 fileStatus.m_mtime.GetDay(),
													 fileStatus.m_mtime.GetHour(),
													 fileStatus.m_mtime.GetMinute(),
													 fileStatus.m_mtime.GetSecond());
					}
					dialog.DoModal();
					nOverWriteFlag = dialog.m_nResult;
					switch(dialog.m_nResult) {
					case 0:				// ̃t@C㏑
					case 1:				// ȍ~Sď㏑
						break;
					case 2:				// XLbv
						continue;
					case 3:				// ~
					default:
						continue;
					case 4:
						sfo.fFlags = sfo.fFlags | FOF_RENAMEONCOLLISION;
						sfo.pTo = strNewPath = dialog.m_strFileName;
						break;
					}
				}
			}
			if (isCopy) {
				sfo.wFunc = FO_COPY;
				sfo.lpszProgressTitle = _T("Rs[Ă܂...");
			}
			CString strStatus;
			if (isCopy) {
				strStatus.Format("%s  %s փRs[Ă܂ (%d/%d)", strFile.Get(0) /* FreeFall 047 */, strNewPath, i, nCount);
			} else {
				strStatus.Format("%s  %s ֈړĂ܂ (%d/%d)", strFile.Get(0) /* FreeFall 047 */, strNewPath, i, nCount);
			}
			((CMainFrame *)AfxGetMainWnd())->SetStatusBarText(strStatus);	// Xe[^Xo[ɐi󋵕\
			if (::SHFileOperation(&sfo) == 0) {
				strMoveFile.Add(strNewPath + GetFileColumnText(fileMP3, COLUMN_FILE_NAME));
			} else {
				break;
			}
		}
	}
	OnChangeSelect();	// Xe[^Xo[̕\ɖ߂
	// vOXo[I
	m_pDoc->EndLoadFile();
#ifndef mogtan
	if (isCopy) {
		return(true);
	}
#endif
#ifdef mogtan
	{
		CArray <int, const int &> arrayList;
		int		nCount;
		nCount = MakeSelectFileArray(arrayList);
		int fileCount=0;
		int i; for (i = 0; i < nCount; i++, fileCount++) {
			if (nCount > strMoveFile.GetSize()) continue;
			int		nIndex = arrayList[i];
			int		nNumber = (int)GetLParamFromIndex(nIndex);
					FILE_MP3	*fileMP3 = m_pDoc->GetListMP3(nNumber);
			if (nNumber >= 0) {
				CFileMP3	file;
				if (file.Attach(strMoveFile[fileCount])) {
					*fileMP3 = file.m_fileMP3;
					UpdateFileStatusFromIndex(nIndex, fileMP3);
				}
				m_pDoc->UpdateAllViews(NULL);
			}
		}
	}
#else
	{
		// ̂Xg폜
		CArray <int, const int &> arrayList;
		int		nCount;
		nCount = MakeSelectFileArray(arrayList);
		for (int i = nCount-1; i >= 0; i--) {
			if (nCount > strMoveFile.GetSize()) continue;
			int		nIndex = arrayList[i];
			int		nNumber = (int)GetLParamFromIndex(nIndex);
			if (nNumber >= 0) {
				FILE_MP3	*fileMP3 = m_pDoc->GetListMP3(nNumber);
				UpdateParentAtDeleteItem(nIndex, fileMP3);
				CFileMP3::InitData(fileMP3);
				DeleteItemFromIndex(nIndex);
			}
		}
		// SẴACȇI
		SelectAllItems(FALSE);
		m_pDoc->UpdateAllViews(NULL);
		// ̂Xgɒǉ
		for (i=0;i<strMoveFile.GetSize();i++) {
			m_pDoc->AddRequestFile(strMoveFile[i], NULL);
		}
		m_pDoc->StartLoadFile("loRt@Cǂݍݒ...");
#ifdef FLICKERFREE
		//SetRedraw(FALSE);
#endif
		m_pDoc->ExecRequestFiles(true, g_bOptLoadFileChecked);
#ifdef FLICKERFREE
		//SetRedraw(TRUE);
#endif
		m_pDoc->EndLoadFile();
		m_pDoc->UpdateAllViews(NULL);
	}
#endif
	return(true);
}

UINT CMySuperGrid::Time2Sec(CString strTime)
{
	int nIndex = strTime.Find(_T(':'));
	if (nIndex == -1) {
		return 0;
	}
	return _ttoi(strTime.Left(nIndex)) * 60 + _ttoi(strTime.Mid(nIndex+1));
}

void CMySuperGrid::UpdateParentAtDeleteItem(UINT nIndex, FILE_MP3 *fileMP3)
{
	CTreeItem *pItem = GetTreeItem(nIndex);
	CTreeItem *pItemParent = GetParentItem(pItem);
	CItemInfo *pInfo = GetData(pItemParent);

	/* RockDance 128 */
	if (g_bOptShowTotalParent) {
		CTreeItem* pTotalParent = pItemParent;
		while (pTotalParent != NULL) { /* TunamiStruck 007 */
			// Ȑ\
			CItemInfo	*pInfo = GetData(pTotalParent);
			CString strBuffer;
			CString strLeft, strRight;
			int		nIndex = NodeToIndex(pTotalParent);
			int		nColNum = g_nColumnNumberList[COLUMN_TRACK_NUMBER];
			if (nColNum >= 0) {
				strBuffer = pInfo->GetSubItem(nColNum-1);
				if ((pTotalParent == pItemParent || nIndex == 0) && strBuffer.Find("/") == -1) {
					strBuffer.Format("%d", atoi(strBuffer)-1);
				} else {
					if (strBuffer.Find("/") != -1) {
						strLeft = strBuffer.Left(strBuffer.Find("/"));
						strRight = strBuffer;
						strRight = strBuffer.Mid(strBuffer.Find("/")+1);
						if (pTotalParent != pItemParent) {
							strBuffer.Format("%s/%d", strLeft, atoi(strRight)-1);
						} else {
							strBuffer.Format("%d/%d", atoi(strLeft)-1, atoi(strRight)-1);
						}
					} else {
						if (pTotalParent == pItemParent) {
							ASSERT(0);
							//strBuffer.Format("%d/%d", atoi(strBuffer)-1, atoi(strBuffer)-1); // ȂH
						} else {
						if (atoi(strBuffer) > 1) {
							strBuffer.Format("%s/%d", strBuffer, atoi(strBuffer)-1);
						} else {
							strBuffer.Format("%s", strBuffer);
						}
						}
					}
				}
				pInfo->SetSubItemText(nColNum-1, strBuffer);
				SetItemText(nIndex, nColNum, strBuffer);
			}
			// tԍv\
			nColNum = g_nColumnNumberList[COLUMN_PLAY_TIME];
			if (nColNum >= 0) {
				strBuffer = GetFileColumnText(fileMP3, COLUMN_PLAY_TIME);
				UINT nTotalTime = Time2Sec(strBuffer);
				strBuffer = pInfo->GetSubItem(nColNum-1);
				if ((pTotalParent == pItemParent || nIndex == 0) && strBuffer.Find("/") == -1) {
					nTotalTime = Time2Sec(strBuffer) - nTotalTime;
					strBuffer.Format(_T("%d:%02d"), nTotalTime/60, nTotalTime%60);
				} else {
					if (strBuffer.Find("/") != -1) {
						strLeft = strBuffer.Left(strBuffer.Find("/"));
						strRight = strBuffer;
						strRight = strBuffer.Mid(strBuffer.Find("/")+1);
						if (pTotalParent != pItemParent) {
						} else {
							UINT nTotalTimeTemp = Time2Sec(strLeft) - nTotalTime;
							strLeft.Format(_T("%d:%02d"), nTotalTimeTemp/60, nTotalTimeTemp%60);
						}
						UINT nTotalTimeTemp = Time2Sec(strRight) - nTotalTime;
						strBuffer.Format(_T("%s/%d:%02d"), strLeft, nTotalTimeTemp/60, nTotalTimeTemp%60);
					} else {
						if (pTotalParent == pItemParent) {
							ASSERT(0);
							//nTotalTime = Time2Sec(strBuffer) - nTotalTime;
							//strLeft.Format(_T("%d:%02d"), nTotalTime/60, nTotalTime%60);
							//strBuffer.Format(_T("%s/%d:%02d"), strLeft, nTotalTime/60, nTotalTime%60);
						} else {
							nTotalTime = Time2Sec(strBuffer) - nTotalTime;
							if (nTotalTime > 0) {
								strBuffer.Format(_T("%s/%d:%02d"), strBuffer, nTotalTime/60, nTotalTime%60);
							} else {
								strBuffer.Format(_T("%s"), strBuffer);
							}
						}
					}
				}
				pInfo->SetSubItemText(nColNum-1, strBuffer);
				SetItemText(nIndex, nColNum, strBuffer);
			}
			//TCYv\
			nColNum = g_nColumnNumberList[COLUMN_FILE_SIZE];
			if (nColNum >= 0) {
				strBuffer = pInfo->GetSubItem(nColNum-1);
				strBuffer.TrimRight("MB");
				if ((pTotalParent == pItemParent || nIndex == 0) && strBuffer.Find("/") == -1) {
					strBuffer.Format("%.2fMB", atof(strBuffer) - (float)fileMP3->lFileSize / 1024 / 1024);
				} else {
					if (strBuffer.Find("/") != -1) {
						strLeft = strBuffer.Left(strBuffer.Find("/"));
						strRight = strBuffer;
						strRight = strBuffer.Mid(strBuffer.Find("/")+1);
						if (pTotalParent != pItemParent) {
							strBuffer.Format("%s/%.2fMB", strLeft, atof(strRight) - (float)fileMP3->lFileSize / 1024 / 1024);
						} else {
							strBuffer.Format("%.2fMB/%.2fMB", atof(strLeft) - (float)fileMP3->lFileSize / 1024 / 1024, atof(strRight) - (float)fileMP3->lFileSize / 1024 / 1024);
						}
					} else {
						if (pTotalParent == pItemParent) {
							ASSERT(0);
							//strBuffer.Format("%.2fMB/%.2fMB", atof(strBuffer) + (float)fileMP3->lFileSize / 1024 / 1024, atof(strBuffer) + (float)fileMP3->lFileSize / 1024 / 1024); // ȂH
						} else {
							strLeft.Format("%sMB", strBuffer);
							if ((atof(strBuffer) - (float)fileMP3->lFileSize / 1024 / 1024) > 0.0) {
								strRight.Format("%.2fMB", atof(strBuffer) - (float)fileMP3->lFileSize / 1024 / 1024);
								strBuffer.Format("%s/%s", strLeft, strRight);
							} else {
								strBuffer = strLeft;
							}
						}
					}
				}
				pInfo->SetSubItemText(nColNum-1, strBuffer);
				SetItemText(nIndex, nColNum, strBuffer);
			}
			pTotalParent = GetParentItem(pTotalParent);
		}
	}
}

void CMySuperGrid::SetHeaderFont(LOGFONT listFont)
{
	if (m_rootItemFont != NULL) {
		m_rootItemFont->Detach();
		delete m_rootItemFont;
	}
	CFont* pFont = new CFont();
	LOGFONT logFont;
	pFont->CreatePointFont(8 * 10, listFont.lfFaceName);
	pFont->GetLogFont(&logFont);
	logFont.lfWeight = FW_BOLD;
	pFont->Detach();
	pFont->CreateFontIndirect(&logFont);
	m_rootItemFont = pFont;
}

BOOL CMySuperGrid::OnToolTipNotify(UINT id, NMHDR *pNMHDR, LRESULT *pResult)
{
	if (!g_bOptShowTips)	return FALSE; /* Rumble 188 */

    CPoint pt;
    GetCursorPos(&pt);
    ScreenToClient(&pt);
	LVHITTESTINFO ht;
	ht.pt = pt;
	SubItemHitTest(&ht);
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
	if (ht.iItem > -1) {
		if (m_nPrevTipItem != ht.iItem || m_nPrevTipSubItem != ht.iSubItem) {
			TRACE1("CMySuperGrid::OnToolTipNotify [%d]\n", m_nPrevTipItem);
			TRACE1("CMySuperGrid::OnToolTipNotify [%d]\n", ht.iItem);
			TRACE1("CMySuperGrid::OnToolTipNotify [%d]\n", m_nPrevTipSubItem);
			TRACE1("CMySuperGrid::OnToolTipNotify [%d]\n", ht.iSubItem);
			m_nPrevTipItem = ht.iItem;
			m_nPrevTipSubItem = ht.iSubItem;
			CTreeItem *pItem = GetTreeItem(ht.iItem);
			CItemInfo *pInfo = GetData(pItem);
			CString strToolTip;
			if (ht.iSubItem == 0) {
				strToolTip = pInfo->GetItemText();
			} else {
				strToolTip = pInfo->GetSubItem(IndexToOrder(ht.iSubItem - 1));
			}
			//strToolTip.Remove(_T('\r'));
			{
				int i; for (int i=0;i<strToolTip.GetLength();i++) {
					if (_ismbblead(strToolTip[i])) {
						// [fBOoCg
						i++;
					} else {
						if (strToolTip[i] == '\r') {
							strToolTip.Delete(i);
							i--;
						}
					}
				}
			}
			if (strToolTip.GetLength() == 0) {
				m_toolTip.Pop();
				TRACE0("CMySuperGrid::OnToolTipNotify NO TOOLTIP1\n");
				m_nPrevTipItem = -1;
				m_nPrevTipSubItem = -1;
				return FALSE;
			}
			// ڍׂݒ
			if (strToolTip != "Root") {
				if (ItemHasChildren(pItem)) {
					int		nColNum = g_nColumnNumberList[COLUMN_TRACK_NUMBER];
					if (nColNum >= 0) {
						if (pInfo->GetSubItem(nColNum-1).GetLength() > 0) {
							strToolTip += (_T("\n[Track] ") + pInfo->GetSubItem(nColNum-1));
						}
					}
					nColNum = g_nColumnNumberList[COLUMN_PLAY_TIME];
					if (nColNum >= 0) {
						if (pInfo->GetSubItem(nColNum-1).GetLength() > 0) {
							strToolTip += (_T("\n[St] ") + pInfo->GetSubItem(nColNum-1));
						}
					}
					nColNum = g_nColumnNumberList[COLUMN_FILE_SIZE];
					if (nColNum >= 0) {
						if (pInfo->GetSubItem(nColNum-1).GetLength() > 0) {
							strToolTip += (_T("\n[TCYv] ") + pInfo->GetSubItem(nColNum-1));
						}
					}
				} else if ((int)pInfo->GetLParam() >= 0) {
					FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());
					strToolTip += (_T("\r[] ") + GetFileColumnText(fileMP3, COLUMN_TRACK_NAME));
					strToolTip += (_T("\n[è] ") + GetFileColumnText(fileMP3, COLUMN_ARTIST_NAME));
					strToolTip += (_T("\n[] ") + GetFileColumnText(fileMP3, COLUMN_ALBUM_NAME));
					strToolTip += (_T("\n[TrackNo] ") + GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER));
					strToolTip += (_T("\n[t] ") + GetFileColumnText(fileMP3, COLUMN_PLAY_TIME));
					strToolTip += (_T("\n[N] ") + GetFileColumnText(fileMP3, COLUMN_YEAR));
					strToolTip += (_T("\n[ެ] ") + GetFileColumnText(fileMP3, COLUMN_GENRE));
					CString strComment = GetFileColumnText(fileMP3, COLUMN_COMMENT);
					{
						BOOL bLead = FALSE;
						int i; for (int i=0;i<strComment.GetLength();i++) {
							if (_ismbblead(strComment[i])) {
								// [fBOoCg
								i++;
							} else {
								if (strComment[i] == '\r') {
									strComment.Delete(i);
									i--;
								}
							}
						}
					}
					//strComment.Remove(_T('\r'));
					strToolTip += (_T("\n[] ") + strComment);
					/* Conspiracy 198 */
					strComment = GetFileColumnText(fileMP3, COLUMN_FORMAT);
					{
						BOOL bLead = FALSE;
						int i; for (int i=0;i<strComment.GetLength();i++) {
							if (_ismbblead(strComment[i])) {
								// [fBOoCg
								i++;
							} else {
								if (strComment[i] == '\r') {
									strComment.Delete(i);
									i--;
								}
							}
						}
					}
					strToolTip += (_T("\n[̫ϯ] ") + strComment);
					strToolTip += (_T("\n[̧] ") + GetFileColumnText(fileMP3, COLUMN_FILE_NAME));
					strToolTip += (_T("\n[߽] ") + GetFileColumnText(fileMP3, COLUMN_FULL_PATH_NAME));
				}
			}
			//if (m_strToolTip != strToolTip) {
			//	m_toolTip.Pop();
			//}
			m_strToolTip = strToolTip;
			pTTT->lpszText = m_strToolTip.GetBuffer(0);
			return TRUE;
		} else {
			TRACE0("CMySuperGrid::OnToolTipNotify NO TOOLTIP\n");
			return FALSE;
		}
	}
	m_toolTip.Pop();
	m_nPrevTipItem = -1;
	m_nPrevTipSubItem = -1;
	TRACE0("CMySuperGrid::OnToolTipNotify RESET\n");
	return FALSE;
}

BOOL CMySuperGrid::OnNotifyMessage(WPARAM wParam, LPARAM lParam, LRESULT *pResult)
{
    CPoint pt;
    GetCursorPos(&pt);
    ScreenToClient(&pt);
	LVHITTESTINFO ht;
	ht.pt = pt;
	SubItemHitTest(&ht);
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)lParam;
	if (pTTT->hdr.idFrom == IDR_MAINFRAME && pTTT->hdr.code == 2222) {
		if (ht.iItem > -1) {
			if (m_nPrevTipItem != ht.iItem || m_nPrevTipSubItem != ht.iSubItem) {
				pTTT->uFlags = 9999;
				m_toolTip.Pop();
				m_nPrevTipItem = -1;
				m_nPrevTipSubItem = -1;
				return TRUE;
			}
		} else {
			m_toolTip.Pop();
			m_nPrevTipItem = -1;
			m_nPrevTipSubItem = -1;
		}
	}
	return TRUE;
}

BOOL CMySuperGrid::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if (!OnNotifyMessage(wParam, lParam, pResult)) {
		return TRUE;
	}
	return CListCtrl::OnNotify(wParam, lParam, pResult);
}

void CMySuperGrid::OnKillFocus(CWnd* pNewWnd)
{
	CListCtrl::OnKillFocus(pNewWnd);

	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if (m_toolTip) {
		m_toolTip.Pop();
		m_toolTip.Activate(FALSE);
		m_nPrevTipItem = -1;
		m_nPrevTipSubItem = -1;
	}
}

void CMySuperGrid::OnSetFocus(CWnd* pOldWnd)
{
	CListCtrl::OnSetFocus(pOldWnd);

	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	m_toolTip.Activate(TRUE);
}

void CMySuperGrid::SelectTreeColumn() /* TyphoonSwell 025 */
{
	int nSIndex /* STEP 008 */ = GetSelectedItem();
	if (nSIndex < 0) return;

	CTreeItem	*pItem = GetTreeItem(nSIndex);
	if (ItemHasChildren(pItem) == FALSE) {
		//return;
		pItem = GetParentItem(pItem); /* STEP 008 */
	}
	CArray <int, const int &> arrayList;
	int		nCount;
	int nIndex = NodeToIndex(pItem); /* STEP 008 */
	if (nIndex < 0) return; /* STEP 008 */
	POINT	save_posMultiSelect[2]; /* STEP 008 */
	save_posMultiSelect[0] = m_posMultiSelect[0]; /* STEP 008 */
	save_posMultiSelect[1] = m_posMultiSelect[1]; /* STEP 008 */
	nCount = MakeSelectFileArray(nIndex /* STEP 008 */, arrayList);
	if (nCount == 0) return;
	SelectRangeStart(nIndex /* STEP 008 */);
	m_posMultiSelect[0].y = nIndex;
	m_posMultiSelect[1].y = arrayList[nCount-1];
	if (m_posMultiSelect[0].x == 0) { /* SeaKnows 035 */
		SelItemRange(TRUE, m_posMultiSelect[0].y+1, m_posMultiSelect[1].y);
		OnChangeSelect(); /* WildCherry 072 */
		return;
	} else {
		SelItemRange(FALSE, -1, -1);
		/* STEP 008 *///SelItemRange(TRUE, m_posMultiSelect[0].y, m_posMultiSelect[0].y);
		/* WildCherry2 074 *///OnChangeSelect(); /* WildCherry 072 */
		SetItemState(nSIndex, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED); /* STEP 008 */
	}
	int i; for (int i=m_posMultiSelect[0].y;i<=m_posMultiSelect[1].y/* STEP 018 */;i++) {
		pItem = GetTreeItem(i);
		if (IsItemFile(pItem) != TRUE)	continue; /* STEP 018 */
		m_posMultiSelect[0].y = i;
		break;
	}
	InvalidateRangeItem(save_posMultiSelect[0].x, save_posMultiSelect[0].y, save_posMultiSelect[1].x, save_posMultiSelect[1].y); /* STEP 008 */
	InvalidateSelectRangeItem();
}

#ifdef FLICKERFREE
			CBrush br(RGB(0, 0, 0));
#endif
BOOL CMySuperGrid::OnDrawCustomCellBG(CDC *pDC, int nItem, int nColumn, RECT &rcItem) /* SeaKnows 036 */
{
	if (m_bMultiSelect) {
		int		sx, sy, ex, ey, nTemp;
		sx = m_posMultiSelect[0].x;
		sy = m_posMultiSelect[0].y;
		ex = m_posMultiSelect[1].x;
		ey = m_posMultiSelect[1].y;
		if (ex < sx) {nTemp = sx; sx = ex; ex = nTemp;}
		if (ey < sy) {nTemp = sy; sy = ey; ey = nTemp;}

		if (nColumn >= COLUMN_MIN && nItem >= sy && nItem <= ey && nColumn >= sx && nColumn <= ex) {
#ifndef FLICKERFREE
			CBrush br(RGB(0, 0, 0));
#endif
			/* STEP 028 */
			CTreeItem	*pSelItem = GetTreeItem(nItem);
			if (pSelItem != NULL) {
				CItemInfo	*pInfo = GetData(pSelItem);

				CONTROLTYPE ctrlType;
				if (pInfo->GetControlType(nColumn-1, ctrlType)) {
					if (ctrlType == invalid) {
						// ҏWs̂ߊDF
						CBrush br(RGB(192, 192, 192));
						pDC->FillRect(&rcItem, &br);
						return(TRUE);
					}
				}
			}
			pDC->FillRect(&rcItem, &br);
			return(TRUE);
		}
	} else if (g_bConfFileNameMaxCheck && g_bFileNameMaxCellColor) {
		CTreeItem	*pItem = GetTreeItem(nItem);
		if (pItem != NULL) {
			int		nType = g_nColumnTypeList[nColumn];
			if (nType >= 0 && nType < COLUMN_MAX) {
				if (nType == COLUMN_FILE_NAME && IsItemFile(pItem) == TRUE) {
					CString strFileName = GetItemText(nItem, nColumn);
					if (strFileName.GetLength() > g_nConfFileNameMaxChar) {
						CBrush br(RGB(128, 0, 0));
						pDC->FillRect(&rcItem, &br);
						return(TRUE);
					}
				}
			}
		}
	}
	return(FALSE);

}

void CMySuperGrid::CheckFileNameMax() /* SeaKnows 037 */
{
	int nIndex = GetSelectedItem();
	if (nIndex < 0) return;

	CTreeItem	*pItem = GetTreeItem(nIndex);
	CArray <int, const int &> arrayList;
	int		nCount;
	nCount = MakeSelectFileArray(arrayList);
	if (nCount == 0) return;
	int i; for (int i=0;i<nCount;i++) {
		int		nIndex = arrayList[i];
		int		nNumber = (int)GetLParamFromIndex(nIndex);
		if (!(nNumber >= 0))	continue;
		FILE_MP3	*fileMP3 = m_pDoc->GetListMP3(nNumber);
		if (fileMP3->strFileName.GetLength() > g_nConfFileNameMaxChar) {
			// t@CI[o[
			TCHAR	fname[_MAX_FNAME], ext[_MAX_EXT];
			_tsplitpath(fileMP3->strFileName, NULL, NULL, fname, ext);
			CDlgFileNameChange dialog;
			dialog.m_nMaxChar = g_nConfFileNameMaxChar - strlen(ext);
			dialog.m_strFileName = fname;
			dialog.m_strOrgFileName = fname;
			//dialog.m_strMsg.Format("t@C %d ȓɕύXĂ", dialog.m_nMaxChar);
			dialog.m_strMsgFormat = "t@C %d(%d) ȓɕύXĂ";
			if (dialog.DoModal() == IDOK) {
				ChangeSubItemText(nIndex, g_nColumnNumberList[COLUMN_FILE_NAME], dialog.m_strFileName + ext);
				InvalidateItemRect(nIndex);
			}
		}
	}
	//InvalidateSelectRangeItem();
}

int CMySuperGrid::GetSelectedItem() /* WildCherry3 083 */
{
	int iItem =GetNextItem(-1, LVNI_ALL | LVNI_SELECTED | LVIS_FOCUSED);
	if (iItem == -1) {
		iItem = GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	}
	return iItem;
}

CString CMySuperGrid::ConvHTML(CString& str, bool bConv) /* BeachMonster4 120 */
{
	if (!bConv) {
		return str;
	}
	CString strText = str;
	strText.Replace("&", "&amp;");
	strText.Replace(" ", "&nbsp;");
	strText.Replace("<", "&lt;");
	strText.Replace(">", "&gt;");
	strText.Replace("\"", "&quot;");
	strText = StrReplace(strText, "\r\n", "<BR>");
	return strText;
}

CString CMySuperGrid::quoteForComment(CString &str) /* RockDance 124 */
{
	if (str.IsEmpty()) {
		return str;
	}
	if (str.Find("\r\n") != -1 || str[0] == '"') {
		str.Replace("\"", "\"\"");
		str = '"' + str + '"';
	}
	return str;
}

bool CMySuperGrid::isOneCellClipboard(CString strBuffer) /* RockDance 124 */
{
	// Nbv{[h擾f[^PZ̃f[^`FbN
	//strBuffer.Replace("\"\"", ""); // "" ͖
	int		nLength = strBuffer.GetLength();
	if (nLength == 0) return true;

	//if (ey >= GetItemCount()) ey = GetItemCount() - 1;
	int nCount = 0;
	// I͈͂̃Z̓e𕶎ɕϊ
	char	*pBuffer = strBuffer.GetBuffer(nLength);
	int		nPos = 0;
	while (true) {
		// Ps̃obt@擾
		char	*pLineTop = pBuffer + nPos;
		int nQuote = 0;
		nPos--;
		do {
			nPos++;
			while(pBuffer[nPos] != '\r' && pBuffer[nPos] != '\0') {
				if (pBuffer[nPos] == '"') {
					nQuote++;
				}
				nPos++;
			}
		} while (nQuote % 2 != 0);
		//bool bCR = pBuffer[nPos] == '\r' ? true : false;
		pBuffer[nPos] = '\0';
		nPos++;

		char	*pStr;
		if ((pStr = GetToken(pLineTop, "\t")) != NULL) {
			nCount++;
			while (true) {
				if ((pStr = GetToken(NULL, "\t")) != NULL) {
					nCount++;
				} else {
					break;
				}
			}
		}

		// [CR] [LF] ̎cXLbv
		while(pBuffer[nPos] == '\n') {
			nPos++;
		}

		if (nPos >= nLength) {
			// obt@̕񂪖Ȃ
			break;
		}
	}
	return nCount > 1 ? false : true;
}

CString CMySuperGrid::unquoteForComment(CString str) /* RockDance 124 */
{
	if (str.IsEmpty()) {
		return str;
	}
	if (str[0] == '"') {
		str.Delete(0);
		str.Delete(str.GetLength()-1);
		str.Replace("\"\"", "\""); // ""  " ɂ
	}
	return str;
}

int CMySuperGrid::GetFolderFileCount(int nIndex) /* STEP 007 */
{
	if (nIndex < 0) return 0;

	CTreeItem	*pItemParent = GetTreeItem(nIndex);
	CItemInfo	*pInfo = GetData(pItemParent);
	if (!((int)pInfo->GetLParam() < 0)) {
		return 0;
	}
	return GetFolderFileCount(pItemParent, pItemParent, 0);
}

int CMySuperGrid::GetFolderFileCount(CTreeItem* pTop, CTreeItem *pItemParent, int fileCount) /* STEP 007 */
{
	//if (!g_bOptShowTotalParent)	return; /* STEP 004 */
	//POSITION pos = pItemParent ? GetHeadPosition(pItemParent) : GetRootHeadPosition();
	int count = fileCount;
	POSITION pos = GetHeadPosition(pItemParent);
	while(pos != NULL) {
		//CTreeItem	*pParent = (CTreeItem*)(pItemParent ? GetNextChild(pItemParent, pos) : GetNextRoot(pos));
		CTreeItem	*pParent = (CTreeItem*)GetNextChild(pItemParent, pos);
		CTreeItem	*pItem = pParent;
		CItemInfo	*lp = GetData(pParent);
		if ((int)lp->GetLParam() < 0) {
			//  t@_
			//count = GetFolderFileCount(pTop, pParent, count);
			continue; // TutH_͑ΏۂƂȂ
		} else {
			//FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)lp->GetLParam());
			CTreeItem* pTotalParent = pItemParent;
			while (pTotalParent != NULL) {
				count++;
				if (pTotalParent == pTop) {
					break;
				}
				pTotalParent = GetParentItem(pTotalParent);
			}
		}
	}
	return count;
}

void CMySuperGrid::CalcSum(int nIndex) /* RockDance 128 */
{
	if (nIndex < 0) return;

	CTreeItem	*pItemParent = GetTreeItem(nIndex);
	CItemInfo	*pInfo = GetData(pItemParent);
	if (!((int)pInfo->GetLParam() < 0)) {
		return;
	}
	int		nColNum = g_nColumnNumberList[COLUMN_TRACK_NUMBER];
	if (nColNum >= 0) {
		pInfo->SetSubItemText(nColNum-1, "");
		SetItemText(nIndex, nColNum, "");
	}
	nColNum = g_nColumnNumberList[COLUMN_PLAY_TIME];
	if (nColNum >= 0) {
		pInfo->SetSubItemText(nColNum-1, "");
		SetItemText(nIndex, nColNum, "");
	}
	nColNum = g_nColumnNumberList[COLUMN_FILE_SIZE];
	if (nColNum >= 0) {
		pInfo->SetSubItemText(nColNum-1, "");
		SetItemText(nIndex, nColNum, "");
	}
	CalcSum(pItemParent, pItemParent);
}

void CMySuperGrid::CalcSum(CTreeItem* pTop, CTreeItem *pItemParent) /* RockDance 128 */
{
	//if (!g_bOptShowTotalParent)	return; /* STEP 004 */
	//POSITION pos = pItemParent ? GetHeadPosition(pItemParent) : GetRootHeadPosition();
	POSITION pos = GetHeadPosition(pItemParent);
	while(pos != NULL) {
		//CTreeItem	*pParent = (CTreeItem*)(pItemParent ? GetNextChild(pItemParent, pos) : GetNextRoot(pos));
		CTreeItem	*pParent = (CTreeItem*)GetNextChild(pItemParent, pos);
		CTreeItem	*pItem = pParent;
		CItemInfo	*lp = GetData(pParent);
		if ((int)lp->GetLParam() < 0) {
			//  t@_
			int		nIndex = NodeToIndex(pParent);
			int		nColNum = g_nColumnNumberList[COLUMN_TRACK_NUMBER];
			if (nColNum >= 0) {
				lp->SetSubItemText(nColNum-1, "");
				SetItemText(nIndex, nColNum, "");
			}
			nColNum = g_nColumnNumberList[COLUMN_PLAY_TIME];
			if (nColNum >= 0) {
				lp->SetSubItemText(nColNum-1, "");
				SetItemText(nIndex, nColNum, "");
			}
			nColNum = g_nColumnNumberList[COLUMN_FILE_SIZE];
			if (nColNum >= 0) {
				lp->SetSubItemText(nColNum-1, "");
				SetItemText(nIndex, nColNum, "");
			}
			CalcSum(pTop, pParent);
		} else {
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)lp->GetLParam());
			CTreeItem* pTotalParent = pItemParent;
			while (pTotalParent != NULL) {
				// Ȑ\
				CItemInfo	*pInfo = GetData(pTotalParent);
				CString strBuffer;
				CString strLeft, strRight;
				int		nIndex = NodeToIndex(pTotalParent);
				int		nColNum = g_nColumnNumberList[COLUMN_TRACK_NUMBER];
				if (nColNum >= 0) {
					strBuffer = pInfo->GetSubItem(nColNum-1);
					if ((pTotalParent == pItemParent || nIndex == 0) && strBuffer.Find("/") == -1) {
						strBuffer.Format("%d", atoi(strBuffer)+1);
					} else {
						if (strBuffer.Find("/") != -1) {
							strLeft = strBuffer.Left(strBuffer.Find("/"));
							strRight = strBuffer;
							strRight = strBuffer.Mid(strBuffer.Find("/")+1);;
							strBuffer.Format("%d/%d", atoi(strLeft) + (pTotalParent == pItemParent ? 1 : 0), atoi(strRight)+1);
						} else {
							if (pTotalParent == pItemParent) {
								ASSERT(0);
							} else {
								CString strOrg = strBuffer;
								strBuffer.Format("%s/%d", strOrg, atoi(strBuffer)+1);
							}
						}
					}
					pInfo->SetSubItemText(nColNum-1, strBuffer);
					SetItemText(nIndex, nColNum, strBuffer);
				}
				// tԍv\
				nColNum = g_nColumnNumberList[COLUMN_PLAY_TIME];
				if (nColNum >= 0) {
					strBuffer = GetFileColumnText(fileMP3, COLUMN_PLAY_TIME);
					UINT nTotalTime = Time2Sec(strBuffer);
					strBuffer = pInfo->GetSubItem(nColNum-1);
					if ((pTotalParent == pItemParent || nIndex == 0) && strBuffer.Find("/") == -1) {
						nTotalTime += Time2Sec(strBuffer);
						strBuffer.Format(_T("%d:%02d"), nTotalTime/60, nTotalTime%60);
					} else {
						if (strBuffer.Find("/") != -1) {
							strLeft = strBuffer.Left(strBuffer.Find("/"));
							if (pTotalParent == pItemParent) {
								UINT nTime = nTotalTime;
								nTime += Time2Sec(strLeft);
								strLeft.Format("%d:%02d", nTime/60, nTime%60);
							}
							strRight = strBuffer;
							strRight = strBuffer.Mid(strBuffer.Find("/")+1);;
							nTotalTime += Time2Sec(strRight);
							strBuffer.Format(_T("%s/%d:%02d"), strLeft, nTotalTime/60, nTotalTime%60);
						} else {
							if (pTotalParent == pItemParent) {
								ASSERT(0);
							} else {
								nTotalTime += Time2Sec(strBuffer);
								CString strOrg = strBuffer;
								strBuffer.Format(_T("%s/%d:%02d"), strOrg, nTotalTime/60, nTotalTime%60);
							}
						}
					}
					pInfo->SetSubItemText(nColNum-1, strBuffer);
					SetItemText(nIndex, nColNum, strBuffer);
				}
				//TCYv\
				nColNum = g_nColumnNumberList[COLUMN_FILE_SIZE];
				if (nColNum >= 0) {
					strBuffer = pInfo->GetSubItem(nColNum-1);
					strBuffer.TrimRight("MB");
					if ((pTotalParent == pItemParent || nIndex == 0) && strBuffer.Find("/") == -1) {
						strBuffer.Format("%.2fMB", atof(strBuffer) + (float)fileMP3->lFileSize / 1024 / 1024);
					} else {
						if (strBuffer.Find("/") != -1) {
							strLeft = strBuffer.Left(strBuffer.Find("/"));
							if (pTotalParent == pItemParent) {
								strLeft.Format("%.2fMB", atof(strLeft) + (float)fileMP3->lFileSize / 1024 / 1024);
							}
							strRight = strBuffer;
							strRight = strBuffer.Mid(strBuffer.Find("/")+1);;
							strBuffer.Format("%s/%.2fMB", strLeft, atof(strRight) + (float)fileMP3->lFileSize / 1024 / 1024);
						} else {
							if (pTotalParent == pItemParent) {
								ASSERT(0);
							} else {
								strLeft.Format("%sMB", strBuffer);
								strRight.Format("%.2fMB", atof(strBuffer) + (float)fileMP3->lFileSize / 1024 / 1024);
								strBuffer.Format("%s/%s", strLeft, strRight);
							}
						}
					}
					pInfo->SetSubItemText(nColNum-1, strBuffer);
					SetItemText(nIndex, nColNum, strBuffer);
				}
				if (pTotalParent == pTop) {
					break;
				}
				pTotalParent = GetParentItem(pTotalParent);
			}
		}
	}
}

void CMySuperGrid::OnUpdateTotal()
{
	if (!g_bOptShowTotalParent)	return; /* STEP 004 */
	CalcSum(0);
}

bool CMySuperGrid::ClipboardPaste(int nPastePos, bool bAddSpace, const CString& strAddFront, const CString& strAddBack/* FunnyCorn 187 */) /* Baja 171 */
{
	// Nbv{[hJăeLXg擾
	HANDLE	hMem;
	OpenClipboard();
	/* RockDance 124 *///hMem = ::GetClipboardData(CF_TEXT);
	bool bText = false; /* RockDance 124 */
	hMem = ::GetClipboardData(STEClipbordFormat/*CF_DSPTEXT*//* Misirlou 146 */); /* RockDance 124 */
	if (hMem == NULL) { /* RockDance 124 */
		hMem = ::GetClipboardData(CF_TEXT);
		bText = true;
	}
	CloseClipboard();

	if (hMem != NULL) {
		LPSTR pBuffer;
		if ((pBuffer = (LPSTR)GlobalLock(hMem)) != NULL) {
			/* RockDance 124 *///PasteString(pBuffer);
#ifdef FLICKERFREE
			//SetRedraw(FALSE);
#endif
			if (strlen(pBuffer) > 0) { /* STEP 033 */
				PasteString(pBuffer, nPastePos, bText, bAddSpace/* Baja 171 */, strAddFront, strAddBack/* FunnyCorn 187 */); /* RockDance 124 */
			}
#ifdef FLICKERFREE
			//SetRedraw(TRUE);
#endif
			GlobalUnlock(hMem);
		}
	}

	return(true);

}

void CMySuperGrid::PasteString(char *sBuffer, int nPastePos, bool bText, bool bAddSpace, const CString& strAddFront, const CString& strAddBack/* FunnyCorn 187 */) /* Baja 171 */
{
	bool bSaveLoadFileAdjustColumn = g_bOptLoadFileAdjustColumn; /* RockDance 130 */
	g_bOptLoadFileAdjustColumn = false; /* RockDance 130 */

	int		sx, sy, ex, ey;
	if (IsRangeSelected() == false) {
		if (GetSelectedItem() == -1) return;	// G[
		if (GetCurSubItem() < COLUMN_MIN) return;		// G[
		// ͈͑I𖳂
		sx = GetCurSubItem();
		sy = GetSelectedItem();
		ex = ey = 99999;
	} else {
		// ͈͑I
		int		nTemp;
		sx = m_posMultiSelect[0].x;
		sy = m_posMultiSelect[0].y;
		ex = m_posMultiSelect[1].x;
		ey = m_posMultiSelect[1].y;
		if (ex < sx) {nTemp = sx; sx = ex; ex = nTemp;}
		if (ey < sy) {nTemp = sy; sy = ey; ey = nTemp;}
		if (sx <= COLUMN_MIN) sx = COLUMN_MIN;

		// Ō̉s菜
		int		nLen = strlen(sBuffer);
		while(nLen > 0 && (sBuffer[nLen-1] == '\r' || sBuffer[nLen-1] == '\n')) {
			nLen--;
			sBuffer[nLen] = '\0';
		}
		// ^us܂܂Ă邩H
		 /* RockDance 124 *///if (strchr(sBuffer, '\t') == NULL && strchr(sBuffer, '\n') == NULL) {
		if ((bText == true && strchr(sBuffer, '\t') == NULL && strchr(sBuffer, '\n') == NULL) || (bText == false && isOneCellClipboard(sBuffer))) {  /* RockDance 124 */
			CString	strBuffer = sBuffer;
			// ܂܂ĂȂꍇ́AIĂ͈͑SĂɃy[Xg
			for (int nItem = sy; nItem <= ey; nItem++) {
				CTreeItem	*pItem = GetTreeItem(nItem);
				if (pItem != NULL && IsItemFile(pItem) == TRUE) {
					CItemInfo	*pItemInfo = GetData(pItem);
					for (int nColumn = sx; nColumn <= ex; nColumn++) {
						// Zɕݒ
						/* RockDance 124 *///ChangeSubItemText(nItem, nColumn, strBuffer, nPastePos/* FreeFall 052 */);
						if (bText) { /* RockDance 124 */
							ChangeSubItemText(nItem, nColumn, strBuffer, nPastePos, bAddSpace, strAddFront, strAddBack);
						} else {
							ChangeSubItemText(nItem, nColumn, unquoteForComment(strBuffer), nPastePos, bAddSpace, strAddFront, strAddBack);
						}
#ifdef FLICKERFREE
						//InvalidateItemRect(nItem);
#endif
					}
				}
			}
#ifdef FLICKERFREE
			InvalidateRangeItem(sx, sy, ex, ey);
			InvalidateRangeItem(0, sy, 0, ey);
#endif
			/* RockDance 130 */
			g_bOptLoadFileAdjustColumn = bSaveLoadFileAdjustColumn;
			for (int nColumn = sx; nColumn <= ex; nColumn++) {
				if (g_bOptLoadFileAdjustColumn) AutoSizeColumns(nColumn);
			}
			return;
		}
	}

#ifdef FLICKERFREE
	SetRedraw(FALSE);
#endif

	CString	strBuffer(sBuffer);
	int		nLength = strBuffer.GetLength();
	if (nLength == 0) return;

	if (ey >= GetItemCount()) ey = GetItemCount() - 1;

	// I͈͂̃Z̓e𕶎ɕϊ
	char	*pBuffer = strBuffer.GetBuffer(nLength);
	int		nPos = 0;
	int		nEndColumn = 0; /* RockDance 130 */
	for (int nItem = sy; nItem <= ey; nItem++) {
		CTreeItem	*pItem = GetTreeItem(nItem);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			CItemInfo	*pItemInfo = GetData(pItem);

			// Ps̃obt@擾
			char	*pLineTop = pBuffer + nPos;
			if (bText == false ) { /* RockDance 124  */
				int nQuote = 0;
				nPos--;
				do {
					nPos++;
					while(pBuffer[nPos] != '\r' && pBuffer[nPos] != '\0') {
						if (pBuffer[nPos] == '"') {
							nQuote++;
						}
						nPos++;
					}
					if (nPos > nLength) {
						// Ȃ
						ASSERT(0);
						break;
					}
				} while (nQuote % 2 != 0);
			} else {
				while(pBuffer[nPos] != '\r' && pBuffer[nPos] != '\0') {
					nPos++;
				}
			}
			/* RockDance 124 *//*
			while(pBuffer[nPos] != '\r' && pBuffer[nPos] != '\0') {
				nPos++;
			}*/
			pBuffer[nPos] = '\0';
			nPos++;
			//while(pBuffer[nPos] != '\r' && pBuffer[nPos] != '\0') {
			//	nPos++;
			//}

			char	*pStr;
			if ((pStr = GetToken(pLineTop, "\t")) != NULL) {
				for (int nColumn = sx; nColumn <= ex; nColumn++) {
					nEndColumn = nColumn; /* RockDance 130 */
					// Zɕݒ
					/* RockDance 124 *///ChangeSubItemText(nItem, nColumn, pStr, nPastePos/* FreeFall 052 */);
					if (bText) { /* RockDance 124 */
						ChangeSubItemText(nItem, nColumn, pStr, nPastePos, bAddSpace, strAddFront, strAddBack);
					} else {
						ChangeSubItemText(nItem, nColumn, unquoteForComment(CString(pStr)), nPastePos, bAddSpace, strAddFront, strAddBack);
					}
#ifdef FLICKERFREE
					//InvalidateItemRect(nItem);
#endif

					// ̃Z̕擾
					if ((pStr = GetToken(NULL, "\t")) == NULL) break;
				}
			}

			// [CR] [LF] ̎cXLbv
			while(pBuffer[nPos] == '\n') {
				nPos++;
			}

			if (nPos >= nLength) {
				// obt@̕񂪖Ȃ
				break;
			}
		}
	}
#ifdef FLICKERFREE
	InvalidateRangeItem(sx, sy, ex, ey);
	InvalidateRangeItem(0, sy, 0, ey);
#endif
	/* RockDance 130 */
	g_bOptLoadFileAdjustColumn = bSaveLoadFileAdjustColumn;
	for (int nColumn = sx; nColumn <= nEndColumn; nColumn++) {
		if (g_bOptLoadFileAdjustColumn) AutoSizeColumns(nColumn);
	}
#ifdef FLICKERFREE
	SetRedraw(TRUE);
#endif
}

void CMySuperGrid::ChangeSubItemText(int iItem, int iSubItem, const char *sUpdateText, int nPos, bool bAddSpace, const CString& strAddFront, const CString& strAddBack/* FunnyCorn 187 */, bool bUpdateInternal/* STEP 037 */)
{
	if (iItem != -1 && iSubItem > 0 && sUpdateText/* sText FreeFall 052 */ != NULL) {
		CTreeItem	*pSelItem = GetTreeItem(iItem);

		if (pSelItem != NULL) {
			CItemInfo	*pInfo = GetData(pSelItem);

			// ύXs̃Z̏ꍇ́A
			CONTROLTYPE ctrlType;
			if (pInfo->GetControlType(iSubItem-1, ctrlType)) {
				if (ctrlType == invalid && !bUpdateInternal) {
					return;
				}
			}

			// tH_
			if ((int)pInfo->GetLParam() < 0) return;

			CString sText = sUpdateText;
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());
			CString strOrgText = GetFileColumnText(fileMP3, g_nColumnTypeList[iSubItem]);
			switch (nPos) {
			case 0:
				sText = strAddFront + sUpdateText + strAddBack;
				break;
			case 1:
				sText = strAddFront + sUpdateText + strAddBack + ((bAddSpace ? " " : "") +  strOrgText);
				break;
			case 2:
				sText = strOrgText + (bAddSpace ? " " : "") + strAddFront + sUpdateText + strAddBack;
				{/* Baja 158 */
					/*
					CString sText2 = strOrgText;
					sText = sUpdateText;
					sText.Insert(0, sText2);
					*/
				}
				break;
			}
			CString		strText;

			// `FbN
			int		nLimit = OnGetColumLimitText(iItem, iSubItem);
			if (nLimit < (int)strlen(sText)) {
				// ő啶Ɏ܂悤ɒ
				char*	sBuffer = new char[nLimit+1];
				StringCopyN(sBuffer, sText, nLimit);
				sBuffer[nLimit] = '\0';
				strText = sBuffer;
				delete [] sBuffer;
			} else {
				// ő啶ȉȂ̂ł̂܂
				strText = sText;
			}
			strText.TrimRight();

			switch(g_nColumnTypeList[iSubItem]) {
			case COLUMN_FILE_NAME:		// t@C
				{
					// OɂȂ'\','/'_tsplitpath()ŃpX؂ƂĔFĂ܂ /* WildCherry2 077 */
					if (g_nOptCheckFileName == FILENAME_CONV_MULTIBYTE) {
						// t@CɎgpłȂu
						strText = ReplaceFileName(fileMP3, strText);
					}
					// gqꍇ́Agqt
					TCHAR	extOrg[_MAX_EXT];
					TCHAR	fname[_MAX_FNAME], ext[_MAX_EXT];
					_tsplitpath(fileMP3->strFullPathName, NULL, NULL, NULL, extOrg);
					_tsplitpath(strText, NULL, NULL, fname, ext);
					extern bool CheckFileExt(const FILE_MP3* pFileMP3, const char* ext);
					if (/*strlen(ext) != 4 ||*/ !CheckFileExt(fileMP3, ext)
					)/*
					||  !(strcmpi(ext, ".mp3") == 0 || strcmpi(ext, ".rmp") == 0 ||
						  strcmpi(ext, ".wma") == 0 || strcmpi(ext, ".wmv") == 0 ||
						  strcmpi(ext, ".asf") == 0 ||
						  strcmpi(ext, ".ape") == 0 ||
						  strcmpi(ext, ".wav") == 0 || strcmpi(ext, ".avi") == 0 || /* Conspiracy 197 *//*
						  strcmpi(ext, ".ogg") == 0)) {//C by Kobarin
					*/
						strText += extOrg;
					/*}*/

					// Ɉړ /* WildCherry2 077 */
					// gqϊ̂ߍēxĂяo /* STEP 006 */
					if (g_nOptCheckFileName == FILENAME_CONV_MULTIBYTE) {
						// t@CɎgpłȂu
						strText = ReplaceFileName(fileMP3, strText);
					}
				}
				if (fileMP3->strFileName != strText) {
					fileMP3->strFileName = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_FILE_TIME:		// t@CXV
				if (g_bOptKeepTimeStamp == true) {
					CTime	time = fileMP3->time;
					// ͂ꂽ^CX^v
					if (strText.GetLength() > 0) {
						char	*sBuffer = new char[strText.GetLength()+1];
						char	*ptr;
						strcpy(sBuffer, sText);
						int		nYear = 2000, nMonth = 1, nDay = 1, nHour = 0, nMin = 0, nSec = 0;
						if ((ptr = strtok(sBuffer, "/")) != NULL) {		// N
							nYear = atoi(ptr);
						}
						if (ptr && (ptr = strtok(NULL, "/")) != NULL) {	// 
							nMonth = atoi(ptr);
						}
						if (ptr && (ptr = strtok(NULL, " ")) != NULL) {	// 
							nDay = atoi(ptr);
						}
						if (ptr && (ptr = strtok(NULL, ":")) != NULL) {	// 
							nHour = atoi(ptr);
						}
						if (ptr && (ptr = strtok(NULL, ":")) != NULL) {	// 
							nMin = atoi(ptr);
						}
						if (ptr && (ptr = strtok(NULL, "")) != NULL) {	// b
							nSec = atoi(ptr);
						}
						delete[]	sBuffer;
						// ͂ꂽl𒲐
						if (nYear < 1971) nYear = 1971;
						// { 1970 NA1970/01/01 00:00:00  CTime 
						//   Assert ̂ŁA1971 NƂ
						if (nYear > 2037) nYear = 2037;
						if (nMonth <  1) nMonth = 1;
						if (nMonth > 12) nMonth = 12;
						if (nDay <  1) nDay = 1;
						if (nDay > 31) nDay = 31;
						if (nHour <  0) nHour = 0;
						if (nHour > 23) nHour = 23;
						if (nMin <  0) nMin = 0;
						if (nMin > 59) nMin = 59;
						if (nSec <  0) nSec = 0;
						if (nSec > 59) nSec = 59;
						//nSec &= ~1;
						// ͂ꂽԂݒ
						time = CTime(nYear, nMonth, nDay, nHour, nMin, nSec);
					}

					// XVH
					if (fileMP3->time != time) {
						fileMP3->time = time;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
					strText.Format("%04d/%02d/%02d %02d:%02d:%02d",
					               fileMP3->time.GetYear(), fileMP3->time.GetMonth(), fileMP3->time.GetDay(),
					               fileMP3->time.GetHour(), fileMP3->time.GetMinute(), fileMP3->time.GetSecond());
				}
				break;

			case COLUMN_TRACK_NAME:		// gbN
				if (IsEditFieldSIF(fileMP3)) {
					if (fileMP3->strTrackNameSI != strText) {
						fileMP3->strTrackNameSI = strText;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				} else {
					if (fileMP3->strTrackName != strText) {
						fileMP3->strTrackName = strText;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				}
				break;

			case COLUMN_ARTIST_NAME:	// A[eBXg
				if (IsEditFieldSIF(fileMP3)) {
					if (fileMP3->strArtistNameSI != strText) {
						fileMP3->strArtistNameSI = strText;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				} else {
					if (fileMP3->strArtistName != strText) {
						fileMP3->strArtistName = strText;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				}
				break;

			case COLUMN_ALBUM_NAME:		// Ao
				if (IsEditFieldSIF(fileMP3)) {
					if (fileMP3->strAlbumNameSI != strText) {
						fileMP3->strAlbumNameSI = strText;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				} else {
					if (fileMP3->strAlbumName != strText) {
						fileMP3->strAlbumName = strText;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				}
				break;

			case COLUMN_TRACK_NUMBER:	// gbNԍ
				if (!IsEditTrackNumberSIF(fileMP3) && !CFileMP3::IsNumeric(strText)) {
					int		nTrackNumber;
					nTrackNumber = atoi(CFileMP3::GetIntTrackNo(strText));
					if (nTrackNumber < 0) nTrackNumber = 0;
					if (nTrackNumber > 255) nTrackNumber = 254;
					strText.Format("%d", nTrackNumber);
				}
				if (IsEditTrackNumberSIF(fileMP3)) {
					if (fileMP3->strTrackNumberSI != strText) {
						fileMP3->strTrackNumberSI = strText;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				} else {
					int		nTrackNumber;
					if (strText.IsEmpty() != TRUE) {
						nTrackNumber = atoi(CFileMP3::GetIntTrackNo(strText));
						if (nTrackNumber < 0) nTrackNumber = 0;
						if (nTrackNumber > 255) nTrackNumber = 254;
						if (nTrackNumber == 0) {
							nTrackNumber = 0xFF;
							strText = "";
						} else if (!IsEditTrackNumberSIF(fileMP3)) {
							strText.Format("%d", nTrackNumber);
						}
					} else {
						nTrackNumber = 0xFF;
					}
					if (fileMP3->strTrackNumber != strText || fileMP3->byTrackNumber != nTrackNumber) {
						fileMP3->strTrackNumber = strText;
						fileMP3->byTrackNumber = nTrackNumber;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				}
				break;

			case COLUMN_DISK_NUMBER:	// fBXNԍ
				if (!IsEditFieldSIF(fileMP3) && !CFileMP3::IsNumeric(strText)) {
					int		nDiskNumber;
					nDiskNumber = atoi(CFileMP3::GetIntDiskNo(strText));
					if (nDiskNumber < 0) nDiskNumber = 0;
					if (nDiskNumber > 255) nDiskNumber = 254;
					strText.Format("%d", nDiskNumber);
				}
				if (IsEditFieldSIF(fileMP3)) {
					if (fileMP3->strDiskNumberSI != strText) {
						fileMP3->strDiskNumberSI = strText;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				} else {
					int		nDiskNumber;
					if (strText.IsEmpty() != TRUE) {
						nDiskNumber = atoi(CFileMP3::GetIntDiskNo(strText));
						if (nDiskNumber < 0) nDiskNumber = 0;
						if (nDiskNumber > 255) nDiskNumber = 254;
						if (nDiskNumber == 0) {
							nDiskNumber = 0xFF;
							strText = "";
						} else if (!IsEditFieldSIF(fileMP3)) {
							strText.Format("%d", nDiskNumber);
						}
					} else {
						nDiskNumber = 0xFF;
					}
					if (fileMP3->strDiskNumber != strText || fileMP3->byDiskNumber != nDiskNumber) {
						fileMP3->strDiskNumber = strText;
						fileMP3->byDiskNumber = nDiskNumber;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				}
				break;

			case COLUMN_YEAR:			// [XN
				if (IsEditFieldSIF(fileMP3)) {
					if (fileMP3->strYearSI != strText) {
						fileMP3->strYearSI = strText;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				} else {
					if (fileMP3->strYear != strText) {
						fileMP3->strYear = strText;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				}
				break;

			case COLUMN_GENRE:			// Wԍ
				if (!IsEditGenreSIF(fileMP3) && IsUserGenre(strText)) {
					int		nGenre = GetGenreCode(strText);
					strText = GetGenreNameSIF(nGenre);
				}
				if (IsEditGenreSIF(fileMP3)) {
					if (fileMP3->strGenreSI != strText) {
						fileMP3->strGenreSI = strText;
						fileMP3->bModifyFlag = TRUE;
					}
				} else {
					int		nGenre = GetGenreCode(strText);
					if (strText.IsEmpty()) {		// ̕(=NA)
						nGenre = 0xff;
						strText = GetGenreNameSIF(nGenre);
					}
					if (fileMP3->strGenre != strText) {
						fileMP3->byGenre = (BYTE)nGenre;
						if (!IsEditGenreSIF(fileMP3)) {
							fileMP3->strGenre = GetGenreNameSIF(nGenre);//strText;
						} else {
							fileMP3->strGenre = strText;
						}
						fileMP3->bModifyFlag = TRUE;
					}
				}
				break;

			case COLUMN_COMMENT:		// Rg
				if (IsEditFieldSIF(fileMP3)) {
					if (fileMP3->strCommentSI != strText) {
						fileMP3->strCommentSI = strText;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				} else {
					if (fileMP3->strComment != strText) {
						fileMP3->strComment = strText;
						fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
					}
				}
				break;

			case COLUMN_COPYRIGHT:		// 쌠
				if (fileMP3->strCopyrightSI != strText) {
					fileMP3->strCopyrightSI = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_ENGINEER:		// GWjA()
				if (fileMP3->strEngineerSI != strText) {
					fileMP3->strEngineerSI = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_SOURCE:			// \[X
				if (fileMP3->strSourceSI != strText) {
					fileMP3->strSourceSI = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_SOFTWARE:		// \tgEFA
				if (fileMP3->strSoftwareSI != strText) {
					fileMP3->strSoftwareSI = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_KEYWORD:		// L[[h
				if (fileMP3->strKeywordSI != strText) {
					fileMP3->strKeywordSI = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_TECHNICIAN:		// Zp
				if (fileMP3->strTechnicianSI != strText) {
					fileMP3->strTechnicianSI = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_LYRIC:			// ̎
				if (fileMP3->strLyricSI != strText) {
					fileMP3->strLyricSI = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_COMMISSION:		// R~bV
				if (fileMP3->strCommissionSI != strText) {
					fileMP3->strCommissionSI = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_WRITER:		// 쎌 /* ADD MIMURA */
				if (fileMP3->strWriterSI != strText) {
					fileMP3->strWriterSI = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_COMPOSER:		//  /* Baja 154 */
				if (fileMP3->strComposerSI != strText) {
					fileMP3->strComposerSI = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_ALBM_ARTIST:	// Orig.A[eBXg /* Baja 154 */
				if (fileMP3->strAlbmArtistSI != strText) {
					fileMP3->strAlbmArtistSI = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_ORIG_ARTIST:	// Orig.A[eBXg /* Baja 154 */
				if (fileMP3->strOrigArtistSI != strText) {
					fileMP3->strOrigArtistSI = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_URL:		// URL /* Baja 154 */
				if (fileMP3->strURLSI != strText) {
					fileMP3->strURLSI = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_ENCODEST:		// GR[hl /* Baja 154 */
				if (fileMP3->strEncodest != strText) {
					fileMP3->strEncodest = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;

			case COLUMN_OTHER:		// ̑
				if (fileMP3->strOther != strText) {
					fileMP3->strOther = strText;
					fileMP3->bModifyFlag = TRUE;	// ҏWtOݒ肷
				}
				break;
			}

			// ZeXV
			if (!bUpdateInternal) { /* STEP 037 */
				pInfo->SetSubItemText(iSubItem-1, strText);
				UpdateData(pSelItem, pInfo);
				SetItemText(iItem, iSubItem, strText);

				// J̎
				if (g_bOptLoadFileAdjustColumn) AutoSizeColumns(iSubItem);
			}
		}
	}
}

void CMySuperGrid::ClipboardCopyFormat(USER_COPY_FORMAT_FORMAT *pForm) /* FunnyCorn 175 */
{
	if (pForm->strFormat.IsEmpty()) {
		// 
		return;
	}

	CArray <int, const int &> arrayList;
	int		nCount;
	nCount = MakeSelectFileArray(arrayList);
	/*
	int		sx, sy, ex, ey;
	// I͈͂擾
	if (GetSelectedRange(sx, sy, ex, ey) == false) {
		return(false);					// ͈͑I𖳂
	}
	*/

	// Œ蕶͂
	if (pForm->strFormat.Find("%STRING%") != -1) {
		CDlgFixedString	dialog;
		dialog.m_strText = pForm->strFixString;
		if (dialog.DoModal() == IDCANCEL) {
			// LZ
			return;
		}
		pForm->strFixString = dialog.m_strText;
	}

	CStringArray strMoveFile;
	// Aԕϊ̐ݒ
	//char	*sNumFormat = "%01d";
	//sNumFormat[2] = '0' + pForm->nColumnCount;

	//int		nNumber = pForm->nInitNumber;
	CString strClipboard = "";
	int i; for (int i=0;i<nCount;i++) {
		int		nIndex = arrayList[i];
		int		nNumber = (int)GetLParamFromIndex(nIndex);
		if (!(nNumber >= 0))	continue;
		FILE_MP3	*fileMP3 = m_pDoc->GetListMP3(nNumber);

		// t@Cgq擾
		CString	strFileName = GetFileColumnText(fileMP3, COLUMN_FILE_NAME);
		TCHAR	sFileName[_MAX_FNAME];
		_tsplitpath(strFileName, NULL, NULL, sFileName, NULL);
		CString strExt;
		{
			TCHAR	ext[_MAX_EXT];
			_tsplitpath(fileMP3->strFileName, NULL, NULL, NULL, ext);
			strExt = &ext[1];
			strExt.MakeUpper();
		}

		CString	strText = pForm->strFormat;
		CString	strTrackNumber, strTrackNumber2, strTrackNumber3, strDiskNumber, strDiskNumber2, strDiskNumber3;

		// P̃gbNԍ
		strTrackNumber.Format("%d", atoi(CFileMP3::GetIntTrackNo(GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER).SpanExcluding("\r"))));
		// Q̃gbNԍ
		strTrackNumber2.Format("%02d", atoi(CFileMP3::GetIntTrackNo(GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER).SpanExcluding("\r"))));
		// R̃gbNԍ
		strTrackNumber3.Format("%03d", atoi(CFileMP3::GetIntTrackNo(GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER).SpanExcluding("\r"))));

		// P̃fBXNԍ
		strDiskNumber.Format("%d", atoi(CFileMP3::GetIntDiskNo(GetFileColumnText(fileMP3, COLUMN_DISK_NUMBER).SpanExcluding("\r"))));
		// Q̃fBXNԍ
		strDiskNumber2.Format("%02d", atoi(CFileMP3::GetIntDiskNo(GetFileColumnText(fileMP3, COLUMN_DISK_NUMBER).SpanExcluding("\r"))));
		// R̃fBXNԍ
		strDiskNumber3.Format("%03d", atoi(CFileMP3::GetIntDiskNo(GetFileColumnText(fileMP3, COLUMN_DISK_NUMBER).SpanExcluding("\r"))));

		// gĕ쐬
		strText = StrReplace(strText, "%FILE_NAME%"    , sFileName);
		strText = StrReplace(strText, "%TRACK_NAME%"   , GetFileColumnText(fileMP3, COLUMN_TRACK_NAME).SpanExcluding("\r"));
		strText = StrReplace(strText, "%ALBUM_NAME%"   , GetFileColumnText(fileMP3, COLUMN_ALBUM_NAME).SpanExcluding("\r"));
		strText = StrReplace(strText, "%ARTIST_NAME%"  , GetFileColumnText(fileMP3, COLUMN_ARTIST_NAME).SpanExcluding("\r"));
		strText = StrReplace(strText, "%TRACK_NUMBER%" , strTrackNumber);
		strText = StrReplace(strText, "%TRACK_NUMBER2%", strTrackNumber2);
		strText = StrReplace(strText, "%TRACK_NUMBER3%", strTrackNumber3);
		strText = StrReplace(strText, "%DISK_NUMBER%" , strDiskNumber);
		strText = StrReplace(strText, "%DISK_NUMBER2%", strDiskNumber2);
		strText = StrReplace(strText, "%DISK_NUMBER3%", strDiskNumber3);
		strText = StrReplace(strText, "%RELEASE_YEAR%" , GetFileColumnText(fileMP3, COLUMN_YEAR).SpanExcluding("\r"));
		strText = StrReplace(strText, "%COMMENT%"      , GetFileColumnText(fileMP3, COLUMN_COMMENT).SpanExcluding("\r"));
		strText = StrReplace(strText, "%GENRE%"        , GetFileColumnText(fileMP3, COLUMN_GENRE).SpanExcluding("\r"));
		//strText = StrReplace(strText, "%NUMBER%"       , strNumber);
		strText = StrReplace(strText, "%STRING%"       , pForm->strFixString);

		// t
		CString strBuffer;
		if (fileMP3->nPlayTime >= 0) { /* Conspiracy 195 */
			strBuffer.Format("%02d:%02d", fileMP3->nPlayTime/60, fileMP3->nPlayTime%60);
		} else {
			strBuffer = "     ";
		}
		strText = StrReplace(strText, "%TOTAL_SEC%", strBuffer);
		// t /* STEP 020 */
		if (fileMP3->nPlayTime >= 0 && fileMP3->nPlayTime/60/60 > 0) {
			strBuffer.Format("%d:%02d:%02d", fileMP3->nPlayTime/60/60, (fileMP3->nPlayTime/60)%60, fileMP3->nPlayTime%60);
		}
		strText = StrReplace(strText, "%TOTAL_SEC3%", strBuffer);
		// t(b)
		if (fileMP3->nPlayTime >= 0) { /* Conspiracy 195 */
			strBuffer.Format("%d", fileMP3->nPlayTime);
		} else {
			strBuffer = "     ";
		}
		strText = StrReplace(strText, "%TOTAL_SEC2%", strBuffer);
		// tH[}bg
		{ /* STEP 012 */
			CString strFormat = fileMP3->strVisualFormat;
			if (strFormat.GetLength() > 0 && fileMP3->strAudioFormat.GetLength() > 0) {
				strFormat += "\n";
			}
			strFormat += fileMP3->strAudioFormat;
			strText = StrReplace(strText, "%FORMAT%", strFormat);
		}

		// R[hiꕔjXy[Xɒu
		strText = StrReplace(strText, "\n", " ");
		strText = StrReplace(strText, "\r", " ");
		//strText = StrReplace(strText, "\t", " ");

		if (!strClipboard.IsEmpty()) {
			strClipboard += "\r\n";
		}
		strClipboard += strText;
	}
	LPSTR pBuffer;
	HGLOBAL hMem;
	hMem = GlobalAlloc(GHND|GMEM_DDESHARE, strClipboard.GetLength()+1);
	pBuffer = (LPSTR)GlobalLock(hMem);
	strcpy(pBuffer, strClipboard);
	GlobalUnlock(hMem);

	// Nbv{[hJăRs[
	OpenClipboard();
	::EmptyClipboard();
	::SetClipboardData(CF_TEXT, (HANDLE)hMem);
	CloseClipboard();

	return;
}

bool CMySuperGrid::DeleteCharSpace(int /*nPos*/) /* FunnyCorn 177 */
{
	int		sx, sy, ex, ey;
	// I͈͂擾
	if (GetSelectedRange(sx, sy, ex, ey) == false) {
		return(false);					// ͈͑I𖳂
	}

	for (int nItem = sy; nItem <= ey; nItem++) {
		CTreeItem	*pItem = GetTreeItem(nItem);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			CItemInfo	*pInfo = GetData(pItem);
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());
			for (int nColumn = sx; nColumn <= ex; nColumn++) {
				CString	strText;
				TCHAR	fname[_MAX_FNAME], ext[_MAX_EXT];
				bool	bKeepExt = false;

				// Z̃eLXg擾
				strText = GetFileColumnText(fileMP3, g_nColumnTypeList[nColumn]);

				// t@C̏ꍇAgqSpɕϊȂ悤ɂ
				if (g_nColumnTypeList[nColumn] == COLUMN_FILE_NAME) {
					_tsplitpath(strText, NULL, NULL, fname, ext);
					extern bool CheckFileExt(const FILE_MP3* pFileMP3, const char* ext);
					if (/*strlen(ext) == 4 && */CheckFileExt(fileMP3, ext)
					) {/*
					&&	(strcmpi(ext, ".mp3") == 0 || strcmpi(ext, ".rmp") == 0 ||
						 strcmpi(ext, ".wma") == 0 || strcmpi(ext, ".wmv") == 0 ||
						 strcmpi(ext, ".asf") == 0 ||
						 strcmpi(ext, ".ape") == 0 ||
						 strcmpi(ext, ".wav") == 0 || strcmpi(ext, ".avi") == 0 || /* Conspiracy 197 *//*
						 strcmpi(ext, ".ogg") == 0)) {
					*/
						// gq菜
						strText = fname;
						bKeepExt = true;
					}
				}


				int nLength;
				do {
					nLength = strText.GetLength();
					strText.TrimLeft(" ");
					strText.TrimLeft("\t");
					if (strText.GetLength() > 1) {
						CString strChar = strText[0];
						strChar += strText[1];
						if (strChar == "@") {
							strText.Delete(0, 2);
						}
					}
				} while (nLength != strText.GetLength());
				do {
					nLength = strText.GetLength();
					strText.TrimRight(" ");
					strText.TrimRight("\t");
					if (strText.GetLength() > 1) {
						CString strChar = strText[strText.GetLength()-2];
						strChar += strText[strText.GetLength()-1];
						if (strChar == "@") {
							strText.Delete(strText.GetLength()-2, 2);
						}
					}
				} while (nLength != strText.GetLength());
				// 菜ĂgqtȂ
				if (bKeepExt) {
					strText += ext;
				}

				ChangeSubItemText(nItem, nColumn, strText);
				InvalidateItemRect(nItem);
			}
		}
	}
	return(true);
}

CString CMySuperGrid::MakeFormatFileBody(FILE_MP3	*fileMP3, const CString &strBody, bool bIsHtml, LIST_WRITE_STATUS *pStatus, bool bWriteHtml)
{
	int		nTrackNumber;
	CString	strTrackNumber;
	CString	strTrackNumber2;
	CString	strTrackNumber3;
	if ((nTrackNumber = atoi(CFileMP3::GetIntTrackNo(GetFileColumnText(fileMP3, COLUMN_TRACK_NUMBER)))) != 0) {
		strTrackNumber.Format("%d", nTrackNumber);
		strTrackNumber2.Format("%02d", nTrackNumber);
		strTrackNumber3.Format("%03d", nTrackNumber);
	}

	int		nDiskNumber;
	CString	strDiskNumber;
	CString	strDiskNumber2;
	CString	strDiskNumber3;
	if ((nTrackNumber = atoi(CFileMP3::GetIntDiskNo(GetFileColumnText(fileMP3, COLUMN_DISK_NUMBER)))) != 0) {
		strDiskNumber.Format("%d", nDiskNumber);
		strDiskNumber2.Format("%02d", nDiskNumber);
		strDiskNumber3.Format("%03d", nDiskNumber);
	}

	CString	strFileSize, strFileSizeByte;
	strFileSize.Format("%.2fMB", (float)fileMP3->lFileSize / 1024 / 1024);
	strFileSizeByte.Format("%d", fileMP3->lFileSize);
	CString	strFileTime;
	strFileTime.Format("%04d/%02d/%02d %02d:%02d:%02d",
					  fileMP3->time.GetYear(), fileMP3->time.GetMonth(), fileMP3->time.GetDay(),
					  fileMP3->time.GetHour(), fileMP3->time.GetMinute(), fileMP3->time.GetSecond());
	CString	strFileTimeCreate;
	strFileTimeCreate.Format("%04d/%02d/%02d %02d:%02d:%02d",
							 fileMP3->timeCreate.GetYear(), fileMP3->timeCreate.GetMonth(), fileMP3->timeCreate.GetDay(),
							 fileMP3->timeCreate.GetHour(), fileMP3->timeCreate.GetMinute(), fileMP3->timeCreate.GetSecond());

	CString	strFileNumber;
	strFileNumber.Format("%d", 1 + pStatus->nFileNumber);

	CString	strPlayPath;
	strPlayPath = ConvFileName(fileMP3->strFullPathName, pStatus->strDirectory);

	CString	strLyricFile;
	strLyricFile = CFileMP3::SearchLyricsFile(fileMP3);

	 /* Baja 162 */
	CString strExt;
	{
		TCHAR	ext[_MAX_EXT];
		_tsplitpath(fileMP3->strFileName, NULL, NULL, NULL, ext);
		strExt = &ext[1];
		strExt.MakeUpper();
	}
	/* Rumble 191 */
	CString strFileNameShort;
	{
		DWORD size = GetShortPathName(fileMP3->strFilePath + fileMP3->strFileName, NULL, 0);
		GetShortPathName(fileMP3->strFilePath + fileMP3->strFileName, strFileNameShort.GetBufferSetLength(size+1), size+1);
		strFileNameShort.ReleaseBuffer();
		TCHAR	fname[_MAX_FNAME], ext[_MAX_EXT];
		_tsplitpath(strFileNameShort, NULL, NULL, fname, ext);
		strFileNameShort = fname;
		strFileNameShort += ext;
	}
	/* Rumble 191 */
	CString strPathNameShort;
	{
		DWORD size = GetShortPathName(fileMP3->strFilePath, NULL, 0);
		GetShortPathName(fileMP3->strFilePath, strPathNameShort.GetBufferSetLength(size+1), size+1);
		strPathNameShort.ReleaseBuffer();
	}
	/* Rumble 191 */
	CString strFullPathShort;
	{
		DWORD size = GetShortPathName(fileMP3->strFullPathName, NULL, 0);
		GetShortPathName(fileMP3->strFullPathName, strFullPathShort.GetBufferSetLength(size+1), size+1);
		strFullPathShort.ReleaseBuffer();
	}
	/* Rumble 191 */
	CString	strPlayPathShort;
	{
		DWORD size = GetShortPathName(fileMP3->strFullPathName, NULL, 0);
		GetShortPathName(fileMP3->strFullPathName, strPlayPathShort.GetBufferSetLength(size+1), size+1);
		strPlayPathShort.ReleaseBuffer();
		CString strDirShort;
		size = GetShortPathName(pStatus->strDirectory, NULL, 0);
		GetShortPathName(pStatus->strDirectory, strDirShort.GetBufferSetLength(size+1), size+1);
		strDirShort.ReleaseBuffer();
		strPlayPathShort = ConvFileName(strPlayPathShort, strDirShort);
	}
	/* Rumble 191 */
	CString	strLyricFileShort;
	{
		DWORD size = GetShortPathName(strLyricFile, NULL, 0);
		GetShortPathName(strLyricFile, strLyricFileShort.GetBufferSetLength(size+1), size+1);
		strLyricFileShort.ReleaseBuffer();
	}


	// gĕ쐬
	CString	strText = strBody;
	strText = StrReplaceEx(strText, "%FILE_NUMBER%"     , strFileNumber, bIsHtml);
	strText = StrReplaceEx(strText, "%FILE_TYPE%"       , GetFileType(fileMP3), bIsHtml);
	strText = StrReplaceEx(strText, "%FILE_NAME%"       , ConvHTML(fileMP3->strFileName, bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%FILE_NAME_SHORT%" , ConvHTML(strFileNameShort, bWriteHtml), bIsHtml); /* Rumble 191 */
	strText = StrReplaceEx(strText, "%PATH_NAME%"       , ConvHTML(fileMP3->strFilePath, bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%PATH_NAME_SHORT%" , ConvHTML(strPathNameShort, bWriteHtml), bIsHtml); /* Rumble 191 */
	strText = StrReplaceEx(strText, "%FULL_PATH%"       , ConvHTML(fileMP3->strFullPathName, bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%FULL_PATH_SHORT%" , ConvHTML(strFullPathShort, bWriteHtml), bIsHtml); /* Rumble 191 */
	strText = StrReplaceEx(strText, "%PLAY_PATH%"       , ConvHTML(strPlayPath, bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%PLAY_PATH_SHORT%"       , ConvHTML(strPlayPathShort, bWriteHtml), bIsHtml); /* Rumble 191 */
	strText = StrReplaceEx(strText, "%TRACK_NAME%"      , ConvHTML(GetFileColumnText(fileMP3, COLUMN_TRACK_NAME), bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%ALBUM_NAME%"      , ConvHTML(GetFileColumnText(fileMP3, COLUMN_ALBUM_NAME), bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%ARTIST_NAME%"     , ConvHTML(GetFileColumnText(fileMP3, COLUMN_ARTIST_NAME), bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%TRACK_NUMBER%"    , strTrackNumber, bIsHtml);
	strText = StrReplaceEx(strText, "%TRACK_NUMBER2%"   , strTrackNumber2, bIsHtml);
	strText = StrReplaceEx(strText, "%TRACK_NUMBER3%"   , strTrackNumber3, bIsHtml);
	strText = StrReplaceEx(strText, "%DISK_NUMBER%"    , strDiskNumber, bIsHtml);
	strText = StrReplaceEx(strText, "%DISK_NUMBER2%"   , strDiskNumber2, bIsHtml);
	strText = StrReplaceEx(strText, "%DISK_NUMBER3%"   , strDiskNumber3, bIsHtml);
	strText = StrReplaceEx(strText, "%RELEASE_YEAR%"    , ConvHTML(GetFileColumnText(fileMP3, COLUMN_YEAR), bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%COMMENT%"         , ConvHTML(GetFileColumnText(fileMP3, COLUMN_COMMENT), bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%GENRE%"           , ConvHTML(GetFileColumnText(fileMP3, COLUMN_GENRE), bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%FILE_SIZE%"       , strFileSize, bIsHtml);
	strText = StrReplaceEx(strText, "%FILE_SIZE_BYTE%"  , ConvNumber(strFileSizeByte), bIsHtml);
	strText = StrReplaceEx(strText, "%FILE_TIME%"       , strFileTime, bIsHtml);
	strText = StrReplaceEx(strText, "%FILE_CTIME%"      , strFileTimeCreate, bIsHtml);
	strText = StrReplaceEx(strText, "%EXIST_LYRIC_FILE%", strLyricFile.IsEmpty() ? "Ȃ" : "", bIsHtml);
	strText = StrReplaceEx(strText, "%LYRIC_FILE_NAME%" , ConvHTML(strLyricFile, bWriteHtml), bIsHtml); /* Rumble 191 */
	strText = StrReplaceEx(strText, "%LYRIC_FILE_NAME_SHORT%" , ConvHTML(strLyricFileShort, bWriteHtml), bIsHtml); /* Rumble 191 */
	strText = StrReplaceEx(strText, "%FILE_EXTENSION%"  , strExt, bIsHtml); /* Baja 162 */
	// SIF ̏
	strText = StrReplaceEx(strText, "%COPYRIGHT%"       , ConvHTML(fileMP3->strCopyrightSI, bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%ENGINEER%"        , ConvHTML(fileMP3->strEngineerSI, bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%SOURCE%"          , ConvHTML(fileMP3->strSourceSI, bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%SOFTWARE%"        , ConvHTML(fileMP3->strSoftwareSI, bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%KEYWORD%"         , ConvHTML(fileMP3->strKeywordSI, bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%TECHNICIAN%"      , ConvHTML(fileMP3->strTechnicianSI, bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%LYRIC%"           , ConvHTML(fileMP3->strLyricSI, bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%COMMISSION%"      , ConvHTML(fileMP3->strCommissionSI, bWriteHtml)/* BeachMonster5 120 */, bIsHtml);
	strText = StrReplaceEx(strText, "%WRITER%"			, ConvHTML(fileMP3->strWriterSI, bWriteHtml), bIsHtml); /* Baja 154 */
	strText = StrReplaceEx(strText, "%COMPOSER%"		, ConvHTML(fileMP3->strComposerSI, bWriteHtml), bIsHtml); /* Baja 154 */
	strText = StrReplaceEx(strText, "%ALBM_ARTIST%"		, ConvHTML(fileMP3->strAlbmArtistSI, bWriteHtml), bIsHtml); /* Baja 154 */
	strText = StrReplaceEx(strText, "%ORIG_ARTIST%"		, ConvHTML(fileMP3->strOrigArtistSI, bWriteHtml), bIsHtml); /* Baja 154 */
	strText = StrReplaceEx(strText, "%URL%"				, ConvHTML(fileMP3->strURLSI, bWriteHtml), bIsHtml); /* Baja 154 */
	strText = StrReplaceEx(strText, "%ENCODEST%"		, ConvHTML(fileMP3->strEncodest, bWriteHtml), bIsHtml); /* Baja 154 */
	strText = StrReplaceEx(strText, "%OTHER%"			, ConvHTML(fileMP3->strOther, bWriteHtml), bIsHtml); /* Conspiracy 196 */

	// t
	CString strBuffer;
	if (fileMP3->nPlayTime >= 0) { /* Conspiracy 195 */
		strBuffer.Format("%02d:%02d", fileMP3->nPlayTime/60, fileMP3->nPlayTime%60);
	} else {
		strBuffer = "     ";
	}
	strText = StrReplaceEx(strText, "%TOTAL_SEC%", strBuffer, bIsHtml);
	// t /* STEP 020 */
	if (fileMP3->nPlayTime >= 0 && fileMP3->nPlayTime/60/60 > 0) {
		strBuffer.Format("%d:%02d:%02d", fileMP3->nPlayTime/60/60, (fileMP3->nPlayTime/60)%60, fileMP3->nPlayTime%60);
	}
	strText = StrReplaceEx(strText, "%TOTAL_SEC3%", strBuffer, bIsHtml);
	// t(b) /* FunnyCorn 172 */
	if (fileMP3->nPlayTime >= 0) { /* Conspiracy 195 */
		strBuffer.Format("%d", fileMP3->nPlayTime);
	} else {
		strBuffer = "     ";
	}
	strText = StrReplaceEx(strText, "%TOTAL_SEC2%", strBuffer, bIsHtml);
	// tH[}bg
	{ /* STEP 012 */
		CString strFormat = fileMP3->strVisualFormat;
		if (strFormat.GetLength() > 0 && fileMP3->strAudioFormat.GetLength() > 0) {
			strFormat += "\n";
		}
		strFormat += fileMP3->strAudioFormat;
		strText = StrReplaceEx(strText, "%FORMAT%", strFormat, bIsHtml);
	}

	if (fileMP3->nPlayTime >= 0) { /* Conspiracy 195 */
		pStatus->nTotalTime += fileMP3->nPlayTime; /* Baja 163 */
	}
	pStatus->fTotalSize += (float)fileMP3->lFileSize;
	pStatus->nFileNumber++;
	pStatus->nFileCount++;

	return strText;
}

CString CMySuperGrid::MakeFormatFileFoot(const CString &strFoot, bool bIsHtml, LIST_WRITE_STATUS *pStatus, bool bWriteHtml) /* Rumble 190 */
{
	// t@C
	CString	strFileCount;
	strFileCount.Format("%d", pStatus->nFileCount);

	// vt
	int		nMinute = pStatus->nTotalTime / 60;
	CString	strTotalTime, strTotalTime2;
	strTotalTime.Format("%02d:%02d", nMinute, pStatus->nTotalTime % 60);
	if ((nMinute/60) > 0) {
		strTotalTime2.Format("%02d:%02d:%02d", nMinute / 60, nMinute % 60, pStatus->nTotalTime % 60);
	} else {
		strTotalTime2 = strTotalTime;
	}

	// vt@CTCY
	CString	strTotalSize;
	strTotalSize.Format("%.2fMB", (float)pStatus->fTotalSize / 1024 / 1024);

	// gĕ쐬
	CString	strText = strFoot;
	strText = StrReplaceEx(strText, "%FILE_COUNT%", strFileCount, bIsHtml);
	strText = StrReplaceEx(strText, "%TOTAL_TIME%", strTotalTime, bIsHtml);
	strText = StrReplaceEx(strText, "%TOTAL_TIME2%", strTotalTime2, bIsHtml);
	strText = StrReplaceEx(strText, "%TOTAL_SIZE%", strTotalSize, bIsHtml);

	return strText;
}

CString CMySuperGrid::WriteFormatFileHeader(CFile &file, CTreeItem *pItem, const CString &strHead, bool bIsHtml, LIST_WRITE_STATUS *pStatus, bool bWriteHtml) /* Rumble 190 */
{
	ASSERT(pItem != NULL);
	CString strText = strHead;

	if (pItem != NULL) {
		CItemInfo *pInfo = GetData(pItem);
		int		nIndex = NodeToIndex(pItem);
		if (IsItemFile(pItem) == TRUE) {
			// t@C̏ꍇ
			CItemInfo	*pInfo = GetData(pItem);
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());

			strText = MakeFormatFileBody(fileMP3, strText, bIsHtml, pStatus, bWriteHtml);
		} else {
			// tH_̏ꍇ
			// qACeSď
			if (ItemHasChildren(pItem) == TRUE) {
				CTreeItem *pSelItem = pItem;
				if (ItemHasChildren(pSelItem)) {
					POSITION pos = GetHeadPosition(pSelItem);
					while(pos != NULL) {
						strText = /* Hurricane 216 */ WriteFormatFileHeader(file, (CTreeItem *)GetNextChild(pSelItem, pos), strText, bIsHtml, pStatus, bWriteHtml);
					}
				}
			}
		}
	}

	return strText;
}

bool CMySuperGrid::ProcessSelectedFiles(LPCTSTR szProgressBarTitle, STEPProcessSelectedFilesCB* callback)
{
	CWaitCursor	wait;
	// IĂt@CSď
	CArray <int, const int &> arrayList;
	int		nCount;
	nCount = MakeSelectFileArray(arrayList);

	// vOXo[
	if (szProgressBarTitle != NULL) {
		m_pDoc->StartLoadFile(szProgressBarTitle);
		m_pDoc->GetDlgLoadProgressBarPtr()->SetDlgItemText(IDC_ST_MESSAGE, "΂炭҂...");
	}

	extern	int		g_nWriteTagProcFlag;
	g_nWriteTagProcFlag = 0;
	int i; for (i = 0; i < nCount; i++) {
		int		nIndex = arrayList[i];

		// vOXo[XV
		if (szProgressBarTitle != NULL) {
			if (nCount > 1) {
				m_pDoc->GetDlgLoadProgressBarPtr()->SetPos(i * 100 / (nCount-1));
			}
		}

		// s
		CTreeItem	*pItem = GetTreeItem(nIndex);
		CItemInfo	*pInfo = pItem ? GetData(pItem) : NULL;
		if (pItem != NULL && pInfo != NULL) {
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());

			FILE_INFO info;
			info.pFileMP3 = fileMP3;
			bool result = (*callback)(&info, g_nWriteTagProcFlag, GetSafeHwnd());
			if (result == false) {
				// ~
				break;
			}
		}
	}

	// vOXo[I
	if (szProgressBarTitle != NULL) {
		m_pDoc->EndLoadFile();
	}

	m_pDoc->UpdateAllFiles(true);

	return true;
}

bool CMySuperGrid::ProcessSelectedFilesForUpdate(LPCTSTR szProgressBarTitle, STEPProcessSelectedFilesCB* callback)
{
	bool result = true;
	CWaitCursor	wait;
	// IĂt@CSď
	CArray <int, const int &> arrayList;
	int		nCount;
	nCount = MakeSelectFileArray(arrayList);

	// vOXo[
	if (szProgressBarTitle != NULL) {
		m_pDoc->StartLoadFile(szProgressBarTitle);
		m_pDoc->GetDlgLoadProgressBarPtr()->SetDlgItemText(IDC_ST_MESSAGE, "΂炭҂...");
	}

	extern	int		g_nWriteTagProcFlag;
	g_nWriteTagProcFlag = 0;
	int i; for (i = 0; i < nCount; i++) {
		int		nIndex = arrayList[i];

		// vOXo[XV
		if (szProgressBarTitle != NULL) {
			if (nCount > 1) {
				m_pDoc->GetDlgLoadProgressBarPtr()->SetPos(i * 100 / (nCount-1));
			}
		}

		// s
		CTreeItem	*pItem = GetTreeItem(nIndex);
		CItemInfo	*pInfo = pItem ? GetData(pItem) : NULL;
		if (pItem != NULL && pInfo != NULL) {
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());

			// XV̕ۑ
			// ǂݎ葮̃`FbN
			bool	bKeepTimeStamp = g_bOptKeepTimeStamp;
			CFileStatus	fileStatus;
			if (CFile::GetStatus(fileMP3->strFullPathName, fileStatus) == FALSE) {
				return false;
			}
			if (fileStatus.m_attribute & CFile::readOnly) {
				if (g_nWriteTagProcFlag != 1) {
					// ㏑mF_CAOJ
					CDlgFileOverWrite	dialog;
					dialog.m_strFileName = fileMP3->strFullPathName;
					dialog.m_strSize.Format("%ld byte", fileStatus.m_size);
					if (fileStatus.m_mtime.GetTime() < 0) {
						dialog.m_strTimeStamp.Format("----/--/-- --:--:--");
					} else {
						dialog.m_strTimeStamp.Format("%04d/%02d/%02d %02d:%02d:%02d",
													 fileStatus.m_mtime.GetYear(),
													 fileStatus.m_mtime.GetMonth(),
													 fileStatus.m_mtime.GetDay(),
													 fileStatus.m_mtime.GetHour(),
													 fileStatus.m_mtime.GetMinute(),
													 fileStatus.m_mtime.GetSecond());
					}
					dialog.DoModal();
					g_nWriteTagProcFlag = dialog.m_nResult;
					switch(dialog.m_nResult) {
					case 0:				// ̃t@C㏑
					case 1:				// ȍ~Sď㏑
						break;
					case 2:				// XLbv
					case 3:				// ~
					default:
						return true;
					}
				}
				TRY {
					// ǂݎp
					SetFileAttributes(fileMP3->strFullPathName, CFile::normal);
					// ύXɑ߂邽߂ bKeepTimeStamp  true ɂ
					bKeepTimeStamp = true;
				}
				CATCH(CFileException, e) {
					CString	strMsg;
					strMsg.Format("%s I[vł܂ł", fileMP3->strFullPathName);
					MessageBox(strMsg, "ǂݎp̉G[", MB_ICONSTOP|MB_OK|MB_TOPMOST);
					return false;
				}
				END_CATCH
			}

			FILE_INFO info;
			info.pFileMP3 = fileMP3;
			result = (*callback)(&info, g_nWriteTagProcFlag, GetSafeHwnd());
			if (bKeepTimeStamp) {
				if (fileMP3->time.GetTime() != -1) {
					// t@CXVԂݒ
					fileStatus.m_mtime = fileMP3->time;
					if (g_bOptSyncCreateTime) fileStatus.m_ctime = fileMP3->time;
				}
				TRY {
					CFile::SetStatus(fileMP3->strFullPathName, fileStatus);
				}
				CATCH(CFileException, e) {
					CString	strMsg;
					strMsg.Format("%s I[vł܂ł", fileMP3->strFullPathName);
					MessageBox(strMsg, "^CX^v̍XVG[", MB_ICONSTOP|MB_OK|MB_TOPMOST);
					result = false;
				}
				END_CATCH
			} else {
				// XṼ^CX^v擾
				if (CFile::GetStatus(fileMP3->strFullPathName, fileStatus) != FALSE) {
					fileMP3->time = fileStatus.m_mtime;
				}
			}
			if (result == false) {
				// ~
				break;
			}
		}
	}

	// vOXo[I
	if (szProgressBarTitle != NULL) {
		m_pDoc->EndLoadFile();
	}

	m_pDoc->UpdateAllFiles(true);

	return true;
}


void CMySuperGrid::SelectTreeFile() /* STEP 013 */
{
	if (GetSelectedItem() < 0) return;

	CTreeItem	*pItem = GetTreeItem(GetSelectedItem());
	if (ItemHasChildren(pItem) == FALSE) {
		pItem = GetParentItem(pItem);
	}
	CArray <int, const int &> arrayList;
	int		nCount;
	int nIndex = NodeToIndex(pItem);
	if (nIndex < 0) return;
	nCount = MakeSelectFileArray(nIndex, arrayList);
	if (nCount == 0) return;
	SelItemRange(FALSE, -1, -1);
	int i; for (int i=0;i<nCount;i++) {
		nIndex++;
		SetItemState(nIndex, LVIS_SELECTED, LVIS_SELECTED);
		pItem = GetTreeItem(nIndex);
		if (ItemHasChildren(pItem) == TRUE) i--;
	}
	int iItem =GetNextItem(-1, LVNI_ALL | LVIS_FOCUSED);
	pItem = GetTreeItem(iItem);
	if (ItemHasChildren(pItem) == TRUE) {
		SetItemState(iItem+1, LVIS_FOCUSED, LVIS_FOCUSED);
	}
	OnChangeSelect();
	InvalidateSelectRangeItem();
}

void CMySuperGrid::MoveToParent() /* STEP 014 */
{
	if (GetSelectedItem() < 0) return;

	CTreeItem	*pItem = GetTreeItem(GetSelectedItem());
	pItem = GetParentItem(pItem);
	if (pItem == NULL) return;
	SelItemRange(FALSE, -1, -1);
	int nIndex = NodeToIndex(pItem);
	SetItemState(nIndex, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
	EnsureVisible(nIndex, FALSE);
	OnChangeSelect();
	InvalidateSelectRangeItem();
}

void CMySuperGrid::MoveToNext() /* STEP 014 */
{
	if (GetSelectedItem() < 0) return;

	CTreeItem	*pItem = GetTreeItem(GetSelectedItem());
	int nIndex = NodeToIndex(pItem);
	do {
		nIndex =GetNextItem(nIndex, LVNI_ALL);
		if (nIndex < 0)	break;
		pItem = GetTreeItem(nIndex);
		if (ItemHasChildren(pItem) == TRUE) {
			SelItemRange(FALSE, -1, -1);
			SetItemState(nIndex, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
			EnsureVisible(nIndex+1, FALSE);
			OnChangeSelect();
			InvalidateSelectRangeItem();
			break;
		}
	} while (1);

}

void CMySuperGrid::MoveToPrevious() /* STEP 014 */
{
	if (GetSelectedItem() < 0) return;

	CTreeItem	*pItem = GetTreeItem(GetSelectedItem());
	int nIndex = NodeToIndex(pItem);
	do {
		nIndex =GetNextItem(nIndex, LVNI_ABOVE);
		if (nIndex < 0)	break;
		pItem = GetTreeItem(nIndex);
		if (ItemHasChildren(pItem) == TRUE) {
			SelItemRange(FALSE, -1, -1);
			SetItemState(nIndex, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
			EnsureVisible(nIndex, FALSE);
			OnChangeSelect();
			InvalidateSelectRangeItem();
			break;
		}
	} while (1);

}

bool CMySuperGrid::ConvUserTag2Tag(USER_CONV_FORMAT_TAG2TAG *pForm) /* STEP 034 */
{
	if (pForm->strFormat.IsEmpty()) {
		// ϊ
		return false;					// G[
	}

	int		sx, sy, ex, ey;
	// I͈͂擾
	if (GetSelectedRange(sx, sy, ex, ey) == false) {
		return false;					// ͈͑I𖳂
	}
	for (int nItem = sy; nItem <= ey; nItem++) {
		CTreeItem	*pItem = GetTreeItem(nItem);
		if (pItem != NULL && IsItemFile(pItem) == TRUE) {
			CItemInfo	*pInfo = GetData(pItem);
			FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());

			CString strTagValue = pInfo->GetSubItem(sx-1);
			ConvTagInfo(pItem, 5, pForm->strFormat, strTagValue);
		}
	}
	return true;
}

void CMySuperGrid::OnRefreshTreeItem(CTreeItem* pOldItem, CTreeItem* pNewItem) /* STEP 037 */
{
	if (IsItemFile(pOldItem) == TRUE) {
		CItemInfo	*pInfo = GetData(pOldItem);
		FILE_MP3	*pFileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());
		pFileMP3->pTreeItem = pNewItem;
	}
}


int CMySuperGrid::GetIndexFromFileMP3(FILE_MP3 *pFileMP3) /* STEP 037 */
{
	CTreeItem* pItem = (CTreeItem*)pFileMP3->pTreeItem;
	return NodeToIndex(pItem);
}

bool CMySuperGrid::ConvSiFieldToId3tag()
{
	// IĂt@CSď
	CArray <int, const int &> arrayList;
	int		nCount;
	nCount = MakeSelectFileArray(arrayList);
	int i; for (i = 0; i < nCount; i++) {
		int		nIndex = arrayList[i];
		ConvSiFieldToId3tag(GetTreeItem(nIndex));
	}
	return(true);
}

bool CMySuperGrid::ConvSiFieldToId3tag(CTreeItem *pItem)
{
	if (pItem == NULL || IsItemFile(pItem) == FALSE) return(false);

	int		nIndex = NodeToIndex(pItem);
	CItemInfo	*pInfo = GetData(pItem);
	FILE_MP3	*fileMP3 = m_pDoc->GetListMP3((int)pInfo->GetLParam());

	// SI tB[h ID3 tag ɃRs[
	void OnConvSIFieldToID3tag(FILE_MP3* pFileMP3);
	OnConvSIFieldToID3tag(fileMP3);
	UpdateFileStatus(pItem, fileMP3);
	return(true);
}
